// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
#[non_exhaustive]
#[derive(std::fmt::Debug)]
pub enum Error {
    ActionNotFoundException(crate::error::ActionNotFoundException),
    ActionTypeNotFoundException(crate::error::ActionTypeNotFoundException),
    ApprovalAlreadyCompletedException(crate::error::ApprovalAlreadyCompletedException),
    ConcurrentModificationException(crate::error::ConcurrentModificationException),
    ConflictException(crate::error::ConflictException),
    DuplicatedStopRequestException(crate::error::DuplicatedStopRequestException),
    InvalidActionDeclarationException(crate::error::InvalidActionDeclarationException),
    InvalidApprovalTokenException(crate::error::InvalidApprovalTokenException),
    InvalidArnException(crate::error::InvalidArnException),
    InvalidBlockerDeclarationException(crate::error::InvalidBlockerDeclarationException),
    InvalidClientTokenException(crate::error::InvalidClientTokenException),
    InvalidJobException(crate::error::InvalidJobException),
    InvalidJobStateException(crate::error::InvalidJobStateException),
    InvalidNextTokenException(crate::error::InvalidNextTokenException),
    InvalidNonceException(crate::error::InvalidNonceException),
    InvalidStageDeclarationException(crate::error::InvalidStageDeclarationException),
    InvalidStructureException(crate::error::InvalidStructureException),
    InvalidTagsException(crate::error::InvalidTagsException),
    InvalidWebhookAuthenticationParametersException(
        crate::error::InvalidWebhookAuthenticationParametersException,
    ),
    InvalidWebhookFilterPatternException(crate::error::InvalidWebhookFilterPatternException),
    JobNotFoundException(crate::error::JobNotFoundException),
    LimitExceededException(crate::error::LimitExceededException),
    NotLatestPipelineExecutionException(crate::error::NotLatestPipelineExecutionException),
    OutputVariablesSizeExceededException(crate::error::OutputVariablesSizeExceededException),
    PipelineExecutionNotFoundException(crate::error::PipelineExecutionNotFoundException),
    PipelineExecutionNotStoppableException(crate::error::PipelineExecutionNotStoppableException),
    PipelineNameInUseException(crate::error::PipelineNameInUseException),
    PipelineNotFoundException(crate::error::PipelineNotFoundException),
    PipelineVersionNotFoundException(crate::error::PipelineVersionNotFoundException),
    RequestFailedException(crate::error::RequestFailedException),
    ResourceNotFoundException(crate::error::ResourceNotFoundException),
    StageNotFoundException(crate::error::StageNotFoundException),
    StageNotRetryableException(crate::error::StageNotRetryableException),
    TooManyTagsException(crate::error::TooManyTagsException),
    ValidationException(crate::error::ValidationException),
    WebhookNotFoundException(crate::error::WebhookNotFoundException),
    Unhandled(Box<dyn std::error::Error + Send + Sync + 'static>),
}
impl std::fmt::Display for Error {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        match self {
            Error::ActionNotFoundException(inner) => inner.fmt(f),
            Error::ActionTypeNotFoundException(inner) => inner.fmt(f),
            Error::ApprovalAlreadyCompletedException(inner) => inner.fmt(f),
            Error::ConcurrentModificationException(inner) => inner.fmt(f),
            Error::ConflictException(inner) => inner.fmt(f),
            Error::DuplicatedStopRequestException(inner) => inner.fmt(f),
            Error::InvalidActionDeclarationException(inner) => inner.fmt(f),
            Error::InvalidApprovalTokenException(inner) => inner.fmt(f),
            Error::InvalidArnException(inner) => inner.fmt(f),
            Error::InvalidBlockerDeclarationException(inner) => inner.fmt(f),
            Error::InvalidClientTokenException(inner) => inner.fmt(f),
            Error::InvalidJobException(inner) => inner.fmt(f),
            Error::InvalidJobStateException(inner) => inner.fmt(f),
            Error::InvalidNextTokenException(inner) => inner.fmt(f),
            Error::InvalidNonceException(inner) => inner.fmt(f),
            Error::InvalidStageDeclarationException(inner) => inner.fmt(f),
            Error::InvalidStructureException(inner) => inner.fmt(f),
            Error::InvalidTagsException(inner) => inner.fmt(f),
            Error::InvalidWebhookAuthenticationParametersException(inner) => inner.fmt(f),
            Error::InvalidWebhookFilterPatternException(inner) => inner.fmt(f),
            Error::JobNotFoundException(inner) => inner.fmt(f),
            Error::LimitExceededException(inner) => inner.fmt(f),
            Error::NotLatestPipelineExecutionException(inner) => inner.fmt(f),
            Error::OutputVariablesSizeExceededException(inner) => inner.fmt(f),
            Error::PipelineExecutionNotFoundException(inner) => inner.fmt(f),
            Error::PipelineExecutionNotStoppableException(inner) => inner.fmt(f),
            Error::PipelineNameInUseException(inner) => inner.fmt(f),
            Error::PipelineNotFoundException(inner) => inner.fmt(f),
            Error::PipelineVersionNotFoundException(inner) => inner.fmt(f),
            Error::RequestFailedException(inner) => inner.fmt(f),
            Error::ResourceNotFoundException(inner) => inner.fmt(f),
            Error::StageNotFoundException(inner) => inner.fmt(f),
            Error::StageNotRetryableException(inner) => inner.fmt(f),
            Error::TooManyTagsException(inner) => inner.fmt(f),
            Error::ValidationException(inner) => inner.fmt(f),
            Error::WebhookNotFoundException(inner) => inner.fmt(f),
            Error::Unhandled(inner) => inner.fmt(f),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::AcknowledgeJobError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::AcknowledgeJobError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::AcknowledgeJobErrorKind::InvalidNonceException(inner) => {
                    Error::InvalidNonceException(inner)
                }
                crate::error::AcknowledgeJobErrorKind::JobNotFoundException(inner) => {
                    Error::JobNotFoundException(inner)
                }
                crate::error::AcknowledgeJobErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::AcknowledgeJobErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::AcknowledgeThirdPartyJobError>> for Error {
    fn from(
        err: smithy_http::result::SdkError<crate::error::AcknowledgeThirdPartyJobError>,
    ) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::AcknowledgeThirdPartyJobErrorKind::InvalidClientTokenException(
                    inner,
                ) => Error::InvalidClientTokenException(inner),
                crate::error::AcknowledgeThirdPartyJobErrorKind::InvalidNonceException(inner) => {
                    Error::InvalidNonceException(inner)
                }
                crate::error::AcknowledgeThirdPartyJobErrorKind::JobNotFoundException(inner) => {
                    Error::JobNotFoundException(inner)
                }
                crate::error::AcknowledgeThirdPartyJobErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::AcknowledgeThirdPartyJobErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::CreateCustomActionTypeError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::CreateCustomActionTypeError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::CreateCustomActionTypeErrorKind::ConcurrentModificationException(
                    inner,
                ) => Error::ConcurrentModificationException(inner),
                crate::error::CreateCustomActionTypeErrorKind::InvalidTagsException(inner) => {
                    Error::InvalidTagsException(inner)
                }
                crate::error::CreateCustomActionTypeErrorKind::LimitExceededException(inner) => {
                    Error::LimitExceededException(inner)
                }
                crate::error::CreateCustomActionTypeErrorKind::TooManyTagsException(inner) => {
                    Error::TooManyTagsException(inner)
                }
                crate::error::CreateCustomActionTypeErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::CreateCustomActionTypeErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::CreatePipelineError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::CreatePipelineError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::CreatePipelineErrorKind::ConcurrentModificationException(inner) => {
                    Error::ConcurrentModificationException(inner)
                }
                crate::error::CreatePipelineErrorKind::InvalidActionDeclarationException(inner) => {
                    Error::InvalidActionDeclarationException(inner)
                }
                crate::error::CreatePipelineErrorKind::InvalidBlockerDeclarationException(
                    inner,
                ) => Error::InvalidBlockerDeclarationException(inner),
                crate::error::CreatePipelineErrorKind::InvalidStageDeclarationException(inner) => {
                    Error::InvalidStageDeclarationException(inner)
                }
                crate::error::CreatePipelineErrorKind::InvalidStructureException(inner) => {
                    Error::InvalidStructureException(inner)
                }
                crate::error::CreatePipelineErrorKind::InvalidTagsException(inner) => {
                    Error::InvalidTagsException(inner)
                }
                crate::error::CreatePipelineErrorKind::LimitExceededException(inner) => {
                    Error::LimitExceededException(inner)
                }
                crate::error::CreatePipelineErrorKind::PipelineNameInUseException(inner) => {
                    Error::PipelineNameInUseException(inner)
                }
                crate::error::CreatePipelineErrorKind::TooManyTagsException(inner) => {
                    Error::TooManyTagsException(inner)
                }
                crate::error::CreatePipelineErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::CreatePipelineErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::DeleteCustomActionTypeError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::DeleteCustomActionTypeError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::DeleteCustomActionTypeErrorKind::ConcurrentModificationException(
                    inner,
                ) => Error::ConcurrentModificationException(inner),
                crate::error::DeleteCustomActionTypeErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::DeleteCustomActionTypeErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::DeletePipelineError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::DeletePipelineError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::DeletePipelineErrorKind::ConcurrentModificationException(inner) => {
                    Error::ConcurrentModificationException(inner)
                }
                crate::error::DeletePipelineErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::DeletePipelineErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::DeleteWebhookError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::DeleteWebhookError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::DeleteWebhookErrorKind::ConcurrentModificationException(inner) => {
                    Error::ConcurrentModificationException(inner)
                }
                crate::error::DeleteWebhookErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::DeleteWebhookErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::DeregisterWebhookWithThirdPartyError>>
    for Error
{
    fn from(
        err: smithy_http::result::SdkError<crate::error::DeregisterWebhookWithThirdPartyError>,
    ) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, ..} => match err.kind {
                crate::error::DeregisterWebhookWithThirdPartyErrorKind::ValidationException(inner) => Error::ValidationException(inner),
                crate::error::DeregisterWebhookWithThirdPartyErrorKind::WebhookNotFoundException(inner) => Error::WebhookNotFoundException(inner),
                crate::error::DeregisterWebhookWithThirdPartyErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            }
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::DisableStageTransitionError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::DisableStageTransitionError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::DisableStageTransitionErrorKind::PipelineNotFoundException(inner) => {
                    Error::PipelineNotFoundException(inner)
                }
                crate::error::DisableStageTransitionErrorKind::StageNotFoundException(inner) => {
                    Error::StageNotFoundException(inner)
                }
                crate::error::DisableStageTransitionErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::DisableStageTransitionErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::EnableStageTransitionError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::EnableStageTransitionError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::EnableStageTransitionErrorKind::PipelineNotFoundException(inner) => {
                    Error::PipelineNotFoundException(inner)
                }
                crate::error::EnableStageTransitionErrorKind::StageNotFoundException(inner) => {
                    Error::StageNotFoundException(inner)
                }
                crate::error::EnableStageTransitionErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::EnableStageTransitionErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::GetActionTypeError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::GetActionTypeError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::GetActionTypeErrorKind::ActionTypeNotFoundException(inner) => {
                    Error::ActionTypeNotFoundException(inner)
                }
                crate::error::GetActionTypeErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::GetActionTypeErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::GetJobDetailsError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::GetJobDetailsError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::GetJobDetailsErrorKind::JobNotFoundException(inner) => {
                    Error::JobNotFoundException(inner)
                }
                crate::error::GetJobDetailsErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::GetJobDetailsErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::GetPipelineError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::GetPipelineError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::GetPipelineErrorKind::PipelineNotFoundException(inner) => {
                    Error::PipelineNotFoundException(inner)
                }
                crate::error::GetPipelineErrorKind::PipelineVersionNotFoundException(inner) => {
                    Error::PipelineVersionNotFoundException(inner)
                }
                crate::error::GetPipelineErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::GetPipelineErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::GetPipelineExecutionError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::GetPipelineExecutionError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::GetPipelineExecutionErrorKind::PipelineExecutionNotFoundException(
                    inner,
                ) => Error::PipelineExecutionNotFoundException(inner),
                crate::error::GetPipelineExecutionErrorKind::PipelineNotFoundException(inner) => {
                    Error::PipelineNotFoundException(inner)
                }
                crate::error::GetPipelineExecutionErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::GetPipelineExecutionErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::GetPipelineStateError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::GetPipelineStateError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::GetPipelineStateErrorKind::PipelineNotFoundException(inner) => {
                    Error::PipelineNotFoundException(inner)
                }
                crate::error::GetPipelineStateErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::GetPipelineStateErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::GetThirdPartyJobDetailsError>> for Error {
    fn from(
        err: smithy_http::result::SdkError<crate::error::GetThirdPartyJobDetailsError>,
    ) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::GetThirdPartyJobDetailsErrorKind::InvalidClientTokenException(
                    inner,
                ) => Error::InvalidClientTokenException(inner),
                crate::error::GetThirdPartyJobDetailsErrorKind::InvalidJobException(inner) => {
                    Error::InvalidJobException(inner)
                }
                crate::error::GetThirdPartyJobDetailsErrorKind::JobNotFoundException(inner) => {
                    Error::JobNotFoundException(inner)
                }
                crate::error::GetThirdPartyJobDetailsErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::GetThirdPartyJobDetailsErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::ListActionExecutionsError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::ListActionExecutionsError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::ListActionExecutionsErrorKind::InvalidNextTokenException(inner) => {
                    Error::InvalidNextTokenException(inner)
                }
                crate::error::ListActionExecutionsErrorKind::PipelineExecutionNotFoundException(
                    inner,
                ) => Error::PipelineExecutionNotFoundException(inner),
                crate::error::ListActionExecutionsErrorKind::PipelineNotFoundException(inner) => {
                    Error::PipelineNotFoundException(inner)
                }
                crate::error::ListActionExecutionsErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::ListActionExecutionsErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::ListActionTypesError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::ListActionTypesError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::ListActionTypesErrorKind::InvalidNextTokenException(inner) => {
                    Error::InvalidNextTokenException(inner)
                }
                crate::error::ListActionTypesErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::ListActionTypesErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::ListPipelineExecutionsError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::ListPipelineExecutionsError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::ListPipelineExecutionsErrorKind::InvalidNextTokenException(inner) => {
                    Error::InvalidNextTokenException(inner)
                }
                crate::error::ListPipelineExecutionsErrorKind::PipelineNotFoundException(inner) => {
                    Error::PipelineNotFoundException(inner)
                }
                crate::error::ListPipelineExecutionsErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::ListPipelineExecutionsErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::ListPipelinesError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::ListPipelinesError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::ListPipelinesErrorKind::InvalidNextTokenException(inner) => {
                    Error::InvalidNextTokenException(inner)
                }
                crate::error::ListPipelinesErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::ListPipelinesErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::ListTagsForResourceError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::ListTagsForResourceError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::ListTagsForResourceErrorKind::InvalidArnException(inner) => {
                    Error::InvalidArnException(inner)
                }
                crate::error::ListTagsForResourceErrorKind::InvalidNextTokenException(inner) => {
                    Error::InvalidNextTokenException(inner)
                }
                crate::error::ListTagsForResourceErrorKind::ResourceNotFoundException(inner) => {
                    Error::ResourceNotFoundException(inner)
                }
                crate::error::ListTagsForResourceErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::ListTagsForResourceErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::ListWebhooksError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::ListWebhooksError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::ListWebhooksErrorKind::InvalidNextTokenException(inner) => {
                    Error::InvalidNextTokenException(inner)
                }
                crate::error::ListWebhooksErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::ListWebhooksErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::PollForJobsError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::PollForJobsError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::PollForJobsErrorKind::ActionTypeNotFoundException(inner) => {
                    Error::ActionTypeNotFoundException(inner)
                }
                crate::error::PollForJobsErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::PollForJobsErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::PollForThirdPartyJobsError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::PollForThirdPartyJobsError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::PollForThirdPartyJobsErrorKind::ActionTypeNotFoundException(
                    inner,
                ) => Error::ActionTypeNotFoundException(inner),
                crate::error::PollForThirdPartyJobsErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::PollForThirdPartyJobsErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::PutActionRevisionError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::PutActionRevisionError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::PutActionRevisionErrorKind::ActionNotFoundException(inner) => {
                    Error::ActionNotFoundException(inner)
                }
                crate::error::PutActionRevisionErrorKind::PipelineNotFoundException(inner) => {
                    Error::PipelineNotFoundException(inner)
                }
                crate::error::PutActionRevisionErrorKind::StageNotFoundException(inner) => {
                    Error::StageNotFoundException(inner)
                }
                crate::error::PutActionRevisionErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::PutActionRevisionErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::PutApprovalResultError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::PutApprovalResultError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::PutApprovalResultErrorKind::ActionNotFoundException(inner) => {
                    Error::ActionNotFoundException(inner)
                }
                crate::error::PutApprovalResultErrorKind::ApprovalAlreadyCompletedException(
                    inner,
                ) => Error::ApprovalAlreadyCompletedException(inner),
                crate::error::PutApprovalResultErrorKind::InvalidApprovalTokenException(inner) => {
                    Error::InvalidApprovalTokenException(inner)
                }
                crate::error::PutApprovalResultErrorKind::PipelineNotFoundException(inner) => {
                    Error::PipelineNotFoundException(inner)
                }
                crate::error::PutApprovalResultErrorKind::StageNotFoundException(inner) => {
                    Error::StageNotFoundException(inner)
                }
                crate::error::PutApprovalResultErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::PutApprovalResultErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::PutJobFailureResultError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::PutJobFailureResultError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::PutJobFailureResultErrorKind::InvalidJobStateException(inner) => {
                    Error::InvalidJobStateException(inner)
                }
                crate::error::PutJobFailureResultErrorKind::JobNotFoundException(inner) => {
                    Error::JobNotFoundException(inner)
                }
                crate::error::PutJobFailureResultErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::PutJobFailureResultErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::PutJobSuccessResultError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::PutJobSuccessResultError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, ..} => match err.kind {
                crate::error::PutJobSuccessResultErrorKind::InvalidJobStateException(inner) => Error::InvalidJobStateException(inner),
                crate::error::PutJobSuccessResultErrorKind::JobNotFoundException(inner) => Error::JobNotFoundException(inner),
                crate::error::PutJobSuccessResultErrorKind::OutputVariablesSizeExceededException(inner) => Error::OutputVariablesSizeExceededException(inner),
                crate::error::PutJobSuccessResultErrorKind::ValidationException(inner) => Error::ValidationException(inner),
                crate::error::PutJobSuccessResultErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            }
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::PutThirdPartyJobFailureResultError>>
    for Error
{
    fn from(
        err: smithy_http::result::SdkError<crate::error::PutThirdPartyJobFailureResultError>,
    ) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, ..} => match err.kind {
                crate::error::PutThirdPartyJobFailureResultErrorKind::InvalidClientTokenException(inner) => Error::InvalidClientTokenException(inner),
                crate::error::PutThirdPartyJobFailureResultErrorKind::InvalidJobStateException(inner) => Error::InvalidJobStateException(inner),
                crate::error::PutThirdPartyJobFailureResultErrorKind::JobNotFoundException(inner) => Error::JobNotFoundException(inner),
                crate::error::PutThirdPartyJobFailureResultErrorKind::ValidationException(inner) => Error::ValidationException(inner),
                crate::error::PutThirdPartyJobFailureResultErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            }
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::PutThirdPartyJobSuccessResultError>>
    for Error
{
    fn from(
        err: smithy_http::result::SdkError<crate::error::PutThirdPartyJobSuccessResultError>,
    ) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, ..} => match err.kind {
                crate::error::PutThirdPartyJobSuccessResultErrorKind::InvalidClientTokenException(inner) => Error::InvalidClientTokenException(inner),
                crate::error::PutThirdPartyJobSuccessResultErrorKind::InvalidJobStateException(inner) => Error::InvalidJobStateException(inner),
                crate::error::PutThirdPartyJobSuccessResultErrorKind::JobNotFoundException(inner) => Error::JobNotFoundException(inner),
                crate::error::PutThirdPartyJobSuccessResultErrorKind::ValidationException(inner) => Error::ValidationException(inner),
                crate::error::PutThirdPartyJobSuccessResultErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            }
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::PutWebhookError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::PutWebhookError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, ..} => match err.kind {
                crate::error::PutWebhookErrorKind::ConcurrentModificationException(inner) => Error::ConcurrentModificationException(inner),
                crate::error::PutWebhookErrorKind::InvalidTagsException(inner) => Error::InvalidTagsException(inner),
                crate::error::PutWebhookErrorKind::InvalidWebhookAuthenticationParametersException(inner) => Error::InvalidWebhookAuthenticationParametersException(inner),
                crate::error::PutWebhookErrorKind::InvalidWebhookFilterPatternException(inner) => Error::InvalidWebhookFilterPatternException(inner),
                crate::error::PutWebhookErrorKind::LimitExceededException(inner) => Error::LimitExceededException(inner),
                crate::error::PutWebhookErrorKind::PipelineNotFoundException(inner) => Error::PipelineNotFoundException(inner),
                crate::error::PutWebhookErrorKind::TooManyTagsException(inner) => Error::TooManyTagsException(inner),
                crate::error::PutWebhookErrorKind::ValidationException(inner) => Error::ValidationException(inner),
                crate::error::PutWebhookErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            }
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::RegisterWebhookWithThirdPartyError>>
    for Error
{
    fn from(
        err: smithy_http::result::SdkError<crate::error::RegisterWebhookWithThirdPartyError>,
    ) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::RegisterWebhookWithThirdPartyErrorKind::ValidationException(
                    inner,
                ) => Error::ValidationException(inner),
                crate::error::RegisterWebhookWithThirdPartyErrorKind::WebhookNotFoundException(
                    inner,
                ) => Error::WebhookNotFoundException(inner),
                crate::error::RegisterWebhookWithThirdPartyErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::RetryStageExecutionError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::RetryStageExecutionError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::RetryStageExecutionErrorKind::ConflictException(inner) => {
                    Error::ConflictException(inner)
                }
                crate::error::RetryStageExecutionErrorKind::NotLatestPipelineExecutionException(
                    inner,
                ) => Error::NotLatestPipelineExecutionException(inner),
                crate::error::RetryStageExecutionErrorKind::PipelineNotFoundException(inner) => {
                    Error::PipelineNotFoundException(inner)
                }
                crate::error::RetryStageExecutionErrorKind::StageNotFoundException(inner) => {
                    Error::StageNotFoundException(inner)
                }
                crate::error::RetryStageExecutionErrorKind::StageNotRetryableException(inner) => {
                    Error::StageNotRetryableException(inner)
                }
                crate::error::RetryStageExecutionErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::RetryStageExecutionErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::StartPipelineExecutionError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::StartPipelineExecutionError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::StartPipelineExecutionErrorKind::ConflictException(inner) => {
                    Error::ConflictException(inner)
                }
                crate::error::StartPipelineExecutionErrorKind::PipelineNotFoundException(inner) => {
                    Error::PipelineNotFoundException(inner)
                }
                crate::error::StartPipelineExecutionErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::StartPipelineExecutionErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::StopPipelineExecutionError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::StopPipelineExecutionError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, ..} => match err.kind {
                crate::error::StopPipelineExecutionErrorKind::ConflictException(inner) => Error::ConflictException(inner),
                crate::error::StopPipelineExecutionErrorKind::DuplicatedStopRequestException(inner) => Error::DuplicatedStopRequestException(inner),
                crate::error::StopPipelineExecutionErrorKind::PipelineExecutionNotStoppableException(inner) => Error::PipelineExecutionNotStoppableException(inner),
                crate::error::StopPipelineExecutionErrorKind::PipelineNotFoundException(inner) => Error::PipelineNotFoundException(inner),
                crate::error::StopPipelineExecutionErrorKind::ValidationException(inner) => Error::ValidationException(inner),
                crate::error::StopPipelineExecutionErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            }
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::TagResourceError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::TagResourceError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::TagResourceErrorKind::ConcurrentModificationException(inner) => {
                    Error::ConcurrentModificationException(inner)
                }
                crate::error::TagResourceErrorKind::InvalidArnException(inner) => {
                    Error::InvalidArnException(inner)
                }
                crate::error::TagResourceErrorKind::InvalidTagsException(inner) => {
                    Error::InvalidTagsException(inner)
                }
                crate::error::TagResourceErrorKind::ResourceNotFoundException(inner) => {
                    Error::ResourceNotFoundException(inner)
                }
                crate::error::TagResourceErrorKind::TooManyTagsException(inner) => {
                    Error::TooManyTagsException(inner)
                }
                crate::error::TagResourceErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::TagResourceErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::UntagResourceError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::UntagResourceError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::UntagResourceErrorKind::ConcurrentModificationException(inner) => {
                    Error::ConcurrentModificationException(inner)
                }
                crate::error::UntagResourceErrorKind::InvalidArnException(inner) => {
                    Error::InvalidArnException(inner)
                }
                crate::error::UntagResourceErrorKind::InvalidTagsException(inner) => {
                    Error::InvalidTagsException(inner)
                }
                crate::error::UntagResourceErrorKind::ResourceNotFoundException(inner) => {
                    Error::ResourceNotFoundException(inner)
                }
                crate::error::UntagResourceErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::UntagResourceErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::UpdateActionTypeError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::UpdateActionTypeError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::UpdateActionTypeErrorKind::ActionTypeNotFoundException(inner) => {
                    Error::ActionTypeNotFoundException(inner)
                }
                crate::error::UpdateActionTypeErrorKind::RequestFailedException(inner) => {
                    Error::RequestFailedException(inner)
                }
                crate::error::UpdateActionTypeErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::UpdateActionTypeErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::UpdatePipelineError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::UpdatePipelineError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::UpdatePipelineErrorKind::InvalidActionDeclarationException(inner) => {
                    Error::InvalidActionDeclarationException(inner)
                }
                crate::error::UpdatePipelineErrorKind::InvalidBlockerDeclarationException(
                    inner,
                ) => Error::InvalidBlockerDeclarationException(inner),
                crate::error::UpdatePipelineErrorKind::InvalidStageDeclarationException(inner) => {
                    Error::InvalidStageDeclarationException(inner)
                }
                crate::error::UpdatePipelineErrorKind::InvalidStructureException(inner) => {
                    Error::InvalidStructureException(inner)
                }
                crate::error::UpdatePipelineErrorKind::LimitExceededException(inner) => {
                    Error::LimitExceededException(inner)
                }
                crate::error::UpdatePipelineErrorKind::ValidationException(inner) => {
                    Error::ValidationException(inner)
                }
                crate::error::UpdatePipelineErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl std::error::Error for Error {}
