// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
#[derive(std::fmt::Debug)]
pub(crate) struct Handle<C = aws_hyper::DynConnector> {
    client: aws_hyper::Client<C>,
    conf: crate::Config,
}

#[derive(Clone, std::fmt::Debug)]
pub struct Client<C = aws_hyper::DynConnector> {
    handle: std::sync::Arc<Handle<C>>,
}
impl<C> Client<C> {
    pub fn from_conf_conn(conf: crate::Config, conn: C) -> Self {
        let client = aws_hyper::Client::new(conn);
        Self {
            handle: std::sync::Arc::new(Handle { client, conf }),
        }
    }

    pub fn conf(&self) -> &crate::Config {
        &self.handle.conf
    }
}
impl Client {
    #[cfg(any(feature = "rustls", feature = "native-tls"))]
    pub fn from_env() -> Self {
        Self::from_conf(crate::Config::builder().build())
    }

    #[cfg(any(feature = "rustls", feature = "native-tls"))]
    pub fn from_conf(conf: crate::Config) -> Self {
        let client = aws_hyper::Client::https();
        Self {
            handle: std::sync::Arc::new(Handle { client, conf }),
        }
    }
}
impl<C> Client<C>
where
    C: aws_hyper::SmithyConnector,
{
    pub fn create_bot_version(&self) -> fluent_builders::CreateBotVersion<C> {
        fluent_builders::CreateBotVersion::new(self.handle.clone())
    }
    pub fn create_intent_version(&self) -> fluent_builders::CreateIntentVersion<C> {
        fluent_builders::CreateIntentVersion::new(self.handle.clone())
    }
    pub fn create_slot_type_version(&self) -> fluent_builders::CreateSlotTypeVersion<C> {
        fluent_builders::CreateSlotTypeVersion::new(self.handle.clone())
    }
    pub fn delete_bot(&self) -> fluent_builders::DeleteBot<C> {
        fluent_builders::DeleteBot::new(self.handle.clone())
    }
    pub fn delete_bot_alias(&self) -> fluent_builders::DeleteBotAlias<C> {
        fluent_builders::DeleteBotAlias::new(self.handle.clone())
    }
    pub fn delete_bot_channel_association(
        &self,
    ) -> fluent_builders::DeleteBotChannelAssociation<C> {
        fluent_builders::DeleteBotChannelAssociation::new(self.handle.clone())
    }
    pub fn delete_bot_version(&self) -> fluent_builders::DeleteBotVersion<C> {
        fluent_builders::DeleteBotVersion::new(self.handle.clone())
    }
    pub fn delete_intent(&self) -> fluent_builders::DeleteIntent<C> {
        fluent_builders::DeleteIntent::new(self.handle.clone())
    }
    pub fn delete_intent_version(&self) -> fluent_builders::DeleteIntentVersion<C> {
        fluent_builders::DeleteIntentVersion::new(self.handle.clone())
    }
    pub fn delete_slot_type(&self) -> fluent_builders::DeleteSlotType<C> {
        fluent_builders::DeleteSlotType::new(self.handle.clone())
    }
    pub fn delete_slot_type_version(&self) -> fluent_builders::DeleteSlotTypeVersion<C> {
        fluent_builders::DeleteSlotTypeVersion::new(self.handle.clone())
    }
    pub fn delete_utterances(&self) -> fluent_builders::DeleteUtterances<C> {
        fluent_builders::DeleteUtterances::new(self.handle.clone())
    }
    pub fn get_bot(&self) -> fluent_builders::GetBot<C> {
        fluent_builders::GetBot::new(self.handle.clone())
    }
    pub fn get_bot_alias(&self) -> fluent_builders::GetBotAlias<C> {
        fluent_builders::GetBotAlias::new(self.handle.clone())
    }
    pub fn get_bot_aliases(&self) -> fluent_builders::GetBotAliases<C> {
        fluent_builders::GetBotAliases::new(self.handle.clone())
    }
    pub fn get_bot_channel_association(&self) -> fluent_builders::GetBotChannelAssociation<C> {
        fluent_builders::GetBotChannelAssociation::new(self.handle.clone())
    }
    pub fn get_bot_channel_associations(&self) -> fluent_builders::GetBotChannelAssociations<C> {
        fluent_builders::GetBotChannelAssociations::new(self.handle.clone())
    }
    pub fn get_bots(&self) -> fluent_builders::GetBots<C> {
        fluent_builders::GetBots::new(self.handle.clone())
    }
    pub fn get_bot_versions(&self) -> fluent_builders::GetBotVersions<C> {
        fluent_builders::GetBotVersions::new(self.handle.clone())
    }
    pub fn get_builtin_intent(&self) -> fluent_builders::GetBuiltinIntent<C> {
        fluent_builders::GetBuiltinIntent::new(self.handle.clone())
    }
    pub fn get_builtin_intents(&self) -> fluent_builders::GetBuiltinIntents<C> {
        fluent_builders::GetBuiltinIntents::new(self.handle.clone())
    }
    pub fn get_builtin_slot_types(&self) -> fluent_builders::GetBuiltinSlotTypes<C> {
        fluent_builders::GetBuiltinSlotTypes::new(self.handle.clone())
    }
    pub fn get_export(&self) -> fluent_builders::GetExport<C> {
        fluent_builders::GetExport::new(self.handle.clone())
    }
    pub fn get_import(&self) -> fluent_builders::GetImport<C> {
        fluent_builders::GetImport::new(self.handle.clone())
    }
    pub fn get_intent(&self) -> fluent_builders::GetIntent<C> {
        fluent_builders::GetIntent::new(self.handle.clone())
    }
    pub fn get_intents(&self) -> fluent_builders::GetIntents<C> {
        fluent_builders::GetIntents::new(self.handle.clone())
    }
    pub fn get_intent_versions(&self) -> fluent_builders::GetIntentVersions<C> {
        fluent_builders::GetIntentVersions::new(self.handle.clone())
    }
    pub fn get_migration(&self) -> fluent_builders::GetMigration<C> {
        fluent_builders::GetMigration::new(self.handle.clone())
    }
    pub fn get_migrations(&self) -> fluent_builders::GetMigrations<C> {
        fluent_builders::GetMigrations::new(self.handle.clone())
    }
    pub fn get_slot_type(&self) -> fluent_builders::GetSlotType<C> {
        fluent_builders::GetSlotType::new(self.handle.clone())
    }
    pub fn get_slot_types(&self) -> fluent_builders::GetSlotTypes<C> {
        fluent_builders::GetSlotTypes::new(self.handle.clone())
    }
    pub fn get_slot_type_versions(&self) -> fluent_builders::GetSlotTypeVersions<C> {
        fluent_builders::GetSlotTypeVersions::new(self.handle.clone())
    }
    pub fn get_utterances_view(&self) -> fluent_builders::GetUtterancesView<C> {
        fluent_builders::GetUtterancesView::new(self.handle.clone())
    }
    pub fn list_tags_for_resource(&self) -> fluent_builders::ListTagsForResource<C> {
        fluent_builders::ListTagsForResource::new(self.handle.clone())
    }
    pub fn put_bot(&self) -> fluent_builders::PutBot<C> {
        fluent_builders::PutBot::new(self.handle.clone())
    }
    pub fn put_bot_alias(&self) -> fluent_builders::PutBotAlias<C> {
        fluent_builders::PutBotAlias::new(self.handle.clone())
    }
    pub fn put_intent(&self) -> fluent_builders::PutIntent<C> {
        fluent_builders::PutIntent::new(self.handle.clone())
    }
    pub fn put_slot_type(&self) -> fluent_builders::PutSlotType<C> {
        fluent_builders::PutSlotType::new(self.handle.clone())
    }
    pub fn start_import(&self) -> fluent_builders::StartImport<C> {
        fluent_builders::StartImport::new(self.handle.clone())
    }
    pub fn start_migration(&self) -> fluent_builders::StartMigration<C> {
        fluent_builders::StartMigration::new(self.handle.clone())
    }
    pub fn tag_resource(&self) -> fluent_builders::TagResource<C> {
        fluent_builders::TagResource::new(self.handle.clone())
    }
    pub fn untag_resource(&self) -> fluent_builders::UntagResource<C> {
        fluent_builders::UntagResource::new(self.handle.clone())
    }
}
pub mod fluent_builders {
    #[derive(std::fmt::Debug)]
    pub struct CreateBotVersion<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::create_bot_version_input::Builder,
    }
    impl<C> CreateBotVersion<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::CreateBotVersionOutput,
            smithy_http::result::SdkError<crate::error::CreateBotVersionError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the bot that you want to create a new version of. The
        /// name is case sensitive. </p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>Identifies a specific revision of the <code>$LATEST</code> version
        /// of the bot. If you specify a checksum and the <code>$LATEST</code> version
        /// of the bot has a different checksum, a
        /// <code>PreconditionFailedException</code> exception is returned and Amazon Lex
        /// doesn't publish a new version. If you don't specify a checksum, Amazon Lex
        /// publishes the <code>$LATEST</code> version.</p>
        pub fn checksum(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.checksum(input);
            self
        }
        pub fn set_checksum(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_checksum(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct CreateIntentVersion<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::create_intent_version_input::Builder,
    }
    impl<C> CreateIntentVersion<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::CreateIntentVersionOutput,
            smithy_http::result::SdkError<crate::error::CreateIntentVersionError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the intent that you want to create a new version of.
        /// The name is case sensitive. </p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>Checksum of the <code>$LATEST</code> version of the intent that
        /// should be used to create the new version. If you specify a checksum and
        /// the <code>$LATEST</code> version of the intent has a different checksum,
        /// Amazon Lex returns a <code>PreconditionFailedException</code> exception and
        /// doesn't publish a new version. If you don't specify a checksum, Amazon Lex
        /// publishes the <code>$LATEST</code> version.</p>
        pub fn checksum(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.checksum(input);
            self
        }
        pub fn set_checksum(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_checksum(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct CreateSlotTypeVersion<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::create_slot_type_version_input::Builder,
    }
    impl<C> CreateSlotTypeVersion<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::CreateSlotTypeVersionOutput,
            smithy_http::result::SdkError<crate::error::CreateSlotTypeVersionError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the slot type that you want to create a new version
        /// for. The name is case sensitive. </p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>Checksum for the <code>$LATEST</code> version of the slot type that
        /// you want to publish. If you specify a checksum and the
        /// <code>$LATEST</code> version of the slot type has a different checksum,
        /// Amazon Lex returns a <code>PreconditionFailedException</code> exception and
        /// doesn't publish the new version. If you don't specify a checksum, Amazon Lex
        /// publishes the <code>$LATEST</code> version.</p>
        pub fn checksum(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.checksum(input);
            self
        }
        pub fn set_checksum(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_checksum(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteBot<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_bot_input::Builder,
    }
    impl<C> DeleteBot<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteBotOutput,
            smithy_http::result::SdkError<crate::error::DeleteBotError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the bot. The name is case sensitive. </p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteBotAlias<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_bot_alias_input::Builder,
    }
    impl<C> DeleteBotAlias<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteBotAliasOutput,
            smithy_http::result::SdkError<crate::error::DeleteBotAliasError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the alias to delete. The name is case sensitive.
        /// </p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>The name of the bot that the alias points to.</p>
        pub fn bot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.bot_name(input);
            self
        }
        pub fn set_bot_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_bot_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteBotChannelAssociation<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_bot_channel_association_input::Builder,
    }
    impl<C> DeleteBotChannelAssociation<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteBotChannelAssociationOutput,
            smithy_http::result::SdkError<crate::error::DeleteBotChannelAssociationError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the association. The name is case sensitive. </p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>The name of the Amazon Lex bot.</p>
        pub fn bot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.bot_name(input);
            self
        }
        pub fn set_bot_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_bot_name(input);
            self
        }
        /// <p>An alias that points to the specific version of the Amazon Lex bot to
        /// which this association is being made.</p>
        pub fn bot_alias(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.bot_alias(input);
            self
        }
        pub fn set_bot_alias(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_bot_alias(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteBotVersion<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_bot_version_input::Builder,
    }
    impl<C> DeleteBotVersion<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteBotVersionOutput,
            smithy_http::result::SdkError<crate::error::DeleteBotVersionError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the bot.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>The version of the bot to delete. You cannot delete the
        /// <code>$LATEST</code> version of the bot. To delete the
        /// <code>$LATEST</code> version, use the <a>DeleteBot</a>
        /// operation.</p>
        pub fn version(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.version(input);
            self
        }
        pub fn set_version(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_version(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteIntent<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_intent_input::Builder,
    }
    impl<C> DeleteIntent<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteIntentOutput,
            smithy_http::result::SdkError<crate::error::DeleteIntentError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the intent. The name is case sensitive. </p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteIntentVersion<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_intent_version_input::Builder,
    }
    impl<C> DeleteIntentVersion<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteIntentVersionOutput,
            smithy_http::result::SdkError<crate::error::DeleteIntentVersionError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the intent.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>The version of the intent to delete. You cannot delete the
        /// <code>$LATEST</code> version of the intent. To delete the
        /// <code>$LATEST</code> version, use the <a>DeleteIntent</a>
        /// operation.</p>
        pub fn version(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.version(input);
            self
        }
        pub fn set_version(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_version(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteSlotType<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_slot_type_input::Builder,
    }
    impl<C> DeleteSlotType<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteSlotTypeOutput,
            smithy_http::result::SdkError<crate::error::DeleteSlotTypeError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the slot type. The name is case sensitive. </p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteSlotTypeVersion<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_slot_type_version_input::Builder,
    }
    impl<C> DeleteSlotTypeVersion<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteSlotTypeVersionOutput,
            smithy_http::result::SdkError<crate::error::DeleteSlotTypeVersionError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the slot type.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>The version of the slot type to delete. You cannot delete the
        /// <code>$LATEST</code> version of the slot type. To delete the
        /// <code>$LATEST</code> version, use the <a>DeleteSlotType</a>
        /// operation.</p>
        pub fn version(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.version(input);
            self
        }
        pub fn set_version(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_version(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteUtterances<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_utterances_input::Builder,
    }
    impl<C> DeleteUtterances<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteUtterancesOutput,
            smithy_http::result::SdkError<crate::error::DeleteUtterancesError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the bot that stored the utterances.</p>
        pub fn bot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.bot_name(input);
            self
        }
        pub fn set_bot_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_bot_name(input);
            self
        }
        /// <p> The unique identifier for the user that made the utterances. This
        /// is the user ID that was sent in the <a href="http://docs.aws.amazon.com/lex/latest/dg/API_runtime_PostContent.html">PostContent</a> or <a href="http://docs.aws.amazon.com/lex/latest/dg/API_runtime_PostText.html">PostText</a> operation request that contained the
        /// utterance.</p>
        pub fn user_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.user_id(input);
            self
        }
        pub fn set_user_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_user_id(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetBot<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_bot_input::Builder,
    }
    impl<C> GetBot<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetBotOutput,
            smithy_http::result::SdkError<crate::error::GetBotError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the bot. The name is case sensitive. </p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>The version or alias of the bot.</p>
        pub fn version_or_alias(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.version_or_alias(input);
            self
        }
        pub fn set_version_or_alias(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_version_or_alias(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetBotAlias<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_bot_alias_input::Builder,
    }
    impl<C> GetBotAlias<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetBotAliasOutput,
            smithy_http::result::SdkError<crate::error::GetBotAliasError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the bot alias. The name is case sensitive.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>The name of the bot.</p>
        pub fn bot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.bot_name(input);
            self
        }
        pub fn set_bot_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_bot_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetBotAliases<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_bot_aliases_input::Builder,
    }
    impl<C> GetBotAliases<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetBotAliasesOutput,
            smithy_http::result::SdkError<crate::error::GetBotAliasesError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the bot.</p>
        pub fn bot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.bot_name(input);
            self
        }
        pub fn set_bot_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_bot_name(input);
            self
        }
        /// <p>A pagination token for fetching the next page of aliases. If the
        /// response to this call is truncated, Amazon Lex returns a pagination token in
        /// the response. To fetch the next page of aliases, specify the pagination
        /// token in the next request. </p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The maximum number of aliases to return in the response. The
        /// default is 50. . </p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.inner = self.inner.max_results(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_results(input);
            self
        }
        /// <p>Substring to match in bot alias names. An alias will be returned if
        /// any part of its name matches the substring. For example, "xyz" matches
        /// both "xyzabc" and "abcxyz."</p>
        pub fn name_contains(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name_contains(input);
            self
        }
        pub fn set_name_contains(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_name_contains(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetBotChannelAssociation<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_bot_channel_association_input::Builder,
    }
    impl<C> GetBotChannelAssociation<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetBotChannelAssociationOutput,
            smithy_http::result::SdkError<crate::error::GetBotChannelAssociationError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the association between the bot and the channel. The
        /// name is case sensitive. </p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>The name of the Amazon Lex bot.</p>
        pub fn bot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.bot_name(input);
            self
        }
        pub fn set_bot_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_bot_name(input);
            self
        }
        /// <p>An alias pointing to the specific version of the Amazon Lex bot to which
        /// this association is being made.</p>
        pub fn bot_alias(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.bot_alias(input);
            self
        }
        pub fn set_bot_alias(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_bot_alias(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetBotChannelAssociations<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_bot_channel_associations_input::Builder,
    }
    impl<C> GetBotChannelAssociations<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetBotChannelAssociationsOutput,
            smithy_http::result::SdkError<crate::error::GetBotChannelAssociationsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the Amazon Lex bot in the association.</p>
        pub fn bot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.bot_name(input);
            self
        }
        pub fn set_bot_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_bot_name(input);
            self
        }
        /// <p>An alias pointing to the specific version of the Amazon Lex bot to which
        /// this association is being made.</p>
        pub fn bot_alias(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.bot_alias(input);
            self
        }
        pub fn set_bot_alias(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_bot_alias(input);
            self
        }
        /// <p>A pagination token for fetching the next page of associations. If
        /// the response to this call is truncated, Amazon Lex returns a pagination token
        /// in the response. To fetch the next page of associations, specify the
        /// pagination token in the next request. </p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The maximum number of associations to return in the response. The
        /// default is 50. </p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.inner = self.inner.max_results(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_results(input);
            self
        }
        /// <p>Substring to match in channel association names. An association
        /// will be returned if any part of its name matches the substring. For
        /// example, "xyz" matches both "xyzabc" and "abcxyz." To return all bot
        /// channel associations, use a hyphen ("-") as the <code>nameContains</code>
        /// parameter.</p>
        pub fn name_contains(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name_contains(input);
            self
        }
        pub fn set_name_contains(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_name_contains(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetBots<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_bots_input::Builder,
    }
    impl<C> GetBots<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetBotsOutput,
            smithy_http::result::SdkError<crate::error::GetBotsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>A pagination token that fetches the next page of bots. If the
        /// response to this call is truncated, Amazon Lex returns a pagination token in
        /// the response. To fetch the next page of bots, specify the pagination token
        /// in the next request. </p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The maximum number of bots to return in the response that the
        /// request will return. The default is 10.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.inner = self.inner.max_results(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_results(input);
            self
        }
        /// <p>Substring to match in bot names. A bot will be returned if any part
        /// of its name matches the substring. For example, "xyz" matches both
        /// "xyzabc" and "abcxyz."</p>
        pub fn name_contains(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name_contains(input);
            self
        }
        pub fn set_name_contains(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_name_contains(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetBotVersions<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_bot_versions_input::Builder,
    }
    impl<C> GetBotVersions<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetBotVersionsOutput,
            smithy_http::result::SdkError<crate::error::GetBotVersionsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the bot for which versions should be
        /// returned.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>A pagination token for fetching the next page of bot versions. If
        /// the response to this call is truncated, Amazon Lex returns a pagination token
        /// in the response. To fetch the next page of versions, specify the
        /// pagination token in the next request. </p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The maximum number of bot versions to return in the response. The
        /// default is 10.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.inner = self.inner.max_results(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_results(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetBuiltinIntent<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_builtin_intent_input::Builder,
    }
    impl<C> GetBuiltinIntent<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetBuiltinIntentOutput,
            smithy_http::result::SdkError<crate::error::GetBuiltinIntentError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The unique identifier for a built-in intent. To find the signature
        /// for an intent, see <a href="https://developer.amazon.com/public/solutions/alexa/alexa-skills-kit/docs/built-in-intent-ref/standard-intents">Standard Built-in Intents</a> in the <i>Alexa Skills
        /// Kit</i>.</p>
        pub fn signature(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.signature(input);
            self
        }
        pub fn set_signature(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_signature(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetBuiltinIntents<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_builtin_intents_input::Builder,
    }
    impl<C> GetBuiltinIntents<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetBuiltinIntentsOutput,
            smithy_http::result::SdkError<crate::error::GetBuiltinIntentsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>A list of locales that the intent supports.</p>
        pub fn locale(mut self, input: crate::model::Locale) -> Self {
            self.inner = self.inner.locale(input);
            self
        }
        pub fn set_locale(mut self, input: std::option::Option<crate::model::Locale>) -> Self {
            self.inner = self.inner.set_locale(input);
            self
        }
        /// <p>Substring to match in built-in intent signatures. An intent will be
        /// returned if any part of its signature matches the substring. For example,
        /// "xyz" matches both "xyzabc" and "abcxyz." To find the signature for an
        /// intent, see <a href="https://developer.amazon.com/public/solutions/alexa/alexa-skills-kit/docs/built-in-intent-ref/standard-intents">Standard Built-in Intents</a> in the <i>Alexa Skills
        /// Kit</i>.</p>
        pub fn signature_contains(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.signature_contains(input);
            self
        }
        pub fn set_signature_contains(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_signature_contains(input);
            self
        }
        /// <p>A pagination token that fetches the next page of intents. If this
        /// API call is truncated, Amazon Lex returns a pagination token in the response.
        /// To fetch the next page of intents, use the pagination token in the next
        /// request.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The maximum number of intents to return in the response. The
        /// default is 10.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.inner = self.inner.max_results(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_results(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetBuiltinSlotTypes<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_builtin_slot_types_input::Builder,
    }
    impl<C> GetBuiltinSlotTypes<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetBuiltinSlotTypesOutput,
            smithy_http::result::SdkError<crate::error::GetBuiltinSlotTypesError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>A list of locales that the slot type supports.</p>
        pub fn locale(mut self, input: crate::model::Locale) -> Self {
            self.inner = self.inner.locale(input);
            self
        }
        pub fn set_locale(mut self, input: std::option::Option<crate::model::Locale>) -> Self {
            self.inner = self.inner.set_locale(input);
            self
        }
        /// <p>Substring to match in built-in slot type signatures. A slot type
        /// will be returned if any part of its signature matches the substring. For
        /// example, "xyz" matches both "xyzabc" and "abcxyz."</p>
        pub fn signature_contains(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.signature_contains(input);
            self
        }
        pub fn set_signature_contains(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_signature_contains(input);
            self
        }
        /// <p>A pagination token that fetches the next page of slot types. If the
        /// response to this API call is truncated, Amazon Lex returns a pagination token
        /// in the response. To fetch the next page of slot types, specify the
        /// pagination token in the next request.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The maximum number of slot types to return in the response. The
        /// default is 10.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.inner = self.inner.max_results(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_results(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetExport<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_export_input::Builder,
    }
    impl<C> GetExport<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetExportOutput,
            smithy_http::result::SdkError<crate::error::GetExportError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the bot to export.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>The version of the bot to export.</p>
        pub fn version(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.version(input);
            self
        }
        pub fn set_version(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_version(input);
            self
        }
        /// <p>The type of resource to export. </p>
        pub fn resource_type(mut self, input: crate::model::ResourceType) -> Self {
            self.inner = self.inner.resource_type(input);
            self
        }
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<crate::model::ResourceType>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
        /// <p>The format of the exported data.</p>
        pub fn export_type(mut self, input: crate::model::ExportType) -> Self {
            self.inner = self.inner.export_type(input);
            self
        }
        pub fn set_export_type(
            mut self,
            input: std::option::Option<crate::model::ExportType>,
        ) -> Self {
            self.inner = self.inner.set_export_type(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetImport<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_import_input::Builder,
    }
    impl<C> GetImport<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetImportOutput,
            smithy_http::result::SdkError<crate::error::GetImportError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The identifier of the import job information to return.</p>
        pub fn import_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.import_id(input);
            self
        }
        pub fn set_import_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_import_id(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetIntent<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_intent_input::Builder,
    }
    impl<C> GetIntent<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetIntentOutput,
            smithy_http::result::SdkError<crate::error::GetIntentError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the intent. The name is case sensitive. </p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>The version of the intent.</p>
        pub fn version(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.version(input);
            self
        }
        pub fn set_version(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_version(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetIntents<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_intents_input::Builder,
    }
    impl<C> GetIntents<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetIntentsOutput,
            smithy_http::result::SdkError<crate::error::GetIntentsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>A pagination token that fetches the next page of intents. If the
        /// response to this API call is truncated, Amazon Lex returns a pagination token
        /// in the response. To fetch the next page of intents, specify the pagination
        /// token in the next request. </p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The maximum number of intents to return in the response. The
        /// default is 10.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.inner = self.inner.max_results(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_results(input);
            self
        }
        /// <p>Substring to match in intent names. An intent will be returned if
        /// any part of its name matches the substring. For example, "xyz" matches
        /// both "xyzabc" and "abcxyz."</p>
        pub fn name_contains(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name_contains(input);
            self
        }
        pub fn set_name_contains(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_name_contains(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetIntentVersions<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_intent_versions_input::Builder,
    }
    impl<C> GetIntentVersions<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetIntentVersionsOutput,
            smithy_http::result::SdkError<crate::error::GetIntentVersionsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the intent for which versions should be
        /// returned.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>A pagination token for fetching the next page of intent versions.
        /// If the response to this call is truncated, Amazon Lex returns a pagination
        /// token in the response. To fetch the next page of versions, specify the
        /// pagination token in the next request. </p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The maximum number of intent versions to return in the response.
        /// The default is 10.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.inner = self.inner.max_results(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_results(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetMigration<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_migration_input::Builder,
    }
    impl<C> GetMigration<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetMigrationOutput,
            smithy_http::result::SdkError<crate::error::GetMigrationError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The unique identifier of the migration to view. The
        /// <code>migrationID</code> is returned by the  operation.</p>
        pub fn migration_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.migration_id(input);
            self
        }
        pub fn set_migration_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_migration_id(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetMigrations<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_migrations_input::Builder,
    }
    impl<C> GetMigrations<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetMigrationsOutput,
            smithy_http::result::SdkError<crate::error::GetMigrationsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The field to sort the list of migrations by. You can sort by the
        /// Amazon Lex V1 bot name or the date and time that the migration was
        /// started.</p>
        pub fn sort_by_attribute(mut self, input: crate::model::MigrationSortAttribute) -> Self {
            self.inner = self.inner.sort_by_attribute(input);
            self
        }
        pub fn set_sort_by_attribute(
            mut self,
            input: std::option::Option<crate::model::MigrationSortAttribute>,
        ) -> Self {
            self.inner = self.inner.set_sort_by_attribute(input);
            self
        }
        /// <p>The order so sort the list.</p>
        pub fn sort_by_order(mut self, input: crate::model::SortOrder) -> Self {
            self.inner = self.inner.sort_by_order(input);
            self
        }
        pub fn set_sort_by_order(
            mut self,
            input: std::option::Option<crate::model::SortOrder>,
        ) -> Self {
            self.inner = self.inner.set_sort_by_order(input);
            self
        }
        /// <p>Filters the list to contain only bots whose name contains the
        /// specified string. The string is matched anywhere in bot name.</p>
        pub fn v1_bot_name_contains(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.v1_bot_name_contains(input);
            self
        }
        pub fn set_v1_bot_name_contains(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_v1_bot_name_contains(input);
            self
        }
        /// <p>Filters the list to contain only migrations in the specified state.</p>
        pub fn migration_status_equals(mut self, input: crate::model::MigrationStatus) -> Self {
            self.inner = self.inner.migration_status_equals(input);
            self
        }
        pub fn set_migration_status_equals(
            mut self,
            input: std::option::Option<crate::model::MigrationStatus>,
        ) -> Self {
            self.inner = self.inner.set_migration_status_equals(input);
            self
        }
        /// <p>The maximum number of migrations to return in the response. The
        /// default is 10.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.inner = self.inner.max_results(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_results(input);
            self
        }
        /// <p>A pagination token that fetches the next page of migrations. If the
        /// response to this operation is truncated, Amazon Lex returns a pagination token
        /// in the response. To fetch the next page of migrations, specify the
        /// pagination token in the request.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetSlotType<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_slot_type_input::Builder,
    }
    impl<C> GetSlotType<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetSlotTypeOutput,
            smithy_http::result::SdkError<crate::error::GetSlotTypeError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the slot type. The name is case sensitive. </p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>The version of the slot type. </p>
        pub fn version(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.version(input);
            self
        }
        pub fn set_version(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_version(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetSlotTypes<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_slot_types_input::Builder,
    }
    impl<C> GetSlotTypes<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetSlotTypesOutput,
            smithy_http::result::SdkError<crate::error::GetSlotTypesError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>A pagination token that fetches the next page of slot types. If the
        /// response to this API call is truncated, Amazon Lex returns a pagination token
        /// in the response. To fetch next page of slot types, specify the pagination
        /// token in the next request.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The maximum number of slot types to return in the response. The
        /// default is 10.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.inner = self.inner.max_results(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_results(input);
            self
        }
        /// <p>Substring to match in slot type names. A slot type will be returned
        /// if any part of its name matches the substring. For example, "xyz" matches
        /// both "xyzabc" and "abcxyz."</p>
        pub fn name_contains(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name_contains(input);
            self
        }
        pub fn set_name_contains(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_name_contains(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetSlotTypeVersions<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_slot_type_versions_input::Builder,
    }
    impl<C> GetSlotTypeVersions<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetSlotTypeVersionsOutput,
            smithy_http::result::SdkError<crate::error::GetSlotTypeVersionsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the slot type for which versions should be
        /// returned.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>A pagination token for fetching the next page of slot type
        /// versions. If the response to this call is truncated, Amazon Lex returns a
        /// pagination token in the response. To fetch the next page of versions,
        /// specify the pagination token in the next request. </p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The maximum number of slot type versions to return in the response.
        /// The default is 10.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.inner = self.inner.max_results(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_results(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetUtterancesView<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::get_utterances_view_input::Builder,
    }
    impl<C> GetUtterancesView<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetUtterancesViewOutput,
            smithy_http::result::SdkError<crate::error::GetUtterancesViewError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the bot for which utterance information should be
        /// returned.</p>
        pub fn bot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.bot_name(input);
            self
        }
        pub fn set_bot_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_bot_name(input);
            self
        }
        /// <p>An array of bot versions for which utterance information should be
        /// returned. The limit is 5 versions per request.</p>
        pub fn bot_versions(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.bot_versions(inp);
            self
        }
        pub fn set_bot_versions(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_bot_versions(input);
            self
        }
        /// <p>To return utterances that were recognized and handled, use
        /// <code>Detected</code>. To return utterances that were not recognized,
        /// use <code>Missed</code>.</p>
        pub fn status_type(mut self, input: crate::model::StatusType) -> Self {
            self.inner = self.inner.status_type(input);
            self
        }
        pub fn set_status_type(
            mut self,
            input: std::option::Option<crate::model::StatusType>,
        ) -> Self {
            self.inner = self.inner.set_status_type(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct ListTagsForResource<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::list_tags_for_resource_input::Builder,
    }
    impl<C> ListTagsForResource<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ListTagsForResourceOutput,
            smithy_http::result::SdkError<crate::error::ListTagsForResourceError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The Amazon Resource Name (ARN) of the resource to get a list of tags
        /// for.</p>
        pub fn resource_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_arn(input);
            self
        }
        pub fn set_resource_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_arn(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutBot<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::put_bot_input::Builder,
    }
    impl<C> PutBot<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutBotOutput,
            smithy_http::result::SdkError<crate::error::PutBotError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the bot. The name is <i>not</i> case
        /// sensitive. </p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>A description of the bot.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.description(input);
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_description(input);
            self
        }
        /// <p>An array of <code>Intent</code> objects. Each intent represents a
        /// command that a user can express. For example, a pizza ordering bot might
        /// support an OrderPizza intent. For more information, see <a>how-it-works</a>.</p>
        pub fn intents(mut self, inp: impl Into<crate::model::Intent>) -> Self {
            self.inner = self.inner.intents(inp);
            self
        }
        pub fn set_intents(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Intent>>,
        ) -> Self {
            self.inner = self.inner.set_intents(input);
            self
        }
        /// <p>Set to <code>true</code> to enable access to natural language
        /// understanding improvements. </p>
        /// <p>When you set the <code>enableModelImprovements</code> parameter to
        /// <code>true</code> you can use the
        /// <code>nluIntentConfidenceThreshold</code> parameter to configure
        /// confidence scores. For more information, see <a href="https://docs.aws.amazon.com/lex/latest/dg/confidence-scores.html">Confidence Scores</a>.</p>
        /// <p>You can only set the <code>enableModelImprovements</code> parameter in
        /// certain Regions. If you set the parameter to <code>true</code>, your bot
        /// has access to accuracy improvements.</p>
        /// <p>The Regions where you can set the <code>enableModelImprovements</code>
        /// parameter to <code>true</code> are:</p>
        /// <ul>
        /// <li>
        /// <p>US East (N. Virginia) (us-east-1)</p>
        /// </li>
        /// <li>
        /// <p>US West (Oregon) (us-west-2)</p>
        /// </li>
        /// <li>
        /// <p>Asia Pacific (Sydney) (ap-southeast-2)</p>
        /// </li>
        /// <li>
        /// <p>EU (Ireland) (eu-west-1)</p>
        /// </li>
        /// </ul>
        /// <p>In other Regions, the <code>enableModelImprovements</code> parameter
        /// is set to <code>true</code> by default. In these Regions setting the
        /// parameter to <code>false</code> throws a <code>ValidationException</code>
        /// exception.</p>
        pub fn enable_model_improvements(mut self, input: bool) -> Self {
            self.inner = self.inner.enable_model_improvements(input);
            self
        }
        pub fn set_enable_model_improvements(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_enable_model_improvements(input);
            self
        }
        /// <p>Determines the threshold where Amazon Lex will insert the
        /// <code>AMAZON.FallbackIntent</code>,
        /// <code>AMAZON.KendraSearchIntent</code>, or both when returning
        /// alternative intents in a <a href="https://docs.aws.amazon.com/lex/latest/dg/API_runtime_PostContent.html">PostContent</a> or
        /// <a href="https://docs.aws.amazon.com/lex/latest/dg/API_runtime_PostText.html">PostText</a> response.
        /// <code>AMAZON.FallbackIntent</code> and
        /// <code>AMAZON.KendraSearchIntent</code> are only inserted if they are
        /// configured for the bot.</p>
        /// <p>You must set the <code>enableModelImprovements</code> parameter to
        /// <code>true</code> to use confidence scores in the following
        /// regions.</p>
        /// <ul>
        /// <li>
        /// <p>US East (N. Virginia) (us-east-1)</p>
        /// </li>
        /// <li>
        /// <p>US West (Oregon) (us-west-2)</p>
        /// </li>
        /// <li>
        /// <p>Asia Pacific (Sydney) (ap-southeast-2)</p>
        /// </li>
        /// <li>
        /// <p>EU (Ireland) (eu-west-1)</p>
        /// </li>
        /// </ul>
        /// <p>In other Regions, the <code>enableModelImprovements</code> parameter
        /// is set to <code>true</code> by default.</p>
        /// <p>For example, suppose a bot is configured with the confidence threshold
        /// of 0.80 and the <code>AMAZON.FallbackIntent</code>. Amazon Lex returns three
        /// alternative intents with the following confidence scores: IntentA (0.70),
        /// IntentB (0.60), IntentC (0.50). The response from the
        /// <code>PostText</code> operation would be:</p>
        /// <ul>
        /// <li>
        /// <p>AMAZON.FallbackIntent</p>
        /// </li>
        /// <li>
        /// <p>IntentA</p>
        /// </li>
        /// <li>
        /// <p>IntentB</p>
        /// </li>
        /// <li>
        /// <p>IntentC</p>
        /// </li>
        /// </ul>
        pub fn nlu_intent_confidence_threshold(mut self, input: f64) -> Self {
            self.inner = self.inner.nlu_intent_confidence_threshold(input);
            self
        }
        pub fn set_nlu_intent_confidence_threshold(
            mut self,
            input: std::option::Option<f64>,
        ) -> Self {
            self.inner = self.inner.set_nlu_intent_confidence_threshold(input);
            self
        }
        /// <p>When Amazon Lex doesn't understand the user's intent, it uses this
        /// message to get clarification. To specify how many times Amazon Lex should
        /// repeat the clarification prompt, use the <code>maxAttempts</code> field.
        /// If Amazon Lex still doesn't understand, it sends the message in the
        /// <code>abortStatement</code> field. </p>
        /// <p>When you create a clarification prompt, make sure that it suggests
        /// the correct response from the user. for example, for a bot that orders
        /// pizza and drinks, you might create this clarification prompt: "What would
        /// you like to do? You can say 'Order a pizza' or 'Order a drink.'"</p>
        /// <p>If you have defined a fallback intent, it will be invoked if the
        /// clarification prompt is repeated the number of times defined in the
        /// <code>maxAttempts</code> field. For more information, see <a href="https://docs.aws.amazon.com/lex/latest/dg/built-in-intent-fallback.html">
        /// AMAZON.FallbackIntent</a>.</p>
        /// <p>If you don't define a clarification prompt, at runtime Amazon Lex will
        /// return a 400 Bad Request exception in three cases: </p>
        /// <ul>
        /// <li>
        /// <p>Follow-up prompt - When the user responds to a follow-up prompt
        /// but does not provide an intent. For example, in response to a
        /// follow-up prompt that says "Would you like anything else today?" the
        /// user says "Yes." Amazon Lex will return a 400 Bad Request exception because
        /// it does not have a clarification prompt to send to the user to get an
        /// intent.</p>
        /// </li>
        /// <li>
        /// <p>Lambda function - When using a Lambda function, you return an
        /// <code>ElicitIntent</code> dialog type. Since Amazon Lex does not have a
        /// clarification prompt to get an intent from the user, it returns a 400
        /// Bad Request exception.</p>
        /// </li>
        /// <li>
        /// <p>PutSession operation - When using the <code>PutSession</code>
        /// operation, you send an <code>ElicitIntent</code> dialog type. Since
        /// Amazon Lex does not have a clarification prompt to get an intent from the
        /// user, it returns a 400 Bad Request exception.</p>
        /// </li>
        /// </ul>
        pub fn clarification_prompt(mut self, input: crate::model::Prompt) -> Self {
            self.inner = self.inner.clarification_prompt(input);
            self
        }
        pub fn set_clarification_prompt(
            mut self,
            input: std::option::Option<crate::model::Prompt>,
        ) -> Self {
            self.inner = self.inner.set_clarification_prompt(input);
            self
        }
        /// <p>When Amazon Lex can't understand the user's input in context, it tries
        /// to elicit the information a few times. After that, Amazon Lex sends the message
        /// defined in <code>abortStatement</code> to the user, and then cancels the
        /// conversation. To set the number of retries, use the
        /// <code>valueElicitationPrompt</code> field for the slot type. </p>
        /// <p>For example, in a pizza ordering bot, Amazon Lex might ask a user "What
        /// type of crust would you like?" If the user's response is not one of the
        /// expected responses (for example, "thin crust, "deep dish," etc.), Amazon Lex
        /// tries to elicit a correct response a few more times. </p>
        /// <p>For example, in a pizza ordering application,
        /// <code>OrderPizza</code> might be one of the intents. This intent might
        /// require the <code>CrustType</code> slot. You specify the
        /// <code>valueElicitationPrompt</code> field when you create the
        /// <code>CrustType</code> slot.</p>
        /// <p>If you have defined a fallback intent the cancel statement will not be
        /// sent to the user, the fallback intent is used instead. For more
        /// information, see <a href="https://docs.aws.amazon.com/lex/latest/dg/built-in-intent-fallback.html">
        /// AMAZON.FallbackIntent</a>.</p>
        pub fn abort_statement(mut self, input: crate::model::Statement) -> Self {
            self.inner = self.inner.abort_statement(input);
            self
        }
        pub fn set_abort_statement(
            mut self,
            input: std::option::Option<crate::model::Statement>,
        ) -> Self {
            self.inner = self.inner.set_abort_statement(input);
            self
        }
        /// <p>The maximum time in seconds that Amazon Lex retains the data gathered in
        /// a conversation.</p>
        /// <p>A user interaction session remains active for the amount of time
        /// specified. If no conversation occurs during this time, the session expires
        /// and Amazon Lex deletes any data provided before the timeout.</p>
        /// <p>For example, suppose that a user chooses the OrderPizza intent, but
        /// gets sidetracked halfway through placing an order. If the user doesn't
        /// complete the order within the specified time, Amazon Lex discards the slot
        /// information that it gathered, and the user must start over.</p>
        /// <p>If you don't include the <code>idleSessionTTLInSeconds</code>
        /// element in a <code>PutBot</code> operation request, Amazon Lex uses the default
        /// value. This is also true if the request replaces an existing
        /// bot.</p>
        /// <p>The default is 300 seconds (5 minutes).</p>
        pub fn idle_session_ttl_in_seconds(mut self, input: i32) -> Self {
            self.inner = self.inner.idle_session_ttl_in_seconds(input);
            self
        }
        pub fn set_idle_session_ttl_in_seconds(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_idle_session_ttl_in_seconds(input);
            self
        }
        /// <p>The Amazon Polly voice ID that you want Amazon Lex to use for voice
        /// interactions with the user. The locale configured for the voice must match
        /// the locale of the bot. For more information, see <a href="https://docs.aws.amazon.com/polly/latest/dg/voicelist.html">Voices
        /// in Amazon Polly</a> in the <i>Amazon Polly Developer
        /// Guide</i>.</p>
        pub fn voice_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.voice_id(input);
            self
        }
        pub fn set_voice_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_voice_id(input);
            self
        }
        /// <p>Identifies a specific revision of the <code>$LATEST</code>
        /// version.</p>
        /// <p>When you create a new bot, leave the <code>checksum</code> field
        /// blank. If you specify a checksum you get a
        /// <code>BadRequestException</code> exception.</p>
        /// <p>When you want to update a bot, set the <code>checksum</code> field
        /// to the checksum of the most recent revision of the <code>$LATEST</code>
        /// version. If you don't specify the <code> checksum</code> field, or if the
        /// checksum does not match the <code>$LATEST</code> version, you get a
        /// <code>PreconditionFailedException</code> exception.</p>
        pub fn checksum(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.checksum(input);
            self
        }
        pub fn set_checksum(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_checksum(input);
            self
        }
        /// <p>If you set the <code>processBehavior</code> element to
        /// <code>BUILD</code>, Amazon Lex builds the bot so that it can be run. If you
        /// set the element to <code>SAVE</code> Amazon Lex saves the bot, but doesn't
        /// build it. </p>
        /// <p>If you don't specify this value, the default value is
        /// <code>BUILD</code>.</p>
        pub fn process_behavior(mut self, input: crate::model::ProcessBehavior) -> Self {
            self.inner = self.inner.process_behavior(input);
            self
        }
        pub fn set_process_behavior(
            mut self,
            input: std::option::Option<crate::model::ProcessBehavior>,
        ) -> Self {
            self.inner = self.inner.set_process_behavior(input);
            self
        }
        /// <p> Specifies the target locale for the bot. Any intent used in the
        /// bot must be compatible with the locale of the bot. </p>
        /// <p>The default is <code>en-US</code>.</p>
        pub fn locale(mut self, input: crate::model::Locale) -> Self {
            self.inner = self.inner.locale(input);
            self
        }
        pub fn set_locale(mut self, input: std::option::Option<crate::model::Locale>) -> Self {
            self.inner = self.inner.set_locale(input);
            self
        }
        /// <p>For each Amazon Lex bot created with the Amazon Lex Model Building Service,
        /// you must specify whether your use of Amazon Lex is related to a website,
        /// program, or other application that is directed or targeted, in whole or in
        /// part, to children under age 13 and subject to the Children's Online
        /// Privacy Protection Act (COPPA) by specifying <code>true</code> or
        /// <code>false</code> in the <code>childDirected</code> field. By
        /// specifying <code>true</code> in the <code>childDirected</code> field, you
        /// confirm that your use of Amazon Lex <b>is</b> related
        /// to a website, program, or other application that is directed or targeted,
        /// in whole or in part, to children under age 13 and subject to COPPA. By
        /// specifying <code>false</code> in the <code>childDirected</code> field, you
        /// confirm that your use of Amazon Lex <b>is not</b>
        /// related to a website, program, or other application that is directed or
        /// targeted, in whole or in part, to children under age 13 and subject to
        /// COPPA. You may not specify a default value for the
        /// <code>childDirected</code> field that does not accurately reflect
        /// whether your use of Amazon Lex is related to a website, program, or other
        /// application that is directed or targeted, in whole or in part, to children
        /// under age 13 and subject to COPPA.</p>
        /// <p>If your use of Amazon Lex relates to a website, program, or other
        /// application that is directed in whole or in part, to children under age
        /// 13, you must obtain any required verifiable parental consent under COPPA.
        /// For information regarding the use of Amazon Lex in connection with websites,
        /// programs, or other applications that are directed or targeted, in whole or
        /// in part, to children under age 13, see the <a href="https://aws.amazon.com/lex/faqs#data-security">Amazon Lex FAQ.</a>
        /// </p>
        pub fn child_directed(mut self, input: bool) -> Self {
            self.inner = self.inner.child_directed(input);
            self
        }
        pub fn set_child_directed(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_child_directed(input);
            self
        }
        /// <p>When set to <code>true</code> user utterances are sent to Amazon
        /// Comprehend for sentiment analysis. If you don't specify
        /// <code>detectSentiment</code>, the default is <code>false</code>.</p>
        pub fn detect_sentiment(mut self, input: bool) -> Self {
            self.inner = self.inner.detect_sentiment(input);
            self
        }
        pub fn set_detect_sentiment(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_detect_sentiment(input);
            self
        }
        /// <p>When set to <code>true</code> a new numbered version of the bot is
        /// created. This is the same as calling the <code>CreateBotVersion</code>
        /// operation. If you don't specify <code>createVersion</code>, the default is
        /// <code>false</code>.</p>
        pub fn create_version(mut self, input: bool) -> Self {
            self.inner = self.inner.create_version(input);
            self
        }
        pub fn set_create_version(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_create_version(input);
            self
        }
        /// <p>A list of tags to add to the bot. You can only add tags when you
        /// create a bot, you can't use the <code>PutBot</code> operation to update
        /// the tags on a bot. To update tags, use the <code>TagResource</code>
        /// operation.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutBotAlias<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::put_bot_alias_input::Builder,
    }
    impl<C> PutBotAlias<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutBotAliasOutput,
            smithy_http::result::SdkError<crate::error::PutBotAliasError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the alias. The name is <i>not</i> case
        /// sensitive.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>A description of the alias.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.description(input);
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_description(input);
            self
        }
        /// <p>The version of the bot.</p>
        pub fn bot_version(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.bot_version(input);
            self
        }
        pub fn set_bot_version(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_bot_version(input);
            self
        }
        /// <p>The name of the bot.</p>
        pub fn bot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.bot_name(input);
            self
        }
        pub fn set_bot_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_bot_name(input);
            self
        }
        /// <p>Identifies a specific revision of the <code>$LATEST</code>
        /// version.</p>
        /// <p>When you create a new bot alias, leave the <code>checksum</code>
        /// field blank. If you specify a checksum you get a
        /// <code>BadRequestException</code> exception.</p>
        /// <p>When you want to update a bot alias, set the <code>checksum</code>
        /// field to the checksum of the most recent revision of the
        /// <code>$LATEST</code> version. If you don't specify the <code>
        /// checksum</code> field, or if the checksum does not match the
        /// <code>$LATEST</code> version, you get a
        /// <code>PreconditionFailedException</code> exception.</p>
        pub fn checksum(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.checksum(input);
            self
        }
        pub fn set_checksum(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_checksum(input);
            self
        }
        /// <p>Settings for conversation logs for the alias.</p>
        pub fn conversation_logs(mut self, input: crate::model::ConversationLogsRequest) -> Self {
            self.inner = self.inner.conversation_logs(input);
            self
        }
        pub fn set_conversation_logs(
            mut self,
            input: std::option::Option<crate::model::ConversationLogsRequest>,
        ) -> Self {
            self.inner = self.inner.set_conversation_logs(input);
            self
        }
        /// <p>A list of tags to add to the bot alias. You can only add tags when you
        /// create an alias, you can't use the <code>PutBotAlias</code> operation to
        /// update the tags on a bot alias. To update tags, use the
        /// <code>TagResource</code> operation.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutIntent<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::put_intent_input::Builder,
    }
    impl<C> PutIntent<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutIntentOutput,
            smithy_http::result::SdkError<crate::error::PutIntentError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the intent. The name is <i>not</i> case
        /// sensitive. </p>
        /// <p>The name can't match a built-in intent name, or a built-in intent
        /// name with "AMAZON." removed. For example, because there is a built-in
        /// intent called <code>AMAZON.HelpIntent</code>, you can't create a custom
        /// intent called <code>HelpIntent</code>.</p>
        /// <p>For a list of built-in intents, see <a href="https://developer.amazon.com/public/solutions/alexa/alexa-skills-kit/docs/built-in-intent-ref/standard-intents">Standard Built-in Intents</a> in the <i>Alexa Skills
        /// Kit</i>.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>A description of the intent.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.description(input);
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_description(input);
            self
        }
        /// <p>An array of intent slots. At runtime, Amazon Lex elicits required slot
        /// values from the user using prompts defined in the slots. For more
        /// information, see <a>how-it-works</a>. </p>
        pub fn slots(mut self, inp: impl Into<crate::model::Slot>) -> Self {
            self.inner = self.inner.slots(inp);
            self
        }
        pub fn set_slots(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Slot>>,
        ) -> Self {
            self.inner = self.inner.set_slots(input);
            self
        }
        /// <p>An array of utterances (strings) that a user might say to signal
        /// the intent. For example, "I want {PizzaSize} pizza", "Order {Quantity}
        /// {PizzaSize} pizzas". </p>
        /// <p>In each utterance, a slot name is enclosed in curly braces.
        /// </p>
        pub fn sample_utterances(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.sample_utterances(inp);
            self
        }
        pub fn set_sample_utterances(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_sample_utterances(input);
            self
        }
        /// <p>Prompts the user to confirm the intent. This question should have a
        /// yes or no answer.</p>
        /// <p>Amazon Lex uses this prompt to ensure that the user acknowledges that
        /// the intent is ready for fulfillment. For example, with the
        /// <code>OrderPizza</code> intent, you might want to confirm that the order
        /// is correct before placing it. For other intents, such as intents that
        /// simply respond to user questions, you might not need to ask the user for
        /// confirmation before providing the information. </p>
        /// <note>
        /// <p>You you must provide both the <code>rejectionStatement</code> and
        /// the <code>confirmationPrompt</code>, or neither.</p>
        /// </note>
        pub fn confirmation_prompt(mut self, input: crate::model::Prompt) -> Self {
            self.inner = self.inner.confirmation_prompt(input);
            self
        }
        pub fn set_confirmation_prompt(
            mut self,
            input: std::option::Option<crate::model::Prompt>,
        ) -> Self {
            self.inner = self.inner.set_confirmation_prompt(input);
            self
        }
        /// <p>When the user answers "no" to the question defined in
        /// <code>confirmationPrompt</code>, Amazon Lex responds with this statement to
        /// acknowledge that the intent was canceled. </p>
        /// <note>
        /// <p>You must provide both the <code>rejectionStatement</code> and the
        /// <code>confirmationPrompt</code>, or neither.</p>
        /// </note>
        pub fn rejection_statement(mut self, input: crate::model::Statement) -> Self {
            self.inner = self.inner.rejection_statement(input);
            self
        }
        pub fn set_rejection_statement(
            mut self,
            input: std::option::Option<crate::model::Statement>,
        ) -> Self {
            self.inner = self.inner.set_rejection_statement(input);
            self
        }
        /// <p>Amazon Lex uses this prompt to solicit additional activity after
        /// fulfilling an intent. For example, after the <code>OrderPizza</code>
        /// intent is fulfilled, you might prompt the user to order a drink.</p>
        /// <p>The action that Amazon Lex takes depends on the user's response, as
        /// follows:</p>
        /// <ul>
        /// <li>
        /// <p>If the user says "Yes" it responds with the clarification
        /// prompt that is configured for the bot.</p>
        /// </li>
        /// <li>
        /// <p>if the user says "Yes" and continues with an utterance that
        /// triggers an intent it starts a conversation for the intent.</p>
        /// </li>
        /// <li>
        /// <p>If the user says "No" it responds with the rejection statement
        /// configured for the the follow-up prompt.</p>
        /// </li>
        /// <li>
        /// <p>If it doesn't recognize the utterance it repeats the follow-up
        /// prompt again.</p>
        /// </li>
        /// </ul>
        /// <p>The <code>followUpPrompt</code> field and the
        /// <code>conclusionStatement</code> field are mutually exclusive. You can
        /// specify only one. </p>
        pub fn follow_up_prompt(mut self, input: crate::model::FollowUpPrompt) -> Self {
            self.inner = self.inner.follow_up_prompt(input);
            self
        }
        pub fn set_follow_up_prompt(
            mut self,
            input: std::option::Option<crate::model::FollowUpPrompt>,
        ) -> Self {
            self.inner = self.inner.set_follow_up_prompt(input);
            self
        }
        /// <p> The statement that you want Amazon Lex to convey to the user after the
        /// intent is successfully fulfilled by the Lambda function. </p>
        /// <p>This element is relevant only if you provide a Lambda function in
        /// the <code>fulfillmentActivity</code>. If you return the intent to the
        /// client application, you can't specify this element.</p>
        /// <note>
        /// <p>The <code>followUpPrompt</code> and
        /// <code>conclusionStatement</code> are mutually exclusive. You can
        /// specify only one.</p>
        /// </note>
        pub fn conclusion_statement(mut self, input: crate::model::Statement) -> Self {
            self.inner = self.inner.conclusion_statement(input);
            self
        }
        pub fn set_conclusion_statement(
            mut self,
            input: std::option::Option<crate::model::Statement>,
        ) -> Self {
            self.inner = self.inner.set_conclusion_statement(input);
            self
        }
        /// <p> Specifies a Lambda function to invoke for each user input. You can
        /// invoke this Lambda function to personalize user interaction. </p>
        /// <p>For example, suppose your bot determines that the user is John.
        /// Your Lambda function might retrieve John's information from a backend
        /// database and prepopulate some of the values. For example, if you find that
        /// John is gluten intolerant, you might set the corresponding intent slot,
        /// <code>GlutenIntolerant</code>, to true. You might find John's phone
        /// number and set the corresponding session attribute. </p>
        pub fn dialog_code_hook(mut self, input: crate::model::CodeHook) -> Self {
            self.inner = self.inner.dialog_code_hook(input);
            self
        }
        pub fn set_dialog_code_hook(
            mut self,
            input: std::option::Option<crate::model::CodeHook>,
        ) -> Self {
            self.inner = self.inner.set_dialog_code_hook(input);
            self
        }
        /// <p>Required. Describes how the intent is fulfilled. For example, after
        /// a user provides all of the information for a pizza order,
        /// <code>fulfillmentActivity</code> defines how the bot places an order
        /// with a local pizza store. </p>
        /// <p> You might configure Amazon Lex to return all of the intent information
        /// to the client application, or direct it to invoke a Lambda function that
        /// can process the intent (for example, place an order with a pizzeria).
        /// </p>
        pub fn fulfillment_activity(mut self, input: crate::model::FulfillmentActivity) -> Self {
            self.inner = self.inner.fulfillment_activity(input);
            self
        }
        pub fn set_fulfillment_activity(
            mut self,
            input: std::option::Option<crate::model::FulfillmentActivity>,
        ) -> Self {
            self.inner = self.inner.set_fulfillment_activity(input);
            self
        }
        /// <p>A unique identifier for the built-in intent to base this intent on.
        /// To find the signature for an intent, see <a href="https://developer.amazon.com/public/solutions/alexa/alexa-skills-kit/docs/built-in-intent-ref/standard-intents">Standard Built-in Intents</a> in the <i>Alexa Skills
        /// Kit</i>.</p>
        pub fn parent_intent_signature(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.parent_intent_signature(input);
            self
        }
        pub fn set_parent_intent_signature(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_parent_intent_signature(input);
            self
        }
        /// <p>Identifies a specific revision of the <code>$LATEST</code>
        /// version.</p>
        /// <p>When you create a new intent, leave the <code>checksum</code> field
        /// blank. If you specify a checksum you get a
        /// <code>BadRequestException</code> exception.</p>
        /// <p>When you want to update a intent, set the <code>checksum</code>
        /// field to the checksum of the most recent revision of the
        /// <code>$LATEST</code> version. If you don't specify the <code>
        /// checksum</code> field, or if the checksum does not match the
        /// <code>$LATEST</code> version, you get a
        /// <code>PreconditionFailedException</code> exception.</p>
        pub fn checksum(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.checksum(input);
            self
        }
        pub fn set_checksum(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_checksum(input);
            self
        }
        /// <p>When set to <code>true</code> a new numbered version of the intent
        /// is created. This is the same as calling the
        /// <code>CreateIntentVersion</code> operation. If you do not specify
        /// <code>createVersion</code>, the default is <code>false</code>.</p>
        pub fn create_version(mut self, input: bool) -> Self {
            self.inner = self.inner.create_version(input);
            self
        }
        pub fn set_create_version(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_create_version(input);
            self
        }
        /// <p>Configuration information required to use the
        /// <code>AMAZON.KendraSearchIntent</code> intent to connect to an Amazon
        /// Kendra index. For more information, see <a href="http://docs.aws.amazon.com/lex/latest/dg/built-in-intent-kendra-search.html">
        /// AMAZON.KendraSearchIntent</a>.</p>
        pub fn kendra_configuration(mut self, input: crate::model::KendraConfiguration) -> Self {
            self.inner = self.inner.kendra_configuration(input);
            self
        }
        pub fn set_kendra_configuration(
            mut self,
            input: std::option::Option<crate::model::KendraConfiguration>,
        ) -> Self {
            self.inner = self.inner.set_kendra_configuration(input);
            self
        }
        /// <p>An array of <code>InputContext</code> objects that lists the contexts
        /// that must be active for Amazon Lex to choose the intent in a conversation with
        /// the user.</p>
        pub fn input_contexts(mut self, inp: impl Into<crate::model::InputContext>) -> Self {
            self.inner = self.inner.input_contexts(inp);
            self
        }
        pub fn set_input_contexts(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::InputContext>>,
        ) -> Self {
            self.inner = self.inner.set_input_contexts(input);
            self
        }
        /// <p>An array of <code>OutputContext</code> objects that lists the contexts
        /// that the intent activates when the intent is fulfilled.</p>
        pub fn output_contexts(mut self, inp: impl Into<crate::model::OutputContext>) -> Self {
            self.inner = self.inner.output_contexts(inp);
            self
        }
        pub fn set_output_contexts(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::OutputContext>>,
        ) -> Self {
            self.inner = self.inner.set_output_contexts(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutSlotType<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::put_slot_type_input::Builder,
    }
    impl<C> PutSlotType<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutSlotTypeOutput,
            smithy_http::result::SdkError<crate::error::PutSlotTypeError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the slot type. The name is <i>not</i>
        /// case sensitive. </p>
        /// <p>The name can't match a built-in slot type name, or a built-in slot
        /// type name with "AMAZON." removed. For example, because there is a built-in
        /// slot type called <code>AMAZON.DATE</code>, you can't create a custom slot
        /// type called <code>DATE</code>.</p>
        /// <p>For a list of built-in slot types, see <a href="https://developer.amazon.com/public/solutions/alexa/alexa-skills-kit/docs/built-in-intent-ref/slot-type-reference">Slot Type Reference</a> in the <i>Alexa Skills
        /// Kit</i>.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.name(input);
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_name(input);
            self
        }
        /// <p>A description of the slot type.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.description(input);
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_description(input);
            self
        }
        /// <p>A list of <code>EnumerationValue</code> objects that defines the
        /// values that the slot type can take. Each value can have a list of
        /// <code>synonyms</code>, which are additional values that help train the
        /// machine learning model about the values that it resolves for a slot. </p>
        /// <p>A regular expression slot type doesn't require enumeration values.
        /// All other slot types require a list of enumeration values.</p>
        /// <p>When Amazon Lex resolves a slot value, it generates a resolution list
        /// that contains up to five possible values for the slot. If you are using a
        /// Lambda function, this resolution list is passed to the function. If you
        /// are not using a Lambda function you can choose to return the value that
        /// the user entered or the first value in the resolution list as the slot
        /// value. The <code>valueSelectionStrategy</code> field indicates the option
        /// to use. </p>
        pub fn enumeration_values(
            mut self,
            inp: impl Into<crate::model::EnumerationValue>,
        ) -> Self {
            self.inner = self.inner.enumeration_values(inp);
            self
        }
        pub fn set_enumeration_values(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::EnumerationValue>>,
        ) -> Self {
            self.inner = self.inner.set_enumeration_values(input);
            self
        }
        /// <p>Identifies a specific revision of the <code>$LATEST</code>
        /// version.</p>
        /// <p>When you create a new slot type, leave the <code>checksum</code>
        /// field blank. If you specify a checksum you get a
        /// <code>BadRequestException</code> exception.</p>
        /// <p>When you want to update a slot type, set the <code>checksum</code>
        /// field to the checksum of the most recent revision of the
        /// <code>$LATEST</code> version. If you don't specify the <code>
        /// checksum</code> field, or if the checksum does not match the
        /// <code>$LATEST</code> version, you get a
        /// <code>PreconditionFailedException</code> exception.</p>
        pub fn checksum(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.checksum(input);
            self
        }
        pub fn set_checksum(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_checksum(input);
            self
        }
        /// <p>Determines the slot resolution strategy that Amazon Lex uses to return
        /// slot type values. The field can be set to one of the following
        /// values:</p>
        /// <ul>
        /// <li>
        /// <p>
        /// <code>ORIGINAL_VALUE</code> - Returns the value entered by the
        /// user, if the user value is similar to the slot value.</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>TOP_RESOLUTION</code> - If there is a resolution list for
        /// the slot, return the first value in the resolution list as the slot
        /// type value. If there is no resolution list, null is
        /// returned.</p>
        /// </li>
        /// </ul>
        /// <p>If you don't specify the <code>valueSelectionStrategy</code>, the
        /// default is <code>ORIGINAL_VALUE</code>.</p>
        pub fn value_selection_strategy(
            mut self,
            input: crate::model::SlotValueSelectionStrategy,
        ) -> Self {
            self.inner = self.inner.value_selection_strategy(input);
            self
        }
        pub fn set_value_selection_strategy(
            mut self,
            input: std::option::Option<crate::model::SlotValueSelectionStrategy>,
        ) -> Self {
            self.inner = self.inner.set_value_selection_strategy(input);
            self
        }
        /// <p>When set to <code>true</code> a new numbered version of the slot
        /// type is created. This is the same as calling the
        /// <code>CreateSlotTypeVersion</code> operation. If you do not specify
        /// <code>createVersion</code>, the default is <code>false</code>.</p>
        pub fn create_version(mut self, input: bool) -> Self {
            self.inner = self.inner.create_version(input);
            self
        }
        pub fn set_create_version(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_create_version(input);
            self
        }
        /// <p>The built-in slot type used as the parent of the slot type. When you
        /// define a parent slot type, the new slot type has all of the same
        /// configuration as the parent.</p>
        /// <p>Only <code>AMAZON.AlphaNumeric</code> is supported.</p>
        pub fn parent_slot_type_signature(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.parent_slot_type_signature(input);
            self
        }
        pub fn set_parent_slot_type_signature(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_parent_slot_type_signature(input);
            self
        }
        /// <p>Configuration information that extends the parent built-in slot type.
        /// The configuration is added to the settings for the parent slot
        /// type.</p>
        pub fn slot_type_configurations(
            mut self,
            inp: impl Into<crate::model::SlotTypeConfiguration>,
        ) -> Self {
            self.inner = self.inner.slot_type_configurations(inp);
            self
        }
        pub fn set_slot_type_configurations(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::SlotTypeConfiguration>>,
        ) -> Self {
            self.inner = self.inner.set_slot_type_configurations(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct StartImport<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::start_import_input::Builder,
    }
    impl<C> StartImport<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::StartImportOutput,
            smithy_http::result::SdkError<crate::error::StartImportError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>A zip archive in binary format. The archive should contain one file, a
        /// JSON file containing the resource to import. The resource should match the
        /// type specified in the <code>resourceType</code> field.</p>
        pub fn payload(mut self, input: smithy_types::Blob) -> Self {
            self.inner = self.inner.payload(input);
            self
        }
        pub fn set_payload(mut self, input: std::option::Option<smithy_types::Blob>) -> Self {
            self.inner = self.inner.set_payload(input);
            self
        }
        /// <p>Specifies the type of resource to export. Each resource also
        /// exports any resources that it depends on. </p>
        /// <ul>
        /// <li>
        /// <p>A bot exports dependent intents.</p>
        /// </li>
        /// <li>
        /// <p>An intent exports dependent slot types.</p>
        /// </li>
        /// </ul>
        pub fn resource_type(mut self, input: crate::model::ResourceType) -> Self {
            self.inner = self.inner.resource_type(input);
            self
        }
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<crate::model::ResourceType>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
        /// <p>Specifies the action that the <code>StartImport</code> operation
        /// should take when there is an existing resource with the same
        /// name.</p>
        /// <ul>
        /// <li>
        /// <p>FAIL_ON_CONFLICT - The import operation is stopped on the first
        /// conflict between a resource in the import file and an existing
        /// resource. The name of the resource causing the conflict is in the
        /// <code>failureReason</code> field of the response to the
        /// <code>GetImport</code> operation.</p>
        /// <p>OVERWRITE_LATEST - The import operation proceeds even if there
        /// is a conflict with an existing resource. The $LASTEST version of the
        /// existing resource is overwritten with the data from the import
        /// file.</p>
        /// </li>
        /// </ul>
        pub fn merge_strategy(mut self, input: crate::model::MergeStrategy) -> Self {
            self.inner = self.inner.merge_strategy(input);
            self
        }
        pub fn set_merge_strategy(
            mut self,
            input: std::option::Option<crate::model::MergeStrategy>,
        ) -> Self {
            self.inner = self.inner.set_merge_strategy(input);
            self
        }
        /// <p>A list of tags to add to the imported bot. You can only add tags when
        /// you import a bot, you can't add tags to an intent or slot type.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct StartMigration<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::start_migration_input::Builder,
    }
    impl<C> StartMigration<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::StartMigrationOutput,
            smithy_http::result::SdkError<crate::error::StartMigrationError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the Amazon Lex V1 bot that you are migrating to Amazon Lex V2.</p>
        pub fn v1_bot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.v1_bot_name(input);
            self
        }
        pub fn set_v1_bot_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_v1_bot_name(input);
            self
        }
        /// <p>The version of the bot to migrate to Amazon Lex V2. You can migrate the
        /// <code>$LATEST</code> version as well as any numbered version.</p>
        pub fn v1_bot_version(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.v1_bot_version(input);
            self
        }
        pub fn set_v1_bot_version(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_v1_bot_version(input);
            self
        }
        /// <p>The name of the Amazon Lex V2 bot that you are migrating the Amazon Lex V1 bot to. </p>
        /// <ul>
        /// <li>
        /// <p>If the Amazon Lex V2 bot doesn't exist, you must use the
        /// <code>CREATE_NEW</code> migration strategy.</p>
        /// </li>
        /// <li>
        /// <p>If the Amazon Lex V2 bot exists, you must use the
        /// <code>UPDATE_EXISTING</code> migration strategy to change the
        /// contents of the Amazon Lex V2 bot.</p>
        /// </li>
        /// </ul>
        pub fn v2_bot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.v2_bot_name(input);
            self
        }
        pub fn set_v2_bot_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_v2_bot_name(input);
            self
        }
        /// <p>The IAM role that Amazon Lex uses to run the Amazon Lex V2 bot.</p>
        pub fn v2_bot_role(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.v2_bot_role(input);
            self
        }
        pub fn set_v2_bot_role(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_v2_bot_role(input);
            self
        }
        /// <p>The strategy used to conduct the migration.</p>
        /// <ul>
        /// <li>
        /// <p>
        /// <code>CREATE_NEW</code> - Creates a new Amazon Lex V2 bot and migrates
        /// the Amazon Lex V1 bot to the new bot.</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>UPDATE_EXISTING</code> - Overwrites the existing Amazon Lex V2 bot
        /// metadata and the locale being migrated. It doesn't change any other
        /// locales in the Amazon Lex V2 bot. If the locale doesn't exist, a new locale
        /// is created in the Amazon Lex V2 bot.</p>
        /// </li>
        /// </ul>
        pub fn migration_strategy(mut self, input: crate::model::MigrationStrategy) -> Self {
            self.inner = self.inner.migration_strategy(input);
            self
        }
        pub fn set_migration_strategy(
            mut self,
            input: std::option::Option<crate::model::MigrationStrategy>,
        ) -> Self {
            self.inner = self.inner.set_migration_strategy(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct TagResource<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::tag_resource_input::Builder,
    }
    impl<C> TagResource<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::TagResourceOutput,
            smithy_http::result::SdkError<crate::error::TagResourceError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The Amazon Resource Name (ARN) of the bot, bot alias, or bot channel
        /// to tag.</p>
        pub fn resource_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_arn(input);
            self
        }
        pub fn set_resource_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_arn(input);
            self
        }
        /// <p>A list of tag keys to add to the resource. If a tag key already
        /// exists, the existing value is replaced with the new value.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct UntagResource<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::untag_resource_input::Builder,
    }
    impl<C> UntagResource<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::UntagResourceOutput,
            smithy_http::result::SdkError<crate::error::UntagResourceError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The Amazon Resource Name (ARN) of the resource to remove the tags
        /// from.</p>
        pub fn resource_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_arn(input);
            self
        }
        pub fn set_resource_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_arn(input);
            self
        }
        /// <p>A list of tag keys to remove from the resource. If a tag key does not
        /// exist on the resource, it is ignored.</p>
        pub fn tag_keys(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.tag_keys(inp);
            self
        }
        pub fn set_tag_keys(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_tag_keys(input);
            self
        }
    }
}
