// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
/// <p>
/// The <code>AcceptQualificationRequest</code> operation approves a Worker's request for a Qualification.
/// </p>
/// <p>
/// Only the owner of the Qualification type can grant a Qualification request for that  type.
/// </p>
/// <p>
/// A successful request for the <code>AcceptQualificationRequest</code> operation
/// returns with no errors and an empty body.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AcceptQualificationRequest {
    _private: (),
}
impl AcceptQualificationRequest {
    /// Creates a new builder-style object to manufacture [`AcceptQualificationRequestInput`](crate::input::AcceptQualificationRequestInput)
    pub fn builder() -> crate::input::accept_qualification_request_input::Builder {
        crate::input::accept_qualification_request_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AcceptQualificationRequest {
    type Output = std::result::Result<
        crate::output::AcceptQualificationRequestOutput,
        crate::error::AcceptQualificationRequestError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_accept_qualification_request_error(response)
        } else {
            crate::operation_deser::parse_accept_qualification_request_response(response)
        }
    }
}

/// <p>
/// The <code>ApproveAssignment</code> operation approves the results of a completed assignment.
/// </p>
/// <p>
/// Approving an assignment initiates two payments from the Requester's Amazon.com account
/// </p>
/// <ul>
/// <li>
/// <p>
/// The Worker who submitted the results is paid the reward specified in the HIT.
/// </p>
/// </li>
/// <li>
/// <p>
/// Amazon Mechanical Turk fees are debited.
/// </p>
/// </li>
/// </ul>
/// <p>
/// If the Requester's account does not have adequate funds for these payments,
/// the call to ApproveAssignment returns an exception, and the approval is not processed.
/// You can include an optional feedback message with the approval,
/// which the Worker can see in the Status section of the web site.
/// </p>
/// <p>
/// You can also call this operation for assignments that were previous rejected
/// and approve them by explicitly overriding the previous rejection.
/// This only works on rejected assignments that were submitted within the previous 30 days
/// and only if the assignment's related HIT has not been deleted.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ApproveAssignment {
    _private: (),
}
impl ApproveAssignment {
    /// Creates a new builder-style object to manufacture [`ApproveAssignmentInput`](crate::input::ApproveAssignmentInput)
    pub fn builder() -> crate::input::approve_assignment_input::Builder {
        crate::input::approve_assignment_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ApproveAssignment {
    type Output = std::result::Result<
        crate::output::ApproveAssignmentOutput,
        crate::error::ApproveAssignmentError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_approve_assignment_error(response)
        } else {
            crate::operation_deser::parse_approve_assignment_response(response)
        }
    }
}

/// <p>
/// The <code>AssociateQualificationWithWorker</code> operation gives a Worker a
/// Qualification. <code>AssociateQualificationWithWorker</code> does not require that the Worker
/// submit a Qualification request. It gives the Qualification directly to the Worker.
/// </p>
/// <p>
/// You can only assign a Qualification of a Qualification type that you created (using
/// the <code>CreateQualificationType</code> operation).
/// </p>
/// <note>
/// <p>
/// Note: <code>AssociateQualificationWithWorker</code> does not affect any pending Qualification
/// requests for the Qualification by the Worker. If you assign a Qualification to a
/// Worker, then later grant a Qualification request made by the Worker, the granting of
/// the request may modify the Qualification score. To resolve a pending Qualification
/// request without affecting the Qualification the Worker already has, reject the
/// request with the <code>RejectQualificationRequest</code> operation.
/// </p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AssociateQualificationWithWorker {
    _private: (),
}
impl AssociateQualificationWithWorker {
    /// Creates a new builder-style object to manufacture [`AssociateQualificationWithWorkerInput`](crate::input::AssociateQualificationWithWorkerInput)
    pub fn builder() -> crate::input::associate_qualification_with_worker_input::Builder {
        crate::input::associate_qualification_with_worker_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AssociateQualificationWithWorker {
    type Output = std::result::Result<
        crate::output::AssociateQualificationWithWorkerOutput,
        crate::error::AssociateQualificationWithWorkerError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_associate_qualification_with_worker_error(response)
        } else {
            crate::operation_deser::parse_associate_qualification_with_worker_response(response)
        }
    }
}

/// <p>
/// The
/// <code>CreateAdditionalAssignmentsForHIT</code>
/// operation increases the maximum number of assignments of an existing HIT.
/// </p>
/// <p>
/// To extend the maximum number of assignments, specify the number of additional assignments.</p>
/// <note>
/// <ul>
/// <li>
/// <p>HITs created with fewer than 10 assignments cannot be extended to have 10 or more assignments. Attempting to add assignments in a way that brings the total number of assignments for a HIT from fewer than 10 assignments to 10 or more
/// assignments will result in an
/// <code>AWS.MechanicalTurk.InvalidMaximumAssignmentsIncrease</code>
/// exception.</p>
/// </li>
/// <li>
/// <p>HITs that were created before July 22, 2015 cannot be extended. Attempting to extend HITs that were created before July 22, 2015 will result in an
/// <code>AWS.MechanicalTurk.HITTooOldForExtension</code>
/// exception.
/// </p>
/// </li>
/// </ul>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateAdditionalAssignmentsForHIT {
    _private: (),
}
impl CreateAdditionalAssignmentsForHIT {
    /// Creates a new builder-style object to manufacture [`CreateAdditionalAssignmentsForHitInput`](crate::input::CreateAdditionalAssignmentsForHitInput)
    pub fn builder() -> crate::input::create_additional_assignments_for_hit_input::Builder {
        crate::input::create_additional_assignments_for_hit_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateAdditionalAssignmentsForHIT {
    type Output = std::result::Result<
        crate::output::CreateAdditionalAssignmentsForHitOutput,
        crate::error::CreateAdditionalAssignmentsForHITError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_additional_assignments_for_hit_error(response)
        } else {
            crate::operation_deser::parse_create_additional_assignments_for_hit_response(response)
        }
    }
}

/// <p>The <code>CreateHIT</code> operation creates a new Human Intelligence Task (HIT).
/// The new HIT is made available for Workers to find and accept on the Amazon Mechanical
/// Turk website. </p>
/// <p>
/// This operation allows you to specify a new HIT by passing in values for the properties of the HIT, such as its title, reward amount and number of assignments. When you pass these values to <code>CreateHIT</code>, a new HIT is created for you, with a new <code>HITTypeID</code>. The HITTypeID can be used to create additional HITs in the future without needing to specify common parameters such as the title, description and reward amount each time.</p>
/// <p> An alternative way to create HITs is to first generate a HITTypeID using the <code>CreateHITType</code> operation and then call the <code>CreateHITWithHITType</code> operation. This is the recommended best practice for Requesters who are creating large numbers of HITs.
/// </p>
/// <p>CreateHIT also supports several ways to provide question data: by providing a value
/// for the <code>Question</code> parameter that fully specifies the contents of the HIT, or by providing
/// a <code>HitLayoutId</code> and associated <code>HitLayoutParameters</code>.
/// </p>
/// <note>
/// <p> If a HIT is created with 10 or more maximum assignments, there is an additional fee. For more information, see
/// <a href="https://requester.mturk.com/pricing">Amazon Mechanical Turk Pricing</a>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateHIT {
    _private: (),
}
impl CreateHIT {
    /// Creates a new builder-style object to manufacture [`CreateHitInput`](crate::input::CreateHitInput)
    pub fn builder() -> crate::input::create_hit_input::Builder {
        crate::input::create_hit_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateHIT {
    type Output = std::result::Result<crate::output::CreateHitOutput, crate::error::CreateHITError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_hit_error(response)
        } else {
            crate::operation_deser::parse_create_hit_response(response)
        }
    }
}

/// <p>
/// The <code>CreateHITType</code> operation creates a new HIT type. This operation
/// allows you to define a standard set of HIT properties to use when creating HITs.
/// If you register a HIT type with values that match an existing HIT type, the HIT type
/// ID of the existing type will be returned.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateHITType {
    _private: (),
}
impl CreateHITType {
    /// Creates a new builder-style object to manufacture [`CreateHitTypeInput`](crate::input::CreateHitTypeInput)
    pub fn builder() -> crate::input::create_hit_type_input::Builder {
        crate::input::create_hit_type_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateHITType {
    type Output =
        std::result::Result<crate::output::CreateHitTypeOutput, crate::error::CreateHITTypeError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_hit_type_error(response)
        } else {
            crate::operation_deser::parse_create_hit_type_response(response)
        }
    }
}

/// <p>
/// The <code>CreateHITWithHITType</code> operation creates a new Human Intelligence Task (HIT)
/// using an existing HITTypeID generated by the <code>CreateHITType</code> operation.
/// </p>
/// <p>
/// This is an alternative way to create HITs from the <code>CreateHIT</code> operation.
/// This is the recommended best practice for Requesters who are creating large numbers of HITs.
/// </p>
/// <p>CreateHITWithHITType also supports several ways to provide question data:
/// by providing a value for the <code>Question</code> parameter that fully specifies the contents of the HIT,
/// or by providing a <code>HitLayoutId</code> and associated <code>HitLayoutParameters</code>.
/// </p>
/// <note>
/// <p>
/// If a HIT is created with 10 or more maximum assignments, there is an additional fee.
/// For more information, see <a href="https://requester.mturk.com/pricing">Amazon Mechanical Turk Pricing</a>.
/// </p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateHITWithHITType {
    _private: (),
}
impl CreateHITWithHITType {
    /// Creates a new builder-style object to manufacture [`CreateHitWithHitTypeInput`](crate::input::CreateHitWithHitTypeInput)
    pub fn builder() -> crate::input::create_hit_with_hit_type_input::Builder {
        crate::input::create_hit_with_hit_type_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateHITWithHITType {
    type Output = std::result::Result<
        crate::output::CreateHitWithHitTypeOutput,
        crate::error::CreateHITWithHITTypeError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_hit_with_hit_type_error(response)
        } else {
            crate::operation_deser::parse_create_hit_with_hit_type_response(response)
        }
    }
}

/// <p>
/// The
/// <code>CreateQualificationType</code>
/// operation creates a new Qualification type, which is represented by a
/// <code>QualificationType</code>
/// data structure.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateQualificationType {
    _private: (),
}
impl CreateQualificationType {
    /// Creates a new builder-style object to manufacture [`CreateQualificationTypeInput`](crate::input::CreateQualificationTypeInput)
    pub fn builder() -> crate::input::create_qualification_type_input::Builder {
        crate::input::create_qualification_type_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateQualificationType {
    type Output = std::result::Result<
        crate::output::CreateQualificationTypeOutput,
        crate::error::CreateQualificationTypeError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_qualification_type_error(response)
        } else {
            crate::operation_deser::parse_create_qualification_type_response(response)
        }
    }
}

/// <p>The <code>CreateWorkerBlock</code> operation allows you to prevent a Worker from working on your HITs. For example, you can block a Worker who is producing poor quality work. You can block up to 100,000 Workers.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateWorkerBlock {
    _private: (),
}
impl CreateWorkerBlock {
    /// Creates a new builder-style object to manufacture [`CreateWorkerBlockInput`](crate::input::CreateWorkerBlockInput)
    pub fn builder() -> crate::input::create_worker_block_input::Builder {
        crate::input::create_worker_block_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateWorkerBlock {
    type Output = std::result::Result<
        crate::output::CreateWorkerBlockOutput,
        crate::error::CreateWorkerBlockError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_worker_block_error(response)
        } else {
            crate::operation_deser::parse_create_worker_block_response(response)
        }
    }
}

/// <p>
/// The <code>DeleteHIT</code> operation is used to delete HIT that is no longer needed.
/// Only the Requester who created the HIT can delete it.
/// </p>
/// <p>
/// You can only dispose of HITs that are in the <code>Reviewable</code> state,
/// with all of their submitted assignments already either approved or rejected.
/// If you call the DeleteHIT operation on a HIT that is not in the <code>Reviewable</code> state
/// (for example, that has not expired, or still has active assignments),
/// or on a HIT that is Reviewable but without all of its submitted assignments
/// already approved or rejected, the service will return an error.
/// </p>
/// <note>
/// <ul>
/// <li>
/// <p>
/// HITs are automatically disposed of after 120 days.
/// </p>
/// </li>
/// <li>
/// <p>
/// After you dispose of a HIT, you can no longer approve the HIT's rejected assignments.
/// </p>
/// </li>
/// <li>
/// <p>
/// Disposed HITs are not returned in results for the ListHITs operation.
/// </p>
/// </li>
/// <li>
/// <p>
/// Disposing HITs can improve the performance of operations such as ListReviewableHITs and ListHITs.
/// </p>
/// </li>
/// </ul>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteHIT {
    _private: (),
}
impl DeleteHIT {
    /// Creates a new builder-style object to manufacture [`DeleteHitInput`](crate::input::DeleteHitInput)
    pub fn builder() -> crate::input::delete_hit_input::Builder {
        crate::input::delete_hit_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteHIT {
    type Output = std::result::Result<crate::output::DeleteHitOutput, crate::error::DeleteHITError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_hit_error(response)
        } else {
            crate::operation_deser::parse_delete_hit_response(response)
        }
    }
}

/// <p>
/// The
/// <code>DeleteQualificationType</code>
/// deletes a Qualification type and deletes any HIT types that are
/// associated with the Qualification type.
/// </p>
/// <p>This operation does not revoke Qualifications already assigned
/// to Workers because the Qualifications might be needed for active HITs.
/// If there are any pending requests for the Qualification type, Amazon
/// Mechanical Turk rejects those requests. After you delete a
/// Qualification type, you can no longer use it to create HITs or HIT
/// types.</p>
/// <note>
/// <p>DeleteQualificationType must wait for all the HITs that use
/// the deleted Qualification type to be deleted before completing. It
/// may take up to 48 hours before DeleteQualificationType completes and
/// the unique name of the Qualification type is available for reuse with
/// CreateQualificationType.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteQualificationType {
    _private: (),
}
impl DeleteQualificationType {
    /// Creates a new builder-style object to manufacture [`DeleteQualificationTypeInput`](crate::input::DeleteQualificationTypeInput)
    pub fn builder() -> crate::input::delete_qualification_type_input::Builder {
        crate::input::delete_qualification_type_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteQualificationType {
    type Output = std::result::Result<
        crate::output::DeleteQualificationTypeOutput,
        crate::error::DeleteQualificationTypeError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_qualification_type_error(response)
        } else {
            crate::operation_deser::parse_delete_qualification_type_response(response)
        }
    }
}

/// <p>The <code>DeleteWorkerBlock</code> operation allows you to reinstate a blocked Worker to work on your HITs. This operation reverses the effects of the CreateWorkerBlock operation. You need the Worker ID to use this operation. If the Worker ID is missing or invalid, this operation fails and returns the message “WorkerId is invalid.” If the specified Worker is not blocked, this operation returns successfully.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteWorkerBlock {
    _private: (),
}
impl DeleteWorkerBlock {
    /// Creates a new builder-style object to manufacture [`DeleteWorkerBlockInput`](crate::input::DeleteWorkerBlockInput)
    pub fn builder() -> crate::input::delete_worker_block_input::Builder {
        crate::input::delete_worker_block_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteWorkerBlock {
    type Output = std::result::Result<
        crate::output::DeleteWorkerBlockOutput,
        crate::error::DeleteWorkerBlockError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_worker_block_error(response)
        } else {
            crate::operation_deser::parse_delete_worker_block_response(response)
        }
    }
}

/// <p>
/// The   <code>DisassociateQualificationFromWorker</code>
/// revokes a previously granted Qualification from a user.
/// </p>
/// <p>
/// You can provide a text message explaining why the Qualification was
/// revoked. The user who had the Qualification can see this message.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DisassociateQualificationFromWorker {
    _private: (),
}
impl DisassociateQualificationFromWorker {
    /// Creates a new builder-style object to manufacture [`DisassociateQualificationFromWorkerInput`](crate::input::DisassociateQualificationFromWorkerInput)
    pub fn builder() -> crate::input::disassociate_qualification_from_worker_input::Builder {
        crate::input::disassociate_qualification_from_worker_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DisassociateQualificationFromWorker {
    type Output = std::result::Result<
        crate::output::DisassociateQualificationFromWorkerOutput,
        crate::error::DisassociateQualificationFromWorkerError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_disassociate_qualification_from_worker_error(response)
        } else {
            crate::operation_deser::parse_disassociate_qualification_from_worker_response(response)
        }
    }
}

/// <p>The <code>GetAccountBalance</code> operation retrieves the Prepaid HITs balance in your Amazon Mechanical Turk account if you are a Prepaid Requester.
/// Alternatively, this operation will retrieve the remaining available AWS Billing usage if you have enabled AWS Billing.
/// Note: If you have enabled AWS Billing and still have a remaining Prepaid HITs balance, this balance can be viewed on the My Account page in the Requester console.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetAccountBalance {
    _private: (),
}
impl GetAccountBalance {
    /// Creates a new builder-style object to manufacture [`GetAccountBalanceInput`](crate::input::GetAccountBalanceInput)
    pub fn builder() -> crate::input::get_account_balance_input::Builder {
        crate::input::get_account_balance_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetAccountBalance {
    type Output = std::result::Result<
        crate::output::GetAccountBalanceOutput,
        crate::error::GetAccountBalanceError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_account_balance_error(response)
        } else {
            crate::operation_deser::parse_get_account_balance_response(response)
        }
    }
}

/// <p>
/// The <code>GetAssignment</code> operation retrieves the details of the specified Assignment.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetAssignment {
    _private: (),
}
impl GetAssignment {
    /// Creates a new builder-style object to manufacture [`GetAssignmentInput`](crate::input::GetAssignmentInput)
    pub fn builder() -> crate::input::get_assignment_input::Builder {
        crate::input::get_assignment_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetAssignment {
    type Output =
        std::result::Result<crate::output::GetAssignmentOutput, crate::error::GetAssignmentError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_assignment_error(response)
        } else {
            crate::operation_deser::parse_get_assignment_response(response)
        }
    }
}

/// <p>
/// The
/// <code>GetFileUploadURL</code>
/// operation generates and returns a temporary URL. You use the
/// temporary URL to retrieve a file uploaded by a Worker as an answer to
/// a FileUploadAnswer question for a HIT. The temporary URL is generated
/// the instant the GetFileUploadURL operation is called, and is valid
/// for 60 seconds. You can get a temporary file upload URL any time
/// until the HIT is disposed. After the HIT is disposed, any uploaded
/// files are deleted, and cannot be retrieved.
/// Pending Deprecation on December 12, 2017. The Answer Specification  
/// structure will no longer  support the <code>FileUploadAnswer</code>
/// element to be used for the QuestionForm data structure.
/// Instead, we recommend that Requesters who want to create HITs asking
/// Workers to upload files to use Amazon S3.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetFileUploadURL {
    _private: (),
}
impl GetFileUploadURL {
    /// Creates a new builder-style object to manufacture [`GetFileUploadUrlInput`](crate::input::GetFileUploadUrlInput)
    pub fn builder() -> crate::input::get_file_upload_url_input::Builder {
        crate::input::get_file_upload_url_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetFileUploadURL {
    type Output = std::result::Result<
        crate::output::GetFileUploadUrlOutput,
        crate::error::GetFileUploadURLError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_file_upload_url_error(response)
        } else {
            crate::operation_deser::parse_get_file_upload_url_response(response)
        }
    }
}

/// <p>
/// The <code>GetHIT</code> operation retrieves the details of the specified HIT.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetHIT {
    _private: (),
}
impl GetHIT {
    /// Creates a new builder-style object to manufacture [`GetHitInput`](crate::input::GetHitInput)
    pub fn builder() -> crate::input::get_hit_input::Builder {
        crate::input::get_hit_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetHIT {
    type Output = std::result::Result<crate::output::GetHitOutput, crate::error::GetHITError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_hit_error(response)
        } else {
            crate::operation_deser::parse_get_hit_response(response)
        }
    }
}

/// <p>
/// The
/// <code>GetQualificationScore</code>
/// operation returns the value of a Worker's Qualification for a given
/// Qualification type.
/// </p>
/// <p>
/// To get a Worker's Qualification, you must know the Worker's ID. The
/// Worker's ID is included in the assignment data returned by the
/// <code>ListAssignmentsForHIT</code>
/// operation.
/// </p>
/// <p>Only the owner of a Qualification type can query the value of
/// a Worker's Qualification of that type.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetQualificationScore {
    _private: (),
}
impl GetQualificationScore {
    /// Creates a new builder-style object to manufacture [`GetQualificationScoreInput`](crate::input::GetQualificationScoreInput)
    pub fn builder() -> crate::input::get_qualification_score_input::Builder {
        crate::input::get_qualification_score_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetQualificationScore {
    type Output = std::result::Result<
        crate::output::GetQualificationScoreOutput,
        crate::error::GetQualificationScoreError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_qualification_score_error(response)
        } else {
            crate::operation_deser::parse_get_qualification_score_response(response)
        }
    }
}

/// <p>
/// The <code>GetQualificationType</code>operation retrieves information about a Qualification type using its ID.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetQualificationType {
    _private: (),
}
impl GetQualificationType {
    /// Creates a new builder-style object to manufacture [`GetQualificationTypeInput`](crate::input::GetQualificationTypeInput)
    pub fn builder() -> crate::input::get_qualification_type_input::Builder {
        crate::input::get_qualification_type_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetQualificationType {
    type Output = std::result::Result<
        crate::output::GetQualificationTypeOutput,
        crate::error::GetQualificationTypeError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_qualification_type_error(response)
        } else {
            crate::operation_deser::parse_get_qualification_type_response(response)
        }
    }
}

/// <p>
/// The
/// <code>ListAssignmentsForHIT</code>
/// operation retrieves completed assignments for a HIT. You can use this
/// operation to retrieve the results for a HIT.
/// </p>
/// <p> You can get assignments for a HIT at any time, even if the
/// HIT is not yet Reviewable. If a HIT requested multiple assignments,
/// and has received some results but has not yet become Reviewable, you
/// can still retrieve the partial results with this operation.
/// </p>
/// <p> Use the AssignmentStatus parameter to control which set of
/// assignments for a HIT are returned. The ListAssignmentsForHIT
/// operation
/// can return submitted assignments awaiting approval, or it can return
/// assignments that have already been approved or rejected. You can set
/// AssignmentStatus=Approved,Rejected to get assignments that have
/// already been approved and rejected together in one result set.
/// </p>
/// <p> Only the Requester who created the HIT can retrieve the
/// assignments for that HIT.
/// </p>
/// <p> Results are sorted and divided into numbered pages and the
/// operation returns a single page of results. You can use the
/// parameters
/// of the operation to control sorting and pagination.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListAssignmentsForHIT {
    _private: (),
}
impl ListAssignmentsForHIT {
    /// Creates a new builder-style object to manufacture [`ListAssignmentsForHitInput`](crate::input::ListAssignmentsForHitInput)
    pub fn builder() -> crate::input::list_assignments_for_hit_input::Builder {
        crate::input::list_assignments_for_hit_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListAssignmentsForHIT {
    type Output = std::result::Result<
        crate::output::ListAssignmentsForHitOutput,
        crate::error::ListAssignmentsForHITError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_assignments_for_hit_error(response)
        } else {
            crate::operation_deser::parse_list_assignments_for_hit_response(response)
        }
    }
}

/// <p>
/// The
/// <code>ListBonusPayments</code>
/// operation retrieves the amounts of bonuses you have paid to Workers
/// for a given HIT or assignment.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListBonusPayments {
    _private: (),
}
impl ListBonusPayments {
    /// Creates a new builder-style object to manufacture [`ListBonusPaymentsInput`](crate::input::ListBonusPaymentsInput)
    pub fn builder() -> crate::input::list_bonus_payments_input::Builder {
        crate::input::list_bonus_payments_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListBonusPayments {
    type Output = std::result::Result<
        crate::output::ListBonusPaymentsOutput,
        crate::error::ListBonusPaymentsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_bonus_payments_error(response)
        } else {
            crate::operation_deser::parse_list_bonus_payments_response(response)
        }
    }
}

/// <p>
/// The
/// <code>ListHITs</code>
/// operation returns all of a Requester's HITs. The operation returns
/// HITs of any status, except for HITs that have been deleted of with
/// the DeleteHIT operation or that have been auto-deleted.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListHITs {
    _private: (),
}
impl ListHITs {
    /// Creates a new builder-style object to manufacture [`ListHiTsInput`](crate::input::ListHiTsInput)
    pub fn builder() -> crate::input::list_hi_ts_input::Builder {
        crate::input::list_hi_ts_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListHITs {
    type Output = std::result::Result<crate::output::ListHiTsOutput, crate::error::ListHITsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_hi_ts_error(response)
        } else {
            crate::operation_deser::parse_list_hi_ts_response(response)
        }
    }
}

/// <p>
/// The <code>ListHITsForQualificationType</code> operation returns the HITs that use
/// the given Qualification type for a Qualification requirement.
/// The operation returns HITs of any status, except for HITs that have been deleted
/// with the <code>DeleteHIT</code> operation or that have been auto-deleted.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListHITsForQualificationType {
    _private: (),
}
impl ListHITsForQualificationType {
    /// Creates a new builder-style object to manufacture [`ListHiTsForQualificationTypeInput`](crate::input::ListHiTsForQualificationTypeInput)
    pub fn builder() -> crate::input::list_hi_ts_for_qualification_type_input::Builder {
        crate::input::list_hi_ts_for_qualification_type_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListHITsForQualificationType {
    type Output = std::result::Result<
        crate::output::ListHiTsForQualificationTypeOutput,
        crate::error::ListHITsForQualificationTypeError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_hi_ts_for_qualification_type_error(response)
        } else {
            crate::operation_deser::parse_list_hi_ts_for_qualification_type_response(response)
        }
    }
}

/// <p>
/// The
/// <code>ListQualificationRequests</code>
/// operation retrieves requests for Qualifications of a particular
/// Qualification type. The owner of the Qualification type calls this
/// operation to poll for pending requests, and accepts them using the
/// AcceptQualification operation.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListQualificationRequests {
    _private: (),
}
impl ListQualificationRequests {
    /// Creates a new builder-style object to manufacture [`ListQualificationRequestsInput`](crate::input::ListQualificationRequestsInput)
    pub fn builder() -> crate::input::list_qualification_requests_input::Builder {
        crate::input::list_qualification_requests_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListQualificationRequests {
    type Output = std::result::Result<
        crate::output::ListQualificationRequestsOutput,
        crate::error::ListQualificationRequestsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_qualification_requests_error(response)
        } else {
            crate::operation_deser::parse_list_qualification_requests_response(response)
        }
    }
}

/// <p>
/// The
/// <code>ListQualificationTypes</code>
/// operation returns a list of Qualification types, filtered by
/// an optional search term.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListQualificationTypes {
    _private: (),
}
impl ListQualificationTypes {
    /// Creates a new builder-style object to manufacture [`ListQualificationTypesInput`](crate::input::ListQualificationTypesInput)
    pub fn builder() -> crate::input::list_qualification_types_input::Builder {
        crate::input::list_qualification_types_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListQualificationTypes {
    type Output = std::result::Result<
        crate::output::ListQualificationTypesOutput,
        crate::error::ListQualificationTypesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_qualification_types_error(response)
        } else {
            crate::operation_deser::parse_list_qualification_types_response(response)
        }
    }
}

/// <p>
/// The <code>ListReviewableHITs</code> operation retrieves the HITs with Status equal to
/// Reviewable or Status equal to Reviewing that belong to the Requester calling the operation.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListReviewableHITs {
    _private: (),
}
impl ListReviewableHITs {
    /// Creates a new builder-style object to manufacture [`ListReviewableHiTsInput`](crate::input::ListReviewableHiTsInput)
    pub fn builder() -> crate::input::list_reviewable_hi_ts_input::Builder {
        crate::input::list_reviewable_hi_ts_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListReviewableHITs {
    type Output = std::result::Result<
        crate::output::ListReviewableHiTsOutput,
        crate::error::ListReviewableHITsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_reviewable_hi_ts_error(response)
        } else {
            crate::operation_deser::parse_list_reviewable_hi_ts_response(response)
        }
    }
}

/// <p>
/// The <code>ListReviewPolicyResultsForHIT</code> operation retrieves the computed results
/// and the actions taken in the course of executing your Review Policies for a given HIT.
/// For information about how to specify Review Policies when you call CreateHIT,
/// see Review Policies. The ListReviewPolicyResultsForHIT operation can return results for both
/// Assignment-level and HIT-level review results.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListReviewPolicyResultsForHIT {
    _private: (),
}
impl ListReviewPolicyResultsForHIT {
    /// Creates a new builder-style object to manufacture [`ListReviewPolicyResultsForHitInput`](crate::input::ListReviewPolicyResultsForHitInput)
    pub fn builder() -> crate::input::list_review_policy_results_for_hit_input::Builder {
        crate::input::list_review_policy_results_for_hit_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListReviewPolicyResultsForHIT {
    type Output = std::result::Result<
        crate::output::ListReviewPolicyResultsForHitOutput,
        crate::error::ListReviewPolicyResultsForHITError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_review_policy_results_for_hit_error(response)
        } else {
            crate::operation_deser::parse_list_review_policy_results_for_hit_response(response)
        }
    }
}

/// <p>The <code>ListWorkersBlocks</code> operation retrieves a list of Workers who are blocked from working on your HITs.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListWorkerBlocks {
    _private: (),
}
impl ListWorkerBlocks {
    /// Creates a new builder-style object to manufacture [`ListWorkerBlocksInput`](crate::input::ListWorkerBlocksInput)
    pub fn builder() -> crate::input::list_worker_blocks_input::Builder {
        crate::input::list_worker_blocks_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListWorkerBlocks {
    type Output = std::result::Result<
        crate::output::ListWorkerBlocksOutput,
        crate::error::ListWorkerBlocksError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_worker_blocks_error(response)
        } else {
            crate::operation_deser::parse_list_worker_blocks_response(response)
        }
    }
}

/// <p>
/// The <code>ListWorkersWithQualificationType</code> operation returns all of the Workers
/// that have been associated with a given Qualification type.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListWorkersWithQualificationType {
    _private: (),
}
impl ListWorkersWithQualificationType {
    /// Creates a new builder-style object to manufacture [`ListWorkersWithQualificationTypeInput`](crate::input::ListWorkersWithQualificationTypeInput)
    pub fn builder() -> crate::input::list_workers_with_qualification_type_input::Builder {
        crate::input::list_workers_with_qualification_type_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListWorkersWithQualificationType {
    type Output = std::result::Result<
        crate::output::ListWorkersWithQualificationTypeOutput,
        crate::error::ListWorkersWithQualificationTypeError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_workers_with_qualification_type_error(response)
        } else {
            crate::operation_deser::parse_list_workers_with_qualification_type_response(response)
        }
    }
}

/// <p>
/// The
/// <code>NotifyWorkers</code>
/// operation sends an email to one or more Workers that you specify with
/// the Worker ID. You can specify up to 100 Worker IDs to send the same
/// message with a single call to the NotifyWorkers operation. The
/// NotifyWorkers operation will send a notification email to a Worker
/// only if you have previously approved or rejected work from the
/// Worker.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct NotifyWorkers {
    _private: (),
}
impl NotifyWorkers {
    /// Creates a new builder-style object to manufacture [`NotifyWorkersInput`](crate::input::NotifyWorkersInput)
    pub fn builder() -> crate::input::notify_workers_input::Builder {
        crate::input::notify_workers_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for NotifyWorkers {
    type Output =
        std::result::Result<crate::output::NotifyWorkersOutput, crate::error::NotifyWorkersError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_notify_workers_error(response)
        } else {
            crate::operation_deser::parse_notify_workers_response(response)
        }
    }
}

/// <p>
/// The <code>RejectAssignment</code> operation rejects the results of a completed assignment.
/// </p>
/// <p>
/// You can include an optional feedback message with the rejection,
/// which the Worker can see in the Status section of the web site.
/// When you include a feedback message with the rejection,
/// it helps the Worker understand why the assignment was rejected,
/// and can improve the quality of the results the Worker submits in the future.
/// </p>
/// <p>
/// Only the Requester who created the HIT can reject an assignment for the HIT.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RejectAssignment {
    _private: (),
}
impl RejectAssignment {
    /// Creates a new builder-style object to manufacture [`RejectAssignmentInput`](crate::input::RejectAssignmentInput)
    pub fn builder() -> crate::input::reject_assignment_input::Builder {
        crate::input::reject_assignment_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RejectAssignment {
    type Output = std::result::Result<
        crate::output::RejectAssignmentOutput,
        crate::error::RejectAssignmentError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_reject_assignment_error(response)
        } else {
            crate::operation_deser::parse_reject_assignment_response(response)
        }
    }
}

/// <p>
/// The
/// <code>RejectQualificationRequest</code>
/// operation rejects a user's request for a Qualification.
/// </p>
/// <p> You can provide a text message explaining why the request was
/// rejected. The Worker who made the request can see this message.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RejectQualificationRequest {
    _private: (),
}
impl RejectQualificationRequest {
    /// Creates a new builder-style object to manufacture [`RejectQualificationRequestInput`](crate::input::RejectQualificationRequestInput)
    pub fn builder() -> crate::input::reject_qualification_request_input::Builder {
        crate::input::reject_qualification_request_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RejectQualificationRequest {
    type Output = std::result::Result<
        crate::output::RejectQualificationRequestOutput,
        crate::error::RejectQualificationRequestError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_reject_qualification_request_error(response)
        } else {
            crate::operation_deser::parse_reject_qualification_request_response(response)
        }
    }
}

/// <p>
/// The
/// <code>SendBonus</code>
/// operation issues a payment of money from your account to a Worker.
/// This payment happens separately from the reward you pay to the Worker
/// when you approve the Worker's assignment. The SendBonus operation
/// requires the Worker's ID and the assignment ID as parameters to
/// initiate payment of the bonus. You must include a message that
/// explains the reason for the bonus payment, as the Worker may not be
/// expecting the payment. Amazon Mechanical Turk collects a fee for
/// bonus payments, similar to the HIT listing fee. This operation fails
/// if your account does not have enough funds to pay for both the bonus
/// and the fees.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct SendBonus {
    _private: (),
}
impl SendBonus {
    /// Creates a new builder-style object to manufacture [`SendBonusInput`](crate::input::SendBonusInput)
    pub fn builder() -> crate::input::send_bonus_input::Builder {
        crate::input::send_bonus_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for SendBonus {
    type Output = std::result::Result<crate::output::SendBonusOutput, crate::error::SendBonusError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_send_bonus_error(response)
        } else {
            crate::operation_deser::parse_send_bonus_response(response)
        }
    }
}

/// <p>
/// The <code>SendTestEventNotification</code> operation causes Amazon Mechanical Turk to send
/// a notification message as if a HIT event occurred, according to the provided
/// notification specification. This allows you to test notifications without
/// setting up notifications for a real HIT type and trying to trigger them using the website.
/// When you call this operation, the service attempts to send the test notification immediately.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct SendTestEventNotification {
    _private: (),
}
impl SendTestEventNotification {
    /// Creates a new builder-style object to manufacture [`SendTestEventNotificationInput`](crate::input::SendTestEventNotificationInput)
    pub fn builder() -> crate::input::send_test_event_notification_input::Builder {
        crate::input::send_test_event_notification_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for SendTestEventNotification {
    type Output = std::result::Result<
        crate::output::SendTestEventNotificationOutput,
        crate::error::SendTestEventNotificationError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_send_test_event_notification_error(response)
        } else {
            crate::operation_deser::parse_send_test_event_notification_response(response)
        }
    }
}

/// <p>
/// The <code>UpdateExpirationForHIT</code> operation allows you update the expiration time of a HIT.
/// If you update it to a time in the past, the HIT will be immediately expired.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateExpirationForHIT {
    _private: (),
}
impl UpdateExpirationForHIT {
    /// Creates a new builder-style object to manufacture [`UpdateExpirationForHitInput`](crate::input::UpdateExpirationForHitInput)
    pub fn builder() -> crate::input::update_expiration_for_hit_input::Builder {
        crate::input::update_expiration_for_hit_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateExpirationForHIT {
    type Output = std::result::Result<
        crate::output::UpdateExpirationForHitOutput,
        crate::error::UpdateExpirationForHITError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_expiration_for_hit_error(response)
        } else {
            crate::operation_deser::parse_update_expiration_for_hit_response(response)
        }
    }
}

/// <p>
/// The <code>UpdateHITReviewStatus</code> operation updates the status of a HIT.
/// If the status is Reviewable, this operation can update the status to Reviewing,
/// or it can revert a Reviewing HIT back to the Reviewable status.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateHITReviewStatus {
    _private: (),
}
impl UpdateHITReviewStatus {
    /// Creates a new builder-style object to manufacture [`UpdateHitReviewStatusInput`](crate::input::UpdateHitReviewStatusInput)
    pub fn builder() -> crate::input::update_hit_review_status_input::Builder {
        crate::input::update_hit_review_status_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateHITReviewStatus {
    type Output = std::result::Result<
        crate::output::UpdateHitReviewStatusOutput,
        crate::error::UpdateHITReviewStatusError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_hit_review_status_error(response)
        } else {
            crate::operation_deser::parse_update_hit_review_status_response(response)
        }
    }
}

/// <p>
/// The
/// <code>UpdateHITTypeOfHIT</code>
/// operation allows you to change the HITType properties of a HIT. This
/// operation disassociates the HIT from its old HITType properties and
/// associates it with the new HITType properties. The HIT takes on the
/// properties of the new HITType in place of the old ones.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateHITTypeOfHIT {
    _private: (),
}
impl UpdateHITTypeOfHIT {
    /// Creates a new builder-style object to manufacture [`UpdateHitTypeOfHitInput`](crate::input::UpdateHitTypeOfHitInput)
    pub fn builder() -> crate::input::update_hit_type_of_hit_input::Builder {
        crate::input::update_hit_type_of_hit_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateHITTypeOfHIT {
    type Output = std::result::Result<
        crate::output::UpdateHitTypeOfHitOutput,
        crate::error::UpdateHITTypeOfHITError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_hit_type_of_hit_error(response)
        } else {
            crate::operation_deser::parse_update_hit_type_of_hit_response(response)
        }
    }
}

/// <p>
/// The <code>UpdateNotificationSettings</code> operation creates, updates,
/// disables or re-enables notifications for a HIT type.
/// If you call the UpdateNotificationSettings operation for a HIT type that already has a
/// notification specification, the operation replaces the old specification with a new one.
/// You can call the UpdateNotificationSettings operation to enable or disable notifications
/// for the HIT type, without having to modify the notification specification itself by providing
/// updates to the Active status without specifying a new notification specification.
/// To change the Active status of a HIT type's notifications,
/// the HIT type must already have a notification specification,
/// or one must be provided in the same call to <code>UpdateNotificationSettings</code>.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateNotificationSettings {
    _private: (),
}
impl UpdateNotificationSettings {
    /// Creates a new builder-style object to manufacture [`UpdateNotificationSettingsInput`](crate::input::UpdateNotificationSettingsInput)
    pub fn builder() -> crate::input::update_notification_settings_input::Builder {
        crate::input::update_notification_settings_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateNotificationSettings {
    type Output = std::result::Result<
        crate::output::UpdateNotificationSettingsOutput,
        crate::error::UpdateNotificationSettingsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_notification_settings_error(response)
        } else {
            crate::operation_deser::parse_update_notification_settings_response(response)
        }
    }
}

/// <p>
/// The
/// <code>UpdateQualificationType</code>
/// operation modifies the attributes of an existing Qualification type,
/// which is represented by a QualificationType data structure. Only the
/// owner of a Qualification type can modify its attributes.
/// </p>
/// <p> Most attributes of a Qualification type can be changed after
/// the type has been created. However, the Name and Keywords fields
/// cannot be modified. The RetryDelayInSeconds parameter can be modified
/// or added to change the delay or to enable retries, but
/// RetryDelayInSeconds cannot be used to disable retries. </p>
/// <p> You can use this operation to update the test for a
/// Qualification type. The test is updated based on the values specified
/// for the Test, TestDurationInSeconds and AnswerKey parameters. All
/// three parameters specify the updated test. If you are updating the
/// test for a type, you must specify the Test and TestDurationInSeconds
/// parameters. The AnswerKey parameter is optional; omitting it specifies
/// that the updated test does not have an answer key. </p>
/// <p> If you omit the Test parameter, the test for the
/// Qualification type is unchanged. There is no way to remove a test from
/// a Qualification type that has one. If the type already has a test, you
/// cannot update it to be AutoGranted. If the Qualification type does not
/// have a test and one is provided by an update, the type will henceforth
/// have a test. </p>
/// <p> If you want to update the test duration or answer key for an
/// existing test without changing the questions, you must specify a Test
/// parameter with the original questions, along with the updated values. </p>
/// <p> If you provide an updated Test but no AnswerKey, the new test
/// will not have an answer key. Requests for such Qualifications must be
/// granted manually. </p>
/// <p> You can also update the AutoGranted and AutoGrantedValue
/// attributes of the Qualification type.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateQualificationType {
    _private: (),
}
impl UpdateQualificationType {
    /// Creates a new builder-style object to manufacture [`UpdateQualificationTypeInput`](crate::input::UpdateQualificationTypeInput)
    pub fn builder() -> crate::input::update_qualification_type_input::Builder {
        crate::input::update_qualification_type_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateQualificationType {
    type Output = std::result::Result<
        crate::output::UpdateQualificationTypeOutput,
        crate::error::UpdateQualificationTypeError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_qualification_type_error(response)
        } else {
            crate::operation_deser::parse_update_qualification_type_response(response)
        }
    }
}
