// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
#[derive(std::fmt::Debug)]
pub(crate) struct Handle<C = aws_hyper::DynConnector> {
    client: aws_hyper::Client<C>,
    conf: crate::Config,
}

#[derive(Clone, std::fmt::Debug)]
pub struct Client<C = aws_hyper::DynConnector> {
    handle: std::sync::Arc<Handle<C>>,
}
impl<C> Client<C> {
    pub fn from_conf_conn(conf: crate::Config, conn: C) -> Self {
        let client = aws_hyper::Client::new(conn);
        Self {
            handle: std::sync::Arc::new(Handle { client, conf }),
        }
    }

    pub fn conf(&self) -> &crate::Config {
        &self.handle.conf
    }
}
impl Client {
    #[cfg(any(feature = "rustls", feature = "native-tls"))]
    pub fn from_env() -> Self {
        Self::from_conf(crate::Config::builder().build())
    }

    #[cfg(any(feature = "rustls", feature = "native-tls"))]
    pub fn from_conf(conf: crate::Config) -> Self {
        let client = aws_hyper::Client::https();
        Self {
            handle: std::sync::Arc::new(Handle { client, conf }),
        }
    }
}
impl<C> Client<C>
where
    C: aws_hyper::SmithyConnector,
{
    pub fn add_tags_to_resource(&self) -> fluent_builders::AddTagsToResource<C> {
        fluent_builders::AddTagsToResource::new(self.handle.clone())
    }
    pub fn authorize_cache_security_group_ingress(
        &self,
    ) -> fluent_builders::AuthorizeCacheSecurityGroupIngress<C> {
        fluent_builders::AuthorizeCacheSecurityGroupIngress::new(self.handle.clone())
    }
    pub fn batch_apply_update_action(&self) -> fluent_builders::BatchApplyUpdateAction<C> {
        fluent_builders::BatchApplyUpdateAction::new(self.handle.clone())
    }
    pub fn batch_stop_update_action(&self) -> fluent_builders::BatchStopUpdateAction<C> {
        fluent_builders::BatchStopUpdateAction::new(self.handle.clone())
    }
    pub fn complete_migration(&self) -> fluent_builders::CompleteMigration<C> {
        fluent_builders::CompleteMigration::new(self.handle.clone())
    }
    pub fn copy_snapshot(&self) -> fluent_builders::CopySnapshot<C> {
        fluent_builders::CopySnapshot::new(self.handle.clone())
    }
    pub fn create_cache_cluster(&self) -> fluent_builders::CreateCacheCluster<C> {
        fluent_builders::CreateCacheCluster::new(self.handle.clone())
    }
    pub fn create_cache_parameter_group(&self) -> fluent_builders::CreateCacheParameterGroup<C> {
        fluent_builders::CreateCacheParameterGroup::new(self.handle.clone())
    }
    pub fn create_cache_security_group(&self) -> fluent_builders::CreateCacheSecurityGroup<C> {
        fluent_builders::CreateCacheSecurityGroup::new(self.handle.clone())
    }
    pub fn create_cache_subnet_group(&self) -> fluent_builders::CreateCacheSubnetGroup<C> {
        fluent_builders::CreateCacheSubnetGroup::new(self.handle.clone())
    }
    pub fn create_global_replication_group(
        &self,
    ) -> fluent_builders::CreateGlobalReplicationGroup<C> {
        fluent_builders::CreateGlobalReplicationGroup::new(self.handle.clone())
    }
    pub fn create_replication_group(&self) -> fluent_builders::CreateReplicationGroup<C> {
        fluent_builders::CreateReplicationGroup::new(self.handle.clone())
    }
    pub fn create_snapshot(&self) -> fluent_builders::CreateSnapshot<C> {
        fluent_builders::CreateSnapshot::new(self.handle.clone())
    }
    pub fn create_user(&self) -> fluent_builders::CreateUser<C> {
        fluent_builders::CreateUser::new(self.handle.clone())
    }
    pub fn create_user_group(&self) -> fluent_builders::CreateUserGroup<C> {
        fluent_builders::CreateUserGroup::new(self.handle.clone())
    }
    pub fn decrease_node_groups_in_global_replication_group(
        &self,
    ) -> fluent_builders::DecreaseNodeGroupsInGlobalReplicationGroup<C> {
        fluent_builders::DecreaseNodeGroupsInGlobalReplicationGroup::new(self.handle.clone())
    }
    pub fn decrease_replica_count(&self) -> fluent_builders::DecreaseReplicaCount<C> {
        fluent_builders::DecreaseReplicaCount::new(self.handle.clone())
    }
    pub fn delete_cache_cluster(&self) -> fluent_builders::DeleteCacheCluster<C> {
        fluent_builders::DeleteCacheCluster::new(self.handle.clone())
    }
    pub fn delete_cache_parameter_group(&self) -> fluent_builders::DeleteCacheParameterGroup<C> {
        fluent_builders::DeleteCacheParameterGroup::new(self.handle.clone())
    }
    pub fn delete_cache_security_group(&self) -> fluent_builders::DeleteCacheSecurityGroup<C> {
        fluent_builders::DeleteCacheSecurityGroup::new(self.handle.clone())
    }
    pub fn delete_cache_subnet_group(&self) -> fluent_builders::DeleteCacheSubnetGroup<C> {
        fluent_builders::DeleteCacheSubnetGroup::new(self.handle.clone())
    }
    pub fn delete_global_replication_group(
        &self,
    ) -> fluent_builders::DeleteGlobalReplicationGroup<C> {
        fluent_builders::DeleteGlobalReplicationGroup::new(self.handle.clone())
    }
    pub fn delete_replication_group(&self) -> fluent_builders::DeleteReplicationGroup<C> {
        fluent_builders::DeleteReplicationGroup::new(self.handle.clone())
    }
    pub fn delete_snapshot(&self) -> fluent_builders::DeleteSnapshot<C> {
        fluent_builders::DeleteSnapshot::new(self.handle.clone())
    }
    pub fn delete_user(&self) -> fluent_builders::DeleteUser<C> {
        fluent_builders::DeleteUser::new(self.handle.clone())
    }
    pub fn delete_user_group(&self) -> fluent_builders::DeleteUserGroup<C> {
        fluent_builders::DeleteUserGroup::new(self.handle.clone())
    }
    pub fn describe_cache_clusters(&self) -> fluent_builders::DescribeCacheClusters<C> {
        fluent_builders::DescribeCacheClusters::new(self.handle.clone())
    }
    pub fn describe_cache_engine_versions(
        &self,
    ) -> fluent_builders::DescribeCacheEngineVersions<C> {
        fluent_builders::DescribeCacheEngineVersions::new(self.handle.clone())
    }
    pub fn describe_cache_parameter_groups(
        &self,
    ) -> fluent_builders::DescribeCacheParameterGroups<C> {
        fluent_builders::DescribeCacheParameterGroups::new(self.handle.clone())
    }
    pub fn describe_cache_parameters(&self) -> fluent_builders::DescribeCacheParameters<C> {
        fluent_builders::DescribeCacheParameters::new(self.handle.clone())
    }
    pub fn describe_cache_security_groups(
        &self,
    ) -> fluent_builders::DescribeCacheSecurityGroups<C> {
        fluent_builders::DescribeCacheSecurityGroups::new(self.handle.clone())
    }
    pub fn describe_cache_subnet_groups(&self) -> fluent_builders::DescribeCacheSubnetGroups<C> {
        fluent_builders::DescribeCacheSubnetGroups::new(self.handle.clone())
    }
    pub fn describe_engine_default_parameters(
        &self,
    ) -> fluent_builders::DescribeEngineDefaultParameters<C> {
        fluent_builders::DescribeEngineDefaultParameters::new(self.handle.clone())
    }
    pub fn describe_events(&self) -> fluent_builders::DescribeEvents<C> {
        fluent_builders::DescribeEvents::new(self.handle.clone())
    }
    pub fn describe_global_replication_groups(
        &self,
    ) -> fluent_builders::DescribeGlobalReplicationGroups<C> {
        fluent_builders::DescribeGlobalReplicationGroups::new(self.handle.clone())
    }
    pub fn describe_replication_groups(&self) -> fluent_builders::DescribeReplicationGroups<C> {
        fluent_builders::DescribeReplicationGroups::new(self.handle.clone())
    }
    pub fn describe_reserved_cache_nodes(&self) -> fluent_builders::DescribeReservedCacheNodes<C> {
        fluent_builders::DescribeReservedCacheNodes::new(self.handle.clone())
    }
    pub fn describe_reserved_cache_nodes_offerings(
        &self,
    ) -> fluent_builders::DescribeReservedCacheNodesOfferings<C> {
        fluent_builders::DescribeReservedCacheNodesOfferings::new(self.handle.clone())
    }
    pub fn describe_service_updates(&self) -> fluent_builders::DescribeServiceUpdates<C> {
        fluent_builders::DescribeServiceUpdates::new(self.handle.clone())
    }
    pub fn describe_snapshots(&self) -> fluent_builders::DescribeSnapshots<C> {
        fluent_builders::DescribeSnapshots::new(self.handle.clone())
    }
    pub fn describe_update_actions(&self) -> fluent_builders::DescribeUpdateActions<C> {
        fluent_builders::DescribeUpdateActions::new(self.handle.clone())
    }
    pub fn describe_user_groups(&self) -> fluent_builders::DescribeUserGroups<C> {
        fluent_builders::DescribeUserGroups::new(self.handle.clone())
    }
    pub fn describe_users(&self) -> fluent_builders::DescribeUsers<C> {
        fluent_builders::DescribeUsers::new(self.handle.clone())
    }
    pub fn disassociate_global_replication_group(
        &self,
    ) -> fluent_builders::DisassociateGlobalReplicationGroup<C> {
        fluent_builders::DisassociateGlobalReplicationGroup::new(self.handle.clone())
    }
    pub fn failover_global_replication_group(
        &self,
    ) -> fluent_builders::FailoverGlobalReplicationGroup<C> {
        fluent_builders::FailoverGlobalReplicationGroup::new(self.handle.clone())
    }
    pub fn increase_node_groups_in_global_replication_group(
        &self,
    ) -> fluent_builders::IncreaseNodeGroupsInGlobalReplicationGroup<C> {
        fluent_builders::IncreaseNodeGroupsInGlobalReplicationGroup::new(self.handle.clone())
    }
    pub fn increase_replica_count(&self) -> fluent_builders::IncreaseReplicaCount<C> {
        fluent_builders::IncreaseReplicaCount::new(self.handle.clone())
    }
    pub fn list_allowed_node_type_modifications(
        &self,
    ) -> fluent_builders::ListAllowedNodeTypeModifications<C> {
        fluent_builders::ListAllowedNodeTypeModifications::new(self.handle.clone())
    }
    pub fn list_tags_for_resource(&self) -> fluent_builders::ListTagsForResource<C> {
        fluent_builders::ListTagsForResource::new(self.handle.clone())
    }
    pub fn modify_cache_cluster(&self) -> fluent_builders::ModifyCacheCluster<C> {
        fluent_builders::ModifyCacheCluster::new(self.handle.clone())
    }
    pub fn modify_cache_parameter_group(&self) -> fluent_builders::ModifyCacheParameterGroup<C> {
        fluent_builders::ModifyCacheParameterGroup::new(self.handle.clone())
    }
    pub fn modify_cache_subnet_group(&self) -> fluent_builders::ModifyCacheSubnetGroup<C> {
        fluent_builders::ModifyCacheSubnetGroup::new(self.handle.clone())
    }
    pub fn modify_global_replication_group(
        &self,
    ) -> fluent_builders::ModifyGlobalReplicationGroup<C> {
        fluent_builders::ModifyGlobalReplicationGroup::new(self.handle.clone())
    }
    pub fn modify_replication_group(&self) -> fluent_builders::ModifyReplicationGroup<C> {
        fluent_builders::ModifyReplicationGroup::new(self.handle.clone())
    }
    pub fn modify_replication_group_shard_configuration(
        &self,
    ) -> fluent_builders::ModifyReplicationGroupShardConfiguration<C> {
        fluent_builders::ModifyReplicationGroupShardConfiguration::new(self.handle.clone())
    }
    pub fn modify_user(&self) -> fluent_builders::ModifyUser<C> {
        fluent_builders::ModifyUser::new(self.handle.clone())
    }
    pub fn modify_user_group(&self) -> fluent_builders::ModifyUserGroup<C> {
        fluent_builders::ModifyUserGroup::new(self.handle.clone())
    }
    pub fn purchase_reserved_cache_nodes_offering(
        &self,
    ) -> fluent_builders::PurchaseReservedCacheNodesOffering<C> {
        fluent_builders::PurchaseReservedCacheNodesOffering::new(self.handle.clone())
    }
    pub fn rebalance_slots_in_global_replication_group(
        &self,
    ) -> fluent_builders::RebalanceSlotsInGlobalReplicationGroup<C> {
        fluent_builders::RebalanceSlotsInGlobalReplicationGroup::new(self.handle.clone())
    }
    pub fn reboot_cache_cluster(&self) -> fluent_builders::RebootCacheCluster<C> {
        fluent_builders::RebootCacheCluster::new(self.handle.clone())
    }
    pub fn remove_tags_from_resource(&self) -> fluent_builders::RemoveTagsFromResource<C> {
        fluent_builders::RemoveTagsFromResource::new(self.handle.clone())
    }
    pub fn reset_cache_parameter_group(&self) -> fluent_builders::ResetCacheParameterGroup<C> {
        fluent_builders::ResetCacheParameterGroup::new(self.handle.clone())
    }
    pub fn revoke_cache_security_group_ingress(
        &self,
    ) -> fluent_builders::RevokeCacheSecurityGroupIngress<C> {
        fluent_builders::RevokeCacheSecurityGroupIngress::new(self.handle.clone())
    }
    pub fn start_migration(&self) -> fluent_builders::StartMigration<C> {
        fluent_builders::StartMigration::new(self.handle.clone())
    }
    pub fn test_failover(&self) -> fluent_builders::TestFailover<C> {
        fluent_builders::TestFailover::new(self.handle.clone())
    }
}
pub mod fluent_builders {
    #[derive(std::fmt::Debug)]
    pub struct AddTagsToResource<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::add_tags_to_resource_input::Builder,
    }
    impl<C> AddTagsToResource<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::AddTagsToResourceOutput,
            smithy_http::result::SdkError<crate::error::AddTagsToResourceError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The Amazon Resource Name (ARN) of the resource to which the tags are to be added,
        /// for example <code>arn:aws:elasticache:us-west-2:0123456789:cluster:myCluster</code>
        /// or <code>arn:aws:elasticache:us-west-2:0123456789:snapshot:mySnapshot</code>.
        /// ElastiCache resources are <i>cluster</i> and <i>snapshot</i>.</p>
        /// <p>For more information about ARNs, see <a href="https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html">Amazon Resource Names (ARNs) and AWS Service Namespaces</a>.</p>
        pub fn resource_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_name(input);
            self
        }
        pub fn set_resource_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_resource_name(input);
            self
        }
        /// <p>A list of tags to be added to this resource. A tag is a key-value pair.
        /// A tag key must be accompanied by a tag value, although null is accepted.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct AuthorizeCacheSecurityGroupIngress<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::authorize_cache_security_group_ingress_input::Builder,
    }
    impl<C> AuthorizeCacheSecurityGroupIngress<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::AuthorizeCacheSecurityGroupIngressOutput,
            smithy_http::result::SdkError<crate::error::AuthorizeCacheSecurityGroupIngressError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The cache security group that allows network ingress.</p>
        pub fn cache_security_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_security_group_name(input);
            self
        }
        pub fn set_cache_security_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_security_group_name(input);
            self
        }
        /// <p>The Amazon EC2 security group to be authorized for ingress to the cache security group.</p>
        pub fn ec2_security_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.ec2_security_group_name(input);
            self
        }
        pub fn set_ec2_security_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_ec2_security_group_name(input);
            self
        }
        /// <p>The AWS account number of the Amazon EC2 security group owner.
        /// Note that this is not the same thing as an AWS access key ID -
        /// you must provide a valid AWS account number for this parameter.</p>
        pub fn ec2_security_group_owner_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.ec2_security_group_owner_id(input);
            self
        }
        pub fn set_ec2_security_group_owner_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_ec2_security_group_owner_id(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct BatchApplyUpdateAction<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::batch_apply_update_action_input::Builder,
    }
    impl<C> BatchApplyUpdateAction<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::BatchApplyUpdateActionOutput,
            smithy_http::result::SdkError<crate::error::BatchApplyUpdateActionError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The replication group IDs</p>
        pub fn replication_group_ids(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_ids(inp);
            self
        }
        pub fn set_replication_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_ids(input);
            self
        }
        /// <p>The cache cluster IDs</p>
        pub fn cache_cluster_ids(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_cluster_ids(inp);
            self
        }
        pub fn set_cache_cluster_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_cache_cluster_ids(input);
            self
        }
        /// <p>The unique ID of the service update</p>
        pub fn service_update_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.service_update_name(input);
            self
        }
        pub fn set_service_update_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_service_update_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct BatchStopUpdateAction<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::batch_stop_update_action_input::Builder,
    }
    impl<C> BatchStopUpdateAction<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::BatchStopUpdateActionOutput,
            smithy_http::result::SdkError<crate::error::BatchStopUpdateActionError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The replication group IDs</p>
        pub fn replication_group_ids(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_ids(inp);
            self
        }
        pub fn set_replication_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_ids(input);
            self
        }
        /// <p>The cache cluster IDs</p>
        pub fn cache_cluster_ids(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_cluster_ids(inp);
            self
        }
        pub fn set_cache_cluster_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_cache_cluster_ids(input);
            self
        }
        /// <p>The unique ID of the service update</p>
        pub fn service_update_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.service_update_name(input);
            self
        }
        pub fn set_service_update_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_service_update_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct CompleteMigration<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::complete_migration_input::Builder,
    }
    impl<C> CompleteMigration<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::CompleteMigrationOutput,
            smithy_http::result::SdkError<crate::error::CompleteMigrationError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The ID of the replication group to which data is being migrated.</p>
        pub fn replication_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_id(input);
            self
        }
        pub fn set_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_id(input);
            self
        }
        /// <p>Forces the migration to stop without ensuring that data is in sync. It is recommended to use this option only to abort the migration and not recommended when application wants to continue migration to ElastiCache.</p>
        pub fn force(mut self, input: bool) -> Self {
            self.inner = self.inner.force(input);
            self
        }
        pub fn set_force(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_force(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct CopySnapshot<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::copy_snapshot_input::Builder,
    }
    impl<C> CopySnapshot<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::CopySnapshotOutput,
            smithy_http::result::SdkError<crate::error::CopySnapshotError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of an existing snapshot from which to make a copy.</p>
        pub fn source_snapshot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.source_snapshot_name(input);
            self
        }
        pub fn set_source_snapshot_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_source_snapshot_name(input);
            self
        }
        /// <p>A name for the snapshot copy.
        /// ElastiCache does not permit overwriting a snapshot, therefore
        /// this name must be unique within its context - ElastiCache or an Amazon S3 bucket if exporting.</p>
        pub fn target_snapshot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.target_snapshot_name(input);
            self
        }
        pub fn set_target_snapshot_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_target_snapshot_name(input);
            self
        }
        /// <p>The Amazon S3 bucket to which the snapshot is exported.
        /// This parameter is used only when exporting a snapshot for external access.</p>
        /// <p>When using this parameter to export a snapshot,
        /// be sure Amazon ElastiCache has the needed permissions to this S3 bucket.
        /// For more information, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/backups-exporting.html#backups-exporting-grant-access">Step 2: Grant ElastiCache Access to Your Amazon S3 Bucket</a> in the <i>Amazon ElastiCache User Guide</i>.</p>
        /// <p>For more information, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/backups-exporting.html">Exporting a Snapshot</a> in the <i>Amazon ElastiCache User Guide</i>.</p>
        pub fn target_bucket(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.target_bucket(input);
            self
        }
        pub fn set_target_bucket(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_target_bucket(input);
            self
        }
        /// <p>The ID of the KMS key used to encrypt the target snapshot.</p>
        pub fn kms_key_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.kms_key_id(input);
            self
        }
        pub fn set_kms_key_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_kms_key_id(input);
            self
        }
        /// <p>A list of tags to be added to this resource. A tag is a key-value pair. A tag key must be accompanied by a tag value, although null is accepted.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct CreateCacheCluster<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::create_cache_cluster_input::Builder,
    }
    impl<C> CreateCacheCluster<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::CreateCacheClusterOutput,
            smithy_http::result::SdkError<crate::error::CreateCacheClusterError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The node group (shard) identifier. This parameter is stored as a lowercase string.</p>        
        /// <p>
        /// <b>Constraints:</b>
        /// </p>
        /// <ul>
        /// <li>
        /// <p>A name must contain from 1 to 50 alphanumeric characters or hyphens.</p>
        /// </li>
        /// <li>
        /// <p>The first character must be a letter.</p>
        /// </li>
        /// <li>
        /// <p>A name cannot end with a hyphen or contain two consecutive hyphens.</p>
        /// </li>
        /// </ul>
        pub fn cache_cluster_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_cluster_id(input);
            self
        }
        pub fn set_cache_cluster_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_cluster_id(input);
            self
        }
        /// <p>The ID of the replication group to which this cluster should belong. If this parameter is specified, the cluster is added to the specified replication group as a read replica; otherwise, the cluster is a standalone primary that is not part of any replication group.</p>
        /// <p>If the specified replication group is Multi-AZ enabled and the Availability Zone is not specified, the cluster is created in Availability Zones that provide the best spread of read replicas across Availability Zones.</p>
        /// <note>
        /// <p>This parameter is only valid if the <code>Engine</code> parameter is <code>redis</code>.</p>
        /// </note>
        pub fn replication_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_id(input);
            self
        }
        pub fn set_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_id(input);
            self
        }
        /// <p>Specifies whether the nodes in this Memcached cluster are created in a single Availability Zone or
        /// created across multiple Availability Zones in the cluster's region.</p>
        /// <p>This parameter is only supported for Memcached clusters.</p>
        /// <p>If the <code>AZMode</code> and <code>PreferredAvailabilityZones</code> are not specified,
        /// ElastiCache assumes <code>single-az</code> mode.</p>
        pub fn az_mode(mut self, input: crate::model::AzMode) -> Self {
            self.inner = self.inner.az_mode(input);
            self
        }
        pub fn set_az_mode(mut self, input: std::option::Option<crate::model::AzMode>) -> Self {
            self.inner = self.inner.set_az_mode(input);
            self
        }
        /// <p>The EC2 Availability Zone in which the cluster is created.</p>
        /// <p>All nodes belonging to this cluster are placed in the preferred Availability Zone.
        /// If you want to create your nodes across multiple Availability Zones, use <code>PreferredAvailabilityZones</code>.</p>
        /// <p>Default: System chosen Availability Zone.</p>
        pub fn preferred_availability_zone(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.preferred_availability_zone(input);
            self
        }
        pub fn set_preferred_availability_zone(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_preferred_availability_zone(input);
            self
        }
        /// <p>A list of the Availability Zones in which cache nodes are created. The order of the zones in the list is not important.</p>
        /// <p>This option is only supported on Memcached.</p>
        /// <note>
        /// <p>If you are creating your cluster in an Amazon VPC (recommended) you can only locate nodes in Availability Zones that are associated with the subnets in the selected subnet group.</p>
        /// <p>The number of Availability Zones listed must equal the value of <code>NumCacheNodes</code>.</p>
        /// </note>
        /// <p>If you want all the nodes in the same Availability Zone, use <code>PreferredAvailabilityZone</code> instead, or
        /// repeat the Availability Zone multiple times in the list.</p>
        /// <p>Default: System chosen Availability Zones.</p>
        pub fn preferred_availability_zones(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.preferred_availability_zones(inp);
            self
        }
        pub fn set_preferred_availability_zones(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_preferred_availability_zones(input);
            self
        }
        /// <p>The initial number of cache nodes that the cluster has.</p>
        /// <p>For clusters running Redis, this value must be 1.
        /// For clusters running Memcached, this value must be between 1 and 40.</p>
        /// <p>If you need more than 40 nodes for your Memcached cluster,
        /// please fill out the ElastiCache Limit Increase Request form at <a href="http://aws.amazon.com/contact-us/elasticache-node-limit-request/">http://aws.amazon.com/contact-us/elasticache-node-limit-request/</a>.</p>
        pub fn num_cache_nodes(mut self, input: i32) -> Self {
            self.inner = self.inner.num_cache_nodes(input);
            self
        }
        pub fn set_num_cache_nodes(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_num_cache_nodes(input);
            self
        }
        /// <p>The compute and memory capacity of the nodes in the node group (shard).</p>
        /// <p>The following node types are supported by ElastiCache.
        /// Generally speaking, the current generation types provide more memory and computational power
        /// at lower cost when compared to their equivalent previous generation counterparts.</p>
        /// <ul>
        /// <li>
        /// <p>General purpose:</p>
        /// <ul>
        /// <li>
        /// <p>Current generation: </p>
        /// <p>
        /// <b>M6g node types</b> (available only for Redis engine version 5.0.6 onward and for Memcached engine version 1.5.16 onward).</p>
        /// <p>  
        /// <code>cache.m6g.large</code>,
        /// <code>cache.m6g.xlarge</code>,
        /// <code>cache.m6g.2xlarge</code>,
        /// <code>cache.m6g.4xlarge</code>,
        /// <code>cache.m6g.8xlarge</code>,
        /// <code>cache.m6g.12xlarge</code>,
        /// <code>cache.m6g.16xlarge</code>
        /// </p>  
        /// <note>
        /// <p>For region availability, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/CacheNodes.SupportedTypes.html#CacheNodes.SupportedTypesByRegion">Supported Node Types</a>
        /// </p>
        /// </note>
        /// <p>
        /// <b>M5 node types:</b>
        /// <code>cache.m5.large</code>,
        /// <code>cache.m5.xlarge</code>,
        /// <code>cache.m5.2xlarge</code>,
        /// <code>cache.m5.4xlarge</code>,
        /// <code>cache.m5.12xlarge</code>,
        /// <code>cache.m5.24xlarge</code>
        /// </p>  
        /// <p>
        /// <b>M4 node types:</b>
        /// <code>cache.m4.large</code>,
        /// <code>cache.m4.xlarge</code>,
        /// <code>cache.m4.2xlarge</code>,
        /// <code>cache.m4.4xlarge</code>,
        /// <code>cache.m4.10xlarge</code>
        /// </p>
        /// <p>
        /// <b>T3 node types:</b>
        /// <code>cache.t3.micro</code>,
        /// <code>cache.t3.small</code>,
        /// <code>cache.t3.medium</code>
        /// </p>
        /// <p>
        /// <b>T2 node types:</b>
        /// <code>cache.t2.micro</code>,
        /// <code>cache.t2.small</code>,
        /// <code>cache.t2.medium</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>Previous generation: (not recommended)</p>
        /// <p>
        /// <b>T1 node types:</b>
        /// <code>cache.t1.micro</code>
        /// </p>
        /// <p>
        /// <b>M1 node types:</b>
        /// <code>cache.m1.small</code>,
        /// <code>cache.m1.medium</code>,
        /// <code>cache.m1.large</code>,
        /// <code>cache.m1.xlarge</code>
        /// </p>
        /// <p>
        /// <b>M3 node types:</b>
        /// <code>cache.m3.medium</code>,
        /// <code>cache.m3.large</code>,
        /// <code>cache.m3.xlarge</code>,
        /// <code>cache.m3.2xlarge</code>
        /// </p>
        /// </li>
        /// </ul>
        /// </li>
        /// <li>
        /// <p>Compute optimized:</p>
        /// <ul>
        /// <li>
        /// <p>Previous generation: (not recommended)</p>
        /// <p>
        /// <b>C1 node types:</b>
        /// <code>cache.c1.xlarge</code>
        /// </p>
        /// </li>
        /// </ul>
        /// </li>
        /// <li>
        /// <p>Memory optimized:</p>
        /// <ul>
        /// <li>
        /// <p>Current generation: </p>
        /// <p>
        /// <b>R6g node types</b> (available only for Redis engine version 5.0.6 onward and for Memcached engine version 1.5.16 onward).</p>
        /// <p>  
        /// <code>cache.r6g.large</code>,
        /// <code>cache.r6g.xlarge</code>,
        /// <code>cache.r6g.2xlarge</code>,
        /// <code>cache.r6g.4xlarge</code>,
        /// <code>cache.r6g.8xlarge</code>,
        /// <code>cache.r6g.12xlarge</code>,
        /// <code>cache.r6g.16xlarge</code>
        /// </p>  
        /// <note>
        /// <p>For region availability, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/CacheNodes.SupportedTypes.html#CacheNodes.SupportedTypesByRegion">Supported Node Types</a>
        /// </p>
        /// </note>
        /// <p>
        /// <b>R5 node types:</b>
        /// <code>cache.r5.large</code>,
        /// <code>cache.r5.xlarge</code>,
        /// <code>cache.r5.2xlarge</code>,
        /// <code>cache.r5.4xlarge</code>,
        /// <code>cache.r5.12xlarge</code>,
        /// <code>cache.r5.24xlarge</code>
        /// </p>
        /// <p>
        /// <b>R4 node types:</b>
        /// <code>cache.r4.large</code>,
        /// <code>cache.r4.xlarge</code>,
        /// <code>cache.r4.2xlarge</code>,
        /// <code>cache.r4.4xlarge</code>,
        /// <code>cache.r4.8xlarge</code>,
        /// <code>cache.r4.16xlarge</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>Previous generation: (not recommended)</p>
        /// <p>
        /// <b>M2 node types:</b>            
        /// <code>cache.m2.xlarge</code>,
        /// <code>cache.m2.2xlarge</code>,
        /// <code>cache.m2.4xlarge</code>
        /// </p>
        /// <p>
        /// <b>R3 node types:</b>
        /// <code>cache.r3.large</code>,
        /// <code>cache.r3.xlarge</code>,
        /// <code>cache.r3.2xlarge</code>,  
        /// <code>cache.r3.4xlarge</code>,
        /// <code>cache.r3.8xlarge</code>
        /// </p>
        /// </li>
        /// </ul>
        /// </li>
        /// </ul>
        /// <p>
        /// <b>Additional node type info</b>
        /// </p>
        /// <ul>
        /// <li>
        /// <p>All current generation instance types are created in Amazon VPC by default.</p>
        /// </li>
        /// <li>
        /// <p>Redis append-only files (AOF) are not supported for T1 or T2 instances.</p>
        /// </li>
        /// <li>
        /// <p>Redis Multi-AZ with automatic failover is not supported on T1 instances.</p>
        /// </li>
        /// <li>
        /// <p>Redis configuration variables <code>appendonly</code> and
        /// <code>appendfsync</code> are not supported on Redis version 2.8.22 and later.</p>
        /// </li>
        /// </ul>
        pub fn cache_node_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_node_type(input);
            self
        }
        pub fn set_cache_node_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_node_type(input);
            self
        }
        /// <p>The name of the cache engine to be used for this cluster.</p>
        /// <p>Valid values for this parameter are: <code>memcached</code> | <code>redis</code>
        /// </p>
        pub fn engine(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.engine(input);
            self
        }
        pub fn set_engine(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_engine(input);
            self
        }
        /// <p>The version number of the cache engine to be used for this cluster.
        /// To view the supported cache engine versions, use the DescribeCacheEngineVersions operation.</p>
        /// <p>
        /// <b>Important:</b> You can upgrade to a newer engine version (see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/SelectEngine.html#VersionManagement">Selecting a Cache Engine and Version</a>), but you cannot downgrade to an earlier engine version.
        /// If you want to use an earlier engine version,
        /// you must delete the existing cluster or replication group and create it anew with the earlier engine version. </p>
        pub fn engine_version(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.engine_version(input);
            self
        }
        pub fn set_engine_version(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_engine_version(input);
            self
        }
        /// <p>The name of the parameter group to associate with this cluster.
        /// If this argument is omitted, the default parameter group for the specified engine is used.
        /// You cannot use any parameter group which has <code>cluster-enabled='yes'</code> when creating a cluster.</p>
        pub fn cache_parameter_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_parameter_group_name(input);
            self
        }
        pub fn set_cache_parameter_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_parameter_group_name(input);
            self
        }
        /// <p>The name of the subnet group to be used for the cluster.</p>
        /// <p>Use this parameter only when you are creating a cluster in an Amazon Virtual Private Cloud (Amazon VPC).</p>
        /// <important>
        /// <p>If you're going to launch your cluster in an Amazon VPC,
        /// you need to create a subnet group before you start creating a cluster.
        /// For more information, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/SubnetGroups.html">Subnets and Subnet Groups</a>.</p>
        /// </important>
        pub fn cache_subnet_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_subnet_group_name(input);
            self
        }
        pub fn set_cache_subnet_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_subnet_group_name(input);
            self
        }
        /// <p>A list of security group names to associate with this cluster.</p>
        /// <p>Use this parameter only when you are creating a cluster outside of an Amazon Virtual Private Cloud (Amazon VPC).</p>
        pub fn cache_security_group_names(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_security_group_names(inp);
            self
        }
        pub fn set_cache_security_group_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_cache_security_group_names(input);
            self
        }
        /// <p>One or more VPC security groups associated with the cluster.</p>
        /// <p>Use this parameter only when you are creating a cluster in an Amazon Virtual Private Cloud (Amazon VPC).</p>
        pub fn security_group_ids(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.security_group_ids(inp);
            self
        }
        pub fn set_security_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_security_group_ids(input);
            self
        }
        /// <p>A list of tags to be added to this resource.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
        /// <p>A single-element string list containing an Amazon Resource Name (ARN) that uniquely identifies
        /// a Redis RDB snapshot file stored in Amazon S3.
        /// The snapshot file is used to populate the node group (shard).
        /// The Amazon S3 object name in the ARN cannot contain any commas.</p>
        /// <note>
        /// <p>This parameter is only valid if the <code>Engine</code> parameter is <code>redis</code>.</p>
        /// </note>
        /// <p>Example of an Amazon S3 ARN: <code>arn:aws:s3:::my_bucket/snapshot1.rdb</code>
        /// </p>
        pub fn snapshot_arns(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.snapshot_arns(inp);
            self
        }
        pub fn set_snapshot_arns(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_snapshot_arns(input);
            self
        }
        /// <p>The name of a Redis snapshot from which to restore data into the new node group (shard).
        /// The snapshot status changes to <code>restoring</code> while the new node group (shard) is being created.</p>
        /// <note>
        /// <p>This parameter is only valid if the <code>Engine</code> parameter is <code>redis</code>.</p>
        /// </note>
        pub fn snapshot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.snapshot_name(input);
            self
        }
        pub fn set_snapshot_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_snapshot_name(input);
            self
        }
        /// <p>Specifies the weekly time range during which maintenance
        /// on the cluster is performed. It is specified as a range in
        /// the format ddd:hh24:mi-ddd:hh24:mi (24H Clock UTC). The minimum
        /// maintenance window is a 60 minute period.
        /// Valid values for <code>ddd</code> are:</p>
        pub fn preferred_maintenance_window(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.preferred_maintenance_window(input);
            self
        }
        pub fn set_preferred_maintenance_window(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_preferred_maintenance_window(input);
            self
        }
        /// <p>The port number on which each of the cache nodes  accepts connections.</p>
        pub fn port(mut self, input: i32) -> Self {
            self.inner = self.inner.port(input);
            self
        }
        pub fn set_port(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_port(input);
            self
        }
        /// <p>The Amazon Resource Name (ARN) of the Amazon Simple Notification Service (SNS) topic
        /// to which notifications are sent.</p>
        /// <note>
        /// <p>The Amazon SNS topic owner must be the same as the cluster owner.</p>
        /// </note>
        pub fn notification_topic_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.notification_topic_arn(input);
            self
        }
        pub fn set_notification_topic_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_notification_topic_arn(input);
            self
        }
        /// <p>This parameter is currently disabled.</p>
        pub fn auto_minor_version_upgrade(mut self, input: bool) -> Self {
            self.inner = self.inner.auto_minor_version_upgrade(input);
            self
        }
        pub fn set_auto_minor_version_upgrade(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_auto_minor_version_upgrade(input);
            self
        }
        /// <p>The number of days for which ElastiCache retains automatic snapshots before deleting them.
        /// For example, if you set <code>SnapshotRetentionLimit</code> to 5,
        /// a snapshot taken today is retained for 5 days before being deleted.</p>
        /// <note>
        /// <p>This parameter is only valid if the <code>Engine</code> parameter is <code>redis</code>.</p>
        /// </note>
        /// <p>Default: 0 (i.e., automatic backups are disabled for this cache cluster).</p>
        pub fn snapshot_retention_limit(mut self, input: i32) -> Self {
            self.inner = self.inner.snapshot_retention_limit(input);
            self
        }
        pub fn set_snapshot_retention_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_snapshot_retention_limit(input);
            self
        }
        /// <p>The daily time range (in UTC) during which ElastiCache begins taking a daily snapshot of your node group (shard).</p>
        /// <p>Example: <code>05:00-09:00</code>
        /// </p>
        /// <p>If you do not specify this parameter, ElastiCache  automatically chooses an appropriate time range.</p>
        /// <note>
        /// <p>This parameter is only valid if the <code>Engine</code> parameter is <code>redis</code>.</p>
        /// </note>
        pub fn snapshot_window(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.snapshot_window(input);
            self
        }
        pub fn set_snapshot_window(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_snapshot_window(input);
            self
        }
        /// <p>
        /// <b>Reserved parameter.</b>  
        /// The password used to access a password protected server.</p>
        /// <p>Password constraints:</p>
        /// <ul>
        /// <li>
        /// <p>Must be only printable ASCII characters.</p>
        /// </li>
        /// <li>
        /// <p>Must be at least 16 characters and no more than 128
        /// characters in length.</p>
        /// </li>
        /// <li>
        /// <p>The only permitted printable special characters are !, &, #, $, ^, <, >, and -. Other printable special characters cannot be used in the AUTH token.</p>
        /// </li>
        /// </ul>
        /// <p>For more information, see <a href="http://redis.io/commands/AUTH">AUTH password</a> at http://redis.io/commands/AUTH.</p>
        pub fn auth_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.auth_token(input);
            self
        }
        pub fn set_auth_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_auth_token(input);
            self
        }
        /// <p>Specifies whether the nodes in the cluster are created in a single outpost or across multiple outposts.</p>
        pub fn outpost_mode(mut self, input: crate::model::OutpostMode) -> Self {
            self.inner = self.inner.outpost_mode(input);
            self
        }
        pub fn set_outpost_mode(
            mut self,
            input: std::option::Option<crate::model::OutpostMode>,
        ) -> Self {
            self.inner = self.inner.set_outpost_mode(input);
            self
        }
        /// <p>The outpost ARN in which the cache cluster is created.</p>
        pub fn preferred_outpost_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.preferred_outpost_arn(input);
            self
        }
        pub fn set_preferred_outpost_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_preferred_outpost_arn(input);
            self
        }
        /// <p>The outpost ARNs in which the cache cluster is created.</p>
        pub fn preferred_outpost_arns(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.preferred_outpost_arns(inp);
            self
        }
        pub fn set_preferred_outpost_arns(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_preferred_outpost_arns(input);
            self
        }
        /// <p>Specifies the destination, format and type of the logs. </p>
        pub fn log_delivery_configurations(
            mut self,
            inp: impl Into<crate::model::LogDeliveryConfigurationRequest>,
        ) -> Self {
            self.inner = self.inner.log_delivery_configurations(inp);
            self
        }
        pub fn set_log_delivery_configurations(
            mut self,
            input: std::option::Option<
                std::vec::Vec<crate::model::LogDeliveryConfigurationRequest>,
            >,
        ) -> Self {
            self.inner = self.inner.set_log_delivery_configurations(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct CreateCacheParameterGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::create_cache_parameter_group_input::Builder,
    }
    impl<C> CreateCacheParameterGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::CreateCacheParameterGroupOutput,
            smithy_http::result::SdkError<crate::error::CreateCacheParameterGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>A user-specified name for the cache parameter group.</p>
        pub fn cache_parameter_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_parameter_group_name(input);
            self
        }
        pub fn set_cache_parameter_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_parameter_group_name(input);
            self
        }
        /// <p>The name of the cache parameter group family that the cache parameter group can be used with.</p>
        /// <p>Valid values are:
        /// <code>memcached1.4</code> |
        /// <code>memcached1.5</code> |
        /// <code>memcached1.6</code> |
        /// <code>redis2.6</code> |
        /// <code>redis2.8</code> |
        /// <code>redis3.2</code> |
        /// <code>redis4.0</code> |
        /// <code>redis5.0</code> |
        /// <code>redis6.x</code> |
        /// </p>
        pub fn cache_parameter_group_family(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.cache_parameter_group_family(input);
            self
        }
        pub fn set_cache_parameter_group_family(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_parameter_group_family(input);
            self
        }
        /// <p>A user-specified description for the cache parameter group.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.description(input);
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_description(input);
            self
        }
        /// <p>A list of tags to be added to this resource. A tag is a key-value pair. A tag key must be accompanied by a tag value, although null is accepted.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct CreateCacheSecurityGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::create_cache_security_group_input::Builder,
    }
    impl<C> CreateCacheSecurityGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::CreateCacheSecurityGroupOutput,
            smithy_http::result::SdkError<crate::error::CreateCacheSecurityGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>A name for the cache security group. This value is stored as a lowercase string.</p>
        /// <p>Constraints: Must contain no more than 255 alphanumeric characters. Cannot be the word "Default".</p>
        /// <p>Example: <code>mysecuritygroup</code>
        /// </p>
        pub fn cache_security_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_security_group_name(input);
            self
        }
        pub fn set_cache_security_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_security_group_name(input);
            self
        }
        /// <p>A description for the cache security group.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.description(input);
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_description(input);
            self
        }
        /// <p>A list of tags to be added to this resource. A tag is a key-value pair. A tag key must be accompanied by a tag value, although null is accepted.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct CreateCacheSubnetGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::create_cache_subnet_group_input::Builder,
    }
    impl<C> CreateCacheSubnetGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::CreateCacheSubnetGroupOutput,
            smithy_http::result::SdkError<crate::error::CreateCacheSubnetGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>A name for the cache subnet group. This value is stored as a lowercase string.</p>
        /// <p>Constraints: Must contain no more than 255 alphanumeric characters or hyphens.</p>
        /// <p>Example: <code>mysubnetgroup</code>
        /// </p>
        pub fn cache_subnet_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_subnet_group_name(input);
            self
        }
        pub fn set_cache_subnet_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_subnet_group_name(input);
            self
        }
        /// <p>A description for the cache subnet group.</p>
        pub fn cache_subnet_group_description(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.cache_subnet_group_description(input);
            self
        }
        pub fn set_cache_subnet_group_description(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_subnet_group_description(input);
            self
        }
        /// <p>A list of VPC subnet IDs for the cache subnet group.</p>
        pub fn subnet_ids(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.subnet_ids(inp);
            self
        }
        pub fn set_subnet_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_subnet_ids(input);
            self
        }
        /// <p>A list of tags to be added to this resource. A tag is a key-value pair. A tag key must be accompanied by a tag value, although null is accepted.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct CreateGlobalReplicationGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::create_global_replication_group_input::Builder,
    }
    impl<C> CreateGlobalReplicationGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::CreateGlobalReplicationGroupOutput,
            smithy_http::result::SdkError<crate::error::CreateGlobalReplicationGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The suffix name of a Global datastore. Amazon ElastiCache automatically applies a prefix
        /// to the Global datastore ID when it is created. Each AWS Region has its own prefix. For instance, a Global datastore ID created in the US-West-1 region will begin with "dsdfu" along with the suffix name you provide. The suffix, combined with the auto-generated prefix, guarantees uniqueness of the Global datastore name across multiple regions.  </p>
        /// <p>For a full list of AWS Regions and their respective Global datastore iD prefixes, see <a href="http://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/Redis-Global-Datastores-CLI.html">Using the AWS CLI with Global datastores </a>.</p>
        pub fn global_replication_group_id_suffix(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.global_replication_group_id_suffix(input);
            self
        }
        pub fn set_global_replication_group_id_suffix(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_global_replication_group_id_suffix(input);
            self
        }
        /// <p>Provides details of the Global datastore</p>
        pub fn global_replication_group_description(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.global_replication_group_description(input);
            self
        }
        pub fn set_global_replication_group_description(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_global_replication_group_description(input);
            self
        }
        /// <p>The name of the primary cluster that accepts writes and will replicate updates to the secondary cluster.</p>
        pub fn primary_replication_group_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.primary_replication_group_id(input);
            self
        }
        pub fn set_primary_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_primary_replication_group_id(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct CreateReplicationGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::create_replication_group_input::Builder,
    }
    impl<C> CreateReplicationGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::CreateReplicationGroupOutput,
            smithy_http::result::SdkError<crate::error::CreateReplicationGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The replication group identifier. This parameter is stored as a lowercase string.</p>
        /// <p>Constraints:</p>
        /// <ul>
        /// <li>
        /// <p>A name must contain from 1 to 40 alphanumeric characters or hyphens.</p>
        /// </li>
        /// <li>
        /// <p>The first character must be a letter.</p>
        /// </li>
        /// <li>
        /// <p>A name cannot end with a hyphen or contain two consecutive hyphens.</p>
        /// </li>
        /// </ul>
        pub fn replication_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_id(input);
            self
        }
        pub fn set_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_id(input);
            self
        }
        /// <p>A user-created description for the replication group.</p>
        pub fn replication_group_description(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.replication_group_description(input);
            self
        }
        pub fn set_replication_group_description(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_description(input);
            self
        }
        /// <p>The name of the Global datastore</p>
        pub fn global_replication_group_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.global_replication_group_id(input);
            self
        }
        pub fn set_global_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_global_replication_group_id(input);
            self
        }
        /// <p>The identifier of the cluster that serves as the primary for this replication
        /// group. This cluster must already exist and have a status of <code>available</code>.</p>
        /// <p>This parameter is not required if <code>NumCacheClusters</code>,
        /// <code>NumNodeGroups</code>, or
        /// <code>ReplicasPerNodeGroup</code> is specified.</p>
        pub fn primary_cluster_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.primary_cluster_id(input);
            self
        }
        pub fn set_primary_cluster_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_primary_cluster_id(input);
            self
        }
        /// <p>Specifies whether a read-only replica is automatically promoted to read/write primary if the existing primary fails.</p>
        /// <p>
        /// <code>AutomaticFailoverEnabled</code> must be enabled for Redis (cluster mode enabled) replication groups.</p>
        /// <p>Default: false</p>
        pub fn automatic_failover_enabled(mut self, input: bool) -> Self {
            self.inner = self.inner.automatic_failover_enabled(input);
            self
        }
        pub fn set_automatic_failover_enabled(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_automatic_failover_enabled(input);
            self
        }
        /// <p>A flag indicating if you have Multi-AZ enabled to enhance fault tolerance. For more information, see <a href="http://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/AutoFailover.html">Minimizing Downtime: Multi-AZ</a>.</p>
        pub fn multi_az_enabled(mut self, input: bool) -> Self {
            self.inner = self.inner.multi_az_enabled(input);
            self
        }
        pub fn set_multi_az_enabled(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_multi_az_enabled(input);
            self
        }
        /// <p>The number of clusters this replication group initially has.</p>
        /// <p>This parameter is not used if there is more than one node group (shard).  
        /// You should use <code>ReplicasPerNodeGroup</code> instead.</p>
        /// <p>If <code>AutomaticFailoverEnabled</code> is <code>true</code>, the value of this parameter must be at least 2.
        /// If <code>AutomaticFailoverEnabled</code> is <code>false</code> you can omit this parameter (it will default to 1), or you
        /// can explicitly set it to a value between 2 and 6.</p>
        /// <p>The maximum permitted value for <code>NumCacheClusters</code> is 6 (1 primary plus 5 replicas).</p>
        pub fn num_cache_clusters(mut self, input: i32) -> Self {
            self.inner = self.inner.num_cache_clusters(input);
            self
        }
        pub fn set_num_cache_clusters(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_num_cache_clusters(input);
            self
        }
        /// <p>A list of EC2 Availability Zones in which the replication group's clusters are created.
        /// The order of the Availability Zones in the list is the order in which clusters are allocated.
        /// The primary cluster is created in the first AZ in the list.</p>
        /// <p>This parameter is not used if there is more than one node group (shard).  
        /// You should use <code>NodeGroupConfiguration</code> instead.</p>
        /// <note>
        /// <p>If you are creating your replication group in an Amazon VPC (recommended),
        /// you can only locate clusters in Availability Zones associated with the subnets in the selected subnet group.</p>
        /// <p>The number of Availability Zones listed must equal the value of <code>NumCacheClusters</code>.</p>
        /// </note>
        /// <p>Default: system chosen Availability Zones.</p>
        pub fn preferred_cache_cluster_a_zs(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.preferred_cache_cluster_a_zs(inp);
            self
        }
        pub fn set_preferred_cache_cluster_a_zs(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_preferred_cache_cluster_a_zs(input);
            self
        }
        /// <p>An optional parameter that specifies the number of node groups (shards) for this Redis (cluster mode enabled) replication group.
        /// For Redis (cluster mode disabled) either omit this parameter or set it to 1.</p>
        /// <p>Default: 1</p>
        pub fn num_node_groups(mut self, input: i32) -> Self {
            self.inner = self.inner.num_node_groups(input);
            self
        }
        pub fn set_num_node_groups(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_num_node_groups(input);
            self
        }
        /// <p>An optional parameter that specifies the number of replica nodes in each node group (shard).
        /// Valid values are 0 to 5.</p>
        pub fn replicas_per_node_group(mut self, input: i32) -> Self {
            self.inner = self.inner.replicas_per_node_group(input);
            self
        }
        pub fn set_replicas_per_node_group(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_replicas_per_node_group(input);
            self
        }
        /// <p>A list of node group (shard) configuration options.
        /// Each node group (shard) configuration has the following members:
        /// <code>PrimaryAvailabilityZone</code>,
        /// <code>ReplicaAvailabilityZones</code>,
        /// <code>ReplicaCount</code>, and
        /// <code>Slots</code>.</p>
        /// <p>If you're creating a Redis (cluster mode disabled) or a Redis (cluster mode enabled) replication group, you can use this parameter to
        /// individually configure each node group (shard), or you can omit this parameter. However, it is required when seeding a
        /// Redis (cluster mode enabled) cluster from a S3 rdb file. You must configure each node group (shard) using this parameter
        /// because you must specify the slots for each node group.</p>
        pub fn node_group_configuration(
            mut self,
            inp: impl Into<crate::model::NodeGroupConfiguration>,
        ) -> Self {
            self.inner = self.inner.node_group_configuration(inp);
            self
        }
        pub fn set_node_group_configuration(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::NodeGroupConfiguration>>,
        ) -> Self {
            self.inner = self.inner.set_node_group_configuration(input);
            self
        }
        /// <p>The compute and memory capacity of the nodes in the node group (shard).</p>        
        /// <p>The following node types are supported by ElastiCache.
        /// Generally speaking, the current generation types provide more memory and computational power
        /// at lower cost when compared to their equivalent previous generation counterparts.</p>
        /// <ul>
        /// <li>
        /// <p>General purpose:</p>
        /// <ul>
        /// <li>
        /// <p>Current generation: </p>
        /// <p>
        /// <b>M6g node types</b> (available only for Redis engine version 5.0.6 onward and for Memcached engine version 1.5.16 onward).</p>
        /// <p>  
        /// <code>cache.m6g.large</code>,
        /// <code>cache.m6g.xlarge</code>,
        /// <code>cache.m6g.2xlarge</code>,
        /// <code>cache.m6g.4xlarge</code>,
        /// <code>cache.m6g.8xlarge</code>,
        /// <code>cache.m6g.12xlarge</code>,
        /// <code>cache.m6g.16xlarge</code>
        /// </p>  
        /// <note>
        /// <p>For region availability, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/CacheNodes.SupportedTypes.html#CacheNodes.SupportedTypesByRegion">Supported Node Types</a>
        /// </p>
        /// </note>
        /// <p>
        /// <b>M5 node types:</b>
        /// <code>cache.m5.large</code>,
        /// <code>cache.m5.xlarge</code>,
        /// <code>cache.m5.2xlarge</code>,
        /// <code>cache.m5.4xlarge</code>,
        /// <code>cache.m5.12xlarge</code>,
        /// <code>cache.m5.24xlarge</code>
        /// </p>  
        /// <p>
        /// <b>M4 node types:</b>
        /// <code>cache.m4.large</code>,
        /// <code>cache.m4.xlarge</code>,
        /// <code>cache.m4.2xlarge</code>,
        /// <code>cache.m4.4xlarge</code>,
        /// <code>cache.m4.10xlarge</code>
        /// </p>
        /// <p>
        /// <b>T3 node types:</b>
        /// <code>cache.t3.micro</code>,
        /// <code>cache.t3.small</code>,
        /// <code>cache.t3.medium</code>
        /// </p>
        /// <p>
        /// <b>T2 node types:</b>
        /// <code>cache.t2.micro</code>,
        /// <code>cache.t2.small</code>,
        /// <code>cache.t2.medium</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>Previous generation: (not recommended)</p>
        /// <p>
        /// <b>T1 node types:</b>
        /// <code>cache.t1.micro</code>
        /// </p>
        /// <p>
        /// <b>M1 node types:</b>
        /// <code>cache.m1.small</code>,
        /// <code>cache.m1.medium</code>,
        /// <code>cache.m1.large</code>,
        /// <code>cache.m1.xlarge</code>
        /// </p>
        /// <p>
        /// <b>M3 node types:</b>
        /// <code>cache.m3.medium</code>,
        /// <code>cache.m3.large</code>,
        /// <code>cache.m3.xlarge</code>,
        /// <code>cache.m3.2xlarge</code>
        /// </p>
        /// </li>
        /// </ul>
        /// </li>
        /// <li>
        /// <p>Compute optimized:</p>
        /// <ul>
        /// <li>
        /// <p>Previous generation: (not recommended)</p>
        /// <p>
        /// <b>C1 node types:</b>
        /// <code>cache.c1.xlarge</code>
        /// </p>
        /// </li>
        /// </ul>
        /// </li>
        /// <li>
        /// <p>Memory optimized:</p>
        /// <ul>
        /// <li>
        /// <p>Current generation: </p>
        /// <p>
        /// <b>R6g node types</b> (available only for Redis engine version 5.0.6 onward and for Memcached engine version 1.5.16 onward).</p>
        /// <p>  
        /// <code>cache.r6g.large</code>,
        /// <code>cache.r6g.xlarge</code>,
        /// <code>cache.r6g.2xlarge</code>,
        /// <code>cache.r6g.4xlarge</code>,
        /// <code>cache.r6g.8xlarge</code>,
        /// <code>cache.r6g.12xlarge</code>,
        /// <code>cache.r6g.16xlarge</code>
        /// </p>  
        /// <note>
        /// <p>For region availability, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/CacheNodes.SupportedTypes.html#CacheNodes.SupportedTypesByRegion">Supported Node Types</a>
        /// </p>
        /// </note>
        /// <p>
        /// <b>R5 node types:</b>
        /// <code>cache.r5.large</code>,
        /// <code>cache.r5.xlarge</code>,
        /// <code>cache.r5.2xlarge</code>,
        /// <code>cache.r5.4xlarge</code>,
        /// <code>cache.r5.12xlarge</code>,
        /// <code>cache.r5.24xlarge</code>
        /// </p>
        /// <p>
        /// <b>R4 node types:</b>
        /// <code>cache.r4.large</code>,
        /// <code>cache.r4.xlarge</code>,
        /// <code>cache.r4.2xlarge</code>,
        /// <code>cache.r4.4xlarge</code>,
        /// <code>cache.r4.8xlarge</code>,
        /// <code>cache.r4.16xlarge</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>Previous generation: (not recommended)</p>
        /// <p>
        /// <b>M2 node types:</b>            
        /// <code>cache.m2.xlarge</code>,
        /// <code>cache.m2.2xlarge</code>,
        /// <code>cache.m2.4xlarge</code>
        /// </p>
        /// <p>
        /// <b>R3 node types:</b>
        /// <code>cache.r3.large</code>,
        /// <code>cache.r3.xlarge</code>,
        /// <code>cache.r3.2xlarge</code>,  
        /// <code>cache.r3.4xlarge</code>,
        /// <code>cache.r3.8xlarge</code>
        /// </p>
        /// </li>
        /// </ul>
        /// </li>
        /// </ul>
        /// <p>
        /// <b>Additional node type info</b>
        /// </p>
        /// <ul>
        /// <li>
        /// <p>All current generation instance types are created in Amazon VPC by default.</p>
        /// </li>
        /// <li>
        /// <p>Redis append-only files (AOF) are not supported for T1 or T2 instances.</p>
        /// </li>
        /// <li>
        /// <p>Redis Multi-AZ with automatic failover is not supported on T1 instances.</p>
        /// </li>
        /// <li>
        /// <p>Redis configuration variables <code>appendonly</code> and
        /// <code>appendfsync</code> are not supported on Redis version 2.8.22 and later.</p>
        /// </li>
        /// </ul>
        pub fn cache_node_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_node_type(input);
            self
        }
        pub fn set_cache_node_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_node_type(input);
            self
        }
        /// <p>The name of the cache engine to be used for the clusters in this replication group. Must be Redis.</p>
        pub fn engine(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.engine(input);
            self
        }
        pub fn set_engine(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_engine(input);
            self
        }
        /// <p>The version number of the cache engine to be used for the clusters in this replication group.
        /// To view the supported cache engine versions, use the <code>DescribeCacheEngineVersions</code> operation.</p>
        /// <p>
        /// <b>Important:</b> You can upgrade to a newer engine version (see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/SelectEngine.html#VersionManagement">Selecting a Cache Engine and Version</a>) in the <i>ElastiCache User Guide</i>,
        /// but you cannot downgrade to an earlier engine version.
        /// If you want to use an earlier engine version,
        /// you must delete the existing cluster or replication group and
        /// create it anew with the earlier engine version. </p>
        pub fn engine_version(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.engine_version(input);
            self
        }
        pub fn set_engine_version(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_engine_version(input);
            self
        }
        /// <p>The name of the parameter group to associate with this replication group.
        /// If this argument is omitted, the default cache parameter group for the specified engine is
        /// used.</p>
        /// <p>If you are running Redis version 3.2.4 or later, only one node group (shard), and want to use a default parameter group,
        /// we recommend that you specify the parameter group by name. </p>
        /// <ul>
        /// <li>
        /// <p>To create a Redis (cluster mode disabled) replication group, use <code>CacheParameterGroupName=default.redis3.2</code>.</p>
        /// </li>
        /// <li>
        /// <p>To create a Redis (cluster mode enabled) replication group, use <code>CacheParameterGroupName=default.redis3.2.cluster.on</code>.</p>
        /// </li>
        /// </ul>
        pub fn cache_parameter_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_parameter_group_name(input);
            self
        }
        pub fn set_cache_parameter_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_parameter_group_name(input);
            self
        }
        /// <p>The name of the cache subnet group to be used for the replication group.</p>
        /// <important>
        /// <p>If you're going to launch your cluster in an Amazon VPC,
        /// you need to create a subnet group before you start creating a cluster.
        /// For more information, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/SubnetGroups.html">Subnets and Subnet Groups</a>.</p>
        /// </important>
        pub fn cache_subnet_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_subnet_group_name(input);
            self
        }
        pub fn set_cache_subnet_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_subnet_group_name(input);
            self
        }
        /// <p>A list of cache security group names to associate with this replication group.</p>
        pub fn cache_security_group_names(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_security_group_names(inp);
            self
        }
        pub fn set_cache_security_group_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_cache_security_group_names(input);
            self
        }
        /// <p>One or more Amazon VPC security groups associated with this replication group.</p>
        /// <p>Use this parameter only when you are creating a replication group in an Amazon Virtual Private Cloud (Amazon VPC).</p>
        pub fn security_group_ids(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.security_group_ids(inp);
            self
        }
        pub fn set_security_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_security_group_ids(input);
            self
        }
        /// <p>A list of tags to be added to this resource.
        /// Tags are comma-separated key,value pairs (e.g. Key=<code>myKey</code>, Value=<code>myKeyValue</code>. You can include multiple tags as shown following:
        /// Key=<code>myKey</code>, Value=<code>myKeyValue</code> Key=<code>mySecondKey</code>, Value=<code>mySecondKeyValue</code>. Tags on replication groups will be replicated to all nodes.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
        /// <p>A list of Amazon Resource Names (ARN) that uniquely identify
        /// the Redis RDB snapshot files stored in Amazon S3.
        /// The snapshot files are used to populate the new replication group.
        /// The Amazon S3 object name in the ARN cannot contain any commas.
        /// The new replication group will have the number of node groups (console: shards)
        /// specified by the parameter <i>NumNodeGroups</i> or the number of
        /// node groups configured by <i>NodeGroupConfiguration</i> regardless
        /// of the number of ARNs specified here.</p>
        /// <p>Example of an Amazon S3 ARN: <code>arn:aws:s3:::my_bucket/snapshot1.rdb</code>
        /// </p>
        pub fn snapshot_arns(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.snapshot_arns(inp);
            self
        }
        pub fn set_snapshot_arns(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_snapshot_arns(input);
            self
        }
        /// <p>The name of a snapshot from which to restore data into the new replication group.
        /// The snapshot status changes to <code>restoring</code> while the new replication group is being created.</p>
        pub fn snapshot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.snapshot_name(input);
            self
        }
        pub fn set_snapshot_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_snapshot_name(input);
            self
        }
        /// <p>Specifies the weekly time range during which maintenance
        /// on the cluster is performed. It is specified as a range in
        /// the format ddd:hh24:mi-ddd:hh24:mi (24H Clock UTC). The minimum
        /// maintenance window is a 60 minute period.
        /// Valid values for <code>ddd</code> are:</p>
        /// <p>Specifies the weekly time range during which maintenance
        /// on the cluster is performed. It is specified as a range in
        /// the format ddd:hh24:mi-ddd:hh24:mi (24H Clock UTC). The minimum
        /// maintenance window is a 60 minute period.</p>
        /// <p>Valid values for <code>ddd</code> are:</p>
        /// <ul>
        /// <li>
        /// <p>
        /// <code>sun</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>mon</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>tue</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>wed</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>thu</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>fri</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>sat</code>
        /// </p>
        /// </li>
        /// </ul>
        /// <p>Example: <code>sun:23:00-mon:01:30</code>
        /// </p>
        pub fn preferred_maintenance_window(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.preferred_maintenance_window(input);
            self
        }
        pub fn set_preferred_maintenance_window(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_preferred_maintenance_window(input);
            self
        }
        /// <p>The port number on which each member of the replication group accepts connections.</p>
        pub fn port(mut self, input: i32) -> Self {
            self.inner = self.inner.port(input);
            self
        }
        pub fn set_port(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_port(input);
            self
        }
        /// <p>The Amazon Resource Name (ARN) of the Amazon Simple Notification Service (SNS)
        /// topic to which notifications are sent.</p>
        /// <note>
        /// <p>The Amazon SNS topic owner must be the same as the cluster owner.</p>
        /// </note>
        pub fn notification_topic_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.notification_topic_arn(input);
            self
        }
        pub fn set_notification_topic_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_notification_topic_arn(input);
            self
        }
        /// <p>This parameter is currently disabled.</p>
        pub fn auto_minor_version_upgrade(mut self, input: bool) -> Self {
            self.inner = self.inner.auto_minor_version_upgrade(input);
            self
        }
        pub fn set_auto_minor_version_upgrade(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_auto_minor_version_upgrade(input);
            self
        }
        /// <p>The number of days for which ElastiCache retains automatic snapshots before deleting them.
        /// For example, if you set <code>SnapshotRetentionLimit</code> to 5,
        /// a snapshot that was taken today is retained for 5 days before being deleted.</p>
        /// <p>Default: 0 (i.e., automatic backups are disabled for this cluster).</p>
        pub fn snapshot_retention_limit(mut self, input: i32) -> Self {
            self.inner = self.inner.snapshot_retention_limit(input);
            self
        }
        pub fn set_snapshot_retention_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_snapshot_retention_limit(input);
            self
        }
        /// <p>The daily time range (in UTC) during which ElastiCache begins taking a daily snapshot of your node group (shard).</p>
        /// <p>Example: <code>05:00-09:00</code>
        /// </p>
        /// <p>If you do not specify this parameter, ElastiCache  automatically chooses an appropriate time range.</p>
        pub fn snapshot_window(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.snapshot_window(input);
            self
        }
        pub fn set_snapshot_window(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_snapshot_window(input);
            self
        }
        /// <p>
        /// <b>Reserved parameter.</b>  
        /// The password used to access a password protected server.</p>
        /// <p>
        /// <code>AuthToken</code> can be specified only on replication groups where <code>TransitEncryptionEnabled</code> is
        /// <code>true</code>.</p>
        /// <important>
        /// <p>For HIPAA compliance, you must specify <code>TransitEncryptionEnabled</code> as <code>true</code>,
        /// an <code>AuthToken</code>, and a <code>CacheSubnetGroup</code>.</p>
        /// </important>
        /// <p>Password constraints:</p>
        /// <ul>
        /// <li>
        /// <p>Must be only printable ASCII characters.</p>
        /// </li>
        /// <li>
        /// <p>Must be at least 16 characters and no more than 128
        /// characters in length.</p>
        /// </li>
        /// <li>
        /// <p>The only permitted printable special characters are !, &, #, $, ^, <, >, and -. Other printable special characters cannot be used in the AUTH token.</p>
        /// </li>
        /// </ul>
        /// <p>For more information, see <a href="http://redis.io/commands/AUTH">AUTH password</a> at http://redis.io/commands/AUTH.</p>
        pub fn auth_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.auth_token(input);
            self
        }
        pub fn set_auth_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_auth_token(input);
            self
        }
        /// <p>A flag that enables in-transit encryption when set to <code>true</code>.</p>
        /// <p>You cannot modify the value of <code>TransitEncryptionEnabled</code>
        /// after the cluster is created. To enable in-transit encryption on a cluster
        /// you must set <code>TransitEncryptionEnabled</code> to <code>true</code>
        /// when you create a cluster.</p>
        /// <p>This parameter is valid only if the <code>Engine</code> parameter is <code>redis</code>,
        /// the <code>EngineVersion</code> parameter is <code>3.2.6</code>, <code>4.x</code> or later,
        /// and the cluster is being created in an Amazon VPC.</p>
        /// <p>If you enable in-transit encryption, you must also specify a value for
        /// <code>CacheSubnetGroup</code>.</p>
        /// <p>
        /// <b>Required:</b>
        /// Only available when creating a replication group in an Amazon VPC using redis version <code>3.2.6</code>, <code>4.x</code> or later.</p>
        /// <p>Default: <code>false</code>
        /// </p>
        /// <important>
        /// <p>For HIPAA compliance, you must specify <code>TransitEncryptionEnabled</code> as <code>true</code>,
        /// an <code>AuthToken</code>, and a <code>CacheSubnetGroup</code>.</p>
        /// </important>
        pub fn transit_encryption_enabled(mut self, input: bool) -> Self {
            self.inner = self.inner.transit_encryption_enabled(input);
            self
        }
        pub fn set_transit_encryption_enabled(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_transit_encryption_enabled(input);
            self
        }
        /// <p>A flag that enables encryption at rest when set to <code>true</code>.</p>
        /// <p>You cannot modify the value of <code>AtRestEncryptionEnabled</code> after the replication
        /// group is created.
        /// To enable encryption at rest on a replication group you must set <code>AtRestEncryptionEnabled</code> to
        /// <code>true</code> when you create the replication group. </p>
        /// <p>
        /// <b>Required:</b>
        /// Only available when creating a replication group in an Amazon VPC using redis version <code>3.2.6</code>, <code>4.x</code> or later.</p>
        /// <p>Default: <code>false</code>
        /// </p>
        pub fn at_rest_encryption_enabled(mut self, input: bool) -> Self {
            self.inner = self.inner.at_rest_encryption_enabled(input);
            self
        }
        pub fn set_at_rest_encryption_enabled(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_at_rest_encryption_enabled(input);
            self
        }
        /// <p>The ID of the KMS key used to encrypt the disk in the cluster.</p>
        pub fn kms_key_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.kms_key_id(input);
            self
        }
        pub fn set_kms_key_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_kms_key_id(input);
            self
        }
        /// <p>The user group to associate with the replication group.</p>
        pub fn user_group_ids(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.user_group_ids(inp);
            self
        }
        pub fn set_user_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_user_group_ids(input);
            self
        }
        /// <p>Specifies the destination, format and type of the logs.</p>
        pub fn log_delivery_configurations(
            mut self,
            inp: impl Into<crate::model::LogDeliveryConfigurationRequest>,
        ) -> Self {
            self.inner = self.inner.log_delivery_configurations(inp);
            self
        }
        pub fn set_log_delivery_configurations(
            mut self,
            input: std::option::Option<
                std::vec::Vec<crate::model::LogDeliveryConfigurationRequest>,
            >,
        ) -> Self {
            self.inner = self.inner.set_log_delivery_configurations(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct CreateSnapshot<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::create_snapshot_input::Builder,
    }
    impl<C> CreateSnapshot<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::CreateSnapshotOutput,
            smithy_http::result::SdkError<crate::error::CreateSnapshotError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The identifier of an existing replication group. The snapshot is created from this replication group.</p>
        pub fn replication_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_id(input);
            self
        }
        pub fn set_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_id(input);
            self
        }
        /// <p>The identifier of an existing cluster. The snapshot is created from this cluster.</p>
        pub fn cache_cluster_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_cluster_id(input);
            self
        }
        pub fn set_cache_cluster_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_cluster_id(input);
            self
        }
        /// <p>A name for the snapshot being created.</p>
        pub fn snapshot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.snapshot_name(input);
            self
        }
        pub fn set_snapshot_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_snapshot_name(input);
            self
        }
        /// <p>The ID of the KMS key used to encrypt the snapshot.</p>
        pub fn kms_key_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.kms_key_id(input);
            self
        }
        pub fn set_kms_key_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_kms_key_id(input);
            self
        }
        /// <p>A list of tags to be added to this resource. A tag is a key-value pair. A tag key must be accompanied by a tag value, although null is accepted.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct CreateUser<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::create_user_input::Builder,
    }
    impl<C> CreateUser<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::CreateUserOutput,
            smithy_http::result::SdkError<crate::error::CreateUserError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The ID of the user.</p>
        pub fn user_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.user_id(input);
            self
        }
        pub fn set_user_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_user_id(input);
            self
        }
        /// <p>The username of the user.</p>
        pub fn user_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.user_name(input);
            self
        }
        pub fn set_user_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_user_name(input);
            self
        }
        /// <p>The current supported value is Redis. </p>
        pub fn engine(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.engine(input);
            self
        }
        pub fn set_engine(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_engine(input);
            self
        }
        /// <p>Passwords used for this user. You can create up to two passwords for each user.</p>
        pub fn passwords(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.passwords(inp);
            self
        }
        pub fn set_passwords(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_passwords(input);
            self
        }
        /// <p>Access permissions string used for this user.</p>
        pub fn access_string(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.access_string(input);
            self
        }
        pub fn set_access_string(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_access_string(input);
            self
        }
        /// <p>Indicates a password is not required for this user.</p>
        pub fn no_password_required(mut self, input: bool) -> Self {
            self.inner = self.inner.no_password_required(input);
            self
        }
        pub fn set_no_password_required(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_no_password_required(input);
            self
        }
        /// <p>A list of tags to be added to this resource. A tag is a key-value pair. A tag key must be accompanied by a tag value, although null is accepted.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct CreateUserGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::create_user_group_input::Builder,
    }
    impl<C> CreateUserGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::CreateUserGroupOutput,
            smithy_http::result::SdkError<crate::error::CreateUserGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The ID of the user group.</p>
        pub fn user_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.user_group_id(input);
            self
        }
        pub fn set_user_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_user_group_id(input);
            self
        }
        /// <p>The current supported value is Redis. </p>
        pub fn engine(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.engine(input);
            self
        }
        pub fn set_engine(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_engine(input);
            self
        }
        /// <p>The list of user IDs that belong to the user group.</p>
        pub fn user_ids(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.user_ids(inp);
            self
        }
        pub fn set_user_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_user_ids(input);
            self
        }
        /// <p>A list of tags to be added to this resource. A tag is a key-value pair. A tag key must be accompanied by a tag value, although null is accepted.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DecreaseNodeGroupsInGlobalReplicationGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::decrease_node_groups_in_global_replication_group_input::Builder,
    }
    impl<C> DecreaseNodeGroupsInGlobalReplicationGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DecreaseNodeGroupsInGlobalReplicationGroupOutput,
            smithy_http::result::SdkError<
                crate::error::DecreaseNodeGroupsInGlobalReplicationGroupError,
            >,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the Global datastore</p>
        pub fn global_replication_group_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.global_replication_group_id(input);
            self
        }
        pub fn set_global_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_global_replication_group_id(input);
            self
        }
        /// <p>The number of node groups (shards) that results from the modification of the shard configuration</p>
        pub fn node_group_count(mut self, input: i32) -> Self {
            self.inner = self.inner.node_group_count(input);
            self
        }
        pub fn set_node_group_count(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_node_group_count(input);
            self
        }
        /// <p>If the value of NodeGroupCount is less than the current number of node groups (shards), then either NodeGroupsToRemove or NodeGroupsToRetain is required. GlobalNodeGroupsToRemove is a list of NodeGroupIds to remove from the cluster.
        /// ElastiCache for Redis will attempt to remove all node groups listed by GlobalNodeGroupsToRemove from the cluster. </p>
        pub fn global_node_groups_to_remove(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.global_node_groups_to_remove(inp);
            self
        }
        pub fn set_global_node_groups_to_remove(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_global_node_groups_to_remove(input);
            self
        }
        /// <p>If the value of NodeGroupCount is less than the current number of node groups (shards), then either NodeGroupsToRemove or NodeGroupsToRetain is required. GlobalNodeGroupsToRetain is a list of NodeGroupIds to retain from the cluster. ElastiCache for Redis will attempt to retain all node groups listed by GlobalNodeGroupsToRetain from the cluster.
        /// </p>
        pub fn global_node_groups_to_retain(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.global_node_groups_to_retain(inp);
            self
        }
        pub fn set_global_node_groups_to_retain(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_global_node_groups_to_retain(input);
            self
        }
        /// <p>Indicates that the shard reconfiguration process begins immediately. At present, the only permitted value for this parameter is true. </p>
        pub fn apply_immediately(mut self, input: bool) -> Self {
            self.inner = self.inner.apply_immediately(input);
            self
        }
        pub fn set_apply_immediately(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_apply_immediately(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DecreaseReplicaCount<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::decrease_replica_count_input::Builder,
    }
    impl<C> DecreaseReplicaCount<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DecreaseReplicaCountOutput,
            smithy_http::result::SdkError<crate::error::DecreaseReplicaCountError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The id of the replication group from which you want to remove replica nodes.</p>
        pub fn replication_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_id(input);
            self
        }
        pub fn set_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_id(input);
            self
        }
        /// <p>The number of read replica nodes you want at the completion of this operation.
        /// For Redis (cluster mode disabled) replication groups, this is the number of replica nodes in the
        /// replication group. For Redis (cluster mode enabled) replication groups, this is the number of
        /// replica nodes in each of the replication group's node groups.</p>
        /// <p>The minimum number of replicas in a shard or replication group is:</p>
        /// <ul>
        /// <li>
        /// <p>Redis (cluster mode disabled)</p>
        /// <ul>
        /// <li>
        /// <p>If Multi-AZ is enabled: 1</p>
        /// </li>
        /// <li>
        /// <p>If Multi-AZ is not enabled: 0</p>
        /// </li>
        /// </ul>
        /// </li>
        /// <li>
        /// <p>Redis (cluster mode enabled): 0 (though you will not be able to failover to a replica if your primary node fails)</p>
        /// </li>
        /// </ul>
        pub fn new_replica_count(mut self, input: i32) -> Self {
            self.inner = self.inner.new_replica_count(input);
            self
        }
        pub fn set_new_replica_count(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_new_replica_count(input);
            self
        }
        /// <p>A list of <code>ConfigureShard</code> objects that can be used to configure each shard
        /// in a Redis (cluster mode enabled) replication group. The <code>ConfigureShard</code> has three members:
        /// <code>NewReplicaCount</code>, <code>NodeGroupId</code>, and <code>PreferredAvailabilityZones</code>.</p>
        pub fn replica_configuration(
            mut self,
            inp: impl Into<crate::model::ConfigureShard>,
        ) -> Self {
            self.inner = self.inner.replica_configuration(inp);
            self
        }
        pub fn set_replica_configuration(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ConfigureShard>>,
        ) -> Self {
            self.inner = self.inner.set_replica_configuration(input);
            self
        }
        /// <p>A list of the node ids to remove from the replication group or node group (shard).</p>
        pub fn replicas_to_remove(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replicas_to_remove(inp);
            self
        }
        pub fn set_replicas_to_remove(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_replicas_to_remove(input);
            self
        }
        /// <p>If <code>True</code>, the number of replica nodes is decreased immediately.
        /// <code>ApplyImmediately=False</code> is not currently supported.</p>
        pub fn apply_immediately(mut self, input: bool) -> Self {
            self.inner = self.inner.apply_immediately(input);
            self
        }
        pub fn set_apply_immediately(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_apply_immediately(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteCacheCluster<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_cache_cluster_input::Builder,
    }
    impl<C> DeleteCacheCluster<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteCacheClusterOutput,
            smithy_http::result::SdkError<crate::error::DeleteCacheClusterError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The cluster identifier for the cluster to be deleted. This parameter is not case sensitive.</p>
        pub fn cache_cluster_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_cluster_id(input);
            self
        }
        pub fn set_cache_cluster_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_cluster_id(input);
            self
        }
        /// <p>The user-supplied name of a final cluster snapshot. This is the unique name that identifies the snapshot.
        /// ElastiCache creates the snapshot, and then deletes the cluster immediately afterward.</p>
        pub fn final_snapshot_identifier(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.final_snapshot_identifier(input);
            self
        }
        pub fn set_final_snapshot_identifier(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_final_snapshot_identifier(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteCacheParameterGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_cache_parameter_group_input::Builder,
    }
    impl<C> DeleteCacheParameterGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteCacheParameterGroupOutput,
            smithy_http::result::SdkError<crate::error::DeleteCacheParameterGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the cache parameter group to delete.</p>
        /// <note>
        /// <p>The specified cache security group must not be associated with any clusters.</p>
        /// </note>
        pub fn cache_parameter_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_parameter_group_name(input);
            self
        }
        pub fn set_cache_parameter_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_parameter_group_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteCacheSecurityGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_cache_security_group_input::Builder,
    }
    impl<C> DeleteCacheSecurityGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteCacheSecurityGroupOutput,
            smithy_http::result::SdkError<crate::error::DeleteCacheSecurityGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the cache security group to delete.</p>
        /// <note>
        /// <p>You cannot delete the default security group.</p>
        /// </note>
        pub fn cache_security_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_security_group_name(input);
            self
        }
        pub fn set_cache_security_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_security_group_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteCacheSubnetGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_cache_subnet_group_input::Builder,
    }
    impl<C> DeleteCacheSubnetGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteCacheSubnetGroupOutput,
            smithy_http::result::SdkError<crate::error::DeleteCacheSubnetGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the cache subnet group to delete.</p>
        /// <p>Constraints: Must contain no more than 255 alphanumeric characters or hyphens.</p>
        pub fn cache_subnet_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_subnet_group_name(input);
            self
        }
        pub fn set_cache_subnet_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_subnet_group_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteGlobalReplicationGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_global_replication_group_input::Builder,
    }
    impl<C> DeleteGlobalReplicationGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteGlobalReplicationGroupOutput,
            smithy_http::result::SdkError<crate::error::DeleteGlobalReplicationGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the Global datastore</p>
        pub fn global_replication_group_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.global_replication_group_id(input);
            self
        }
        pub fn set_global_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_global_replication_group_id(input);
            self
        }
        /// <p>The primary replication group is retained as a standalone replication group. </p>
        pub fn retain_primary_replication_group(mut self, input: bool) -> Self {
            self.inner = self.inner.retain_primary_replication_group(input);
            self
        }
        pub fn set_retain_primary_replication_group(
            mut self,
            input: std::option::Option<bool>,
        ) -> Self {
            self.inner = self.inner.set_retain_primary_replication_group(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteReplicationGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_replication_group_input::Builder,
    }
    impl<C> DeleteReplicationGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteReplicationGroupOutput,
            smithy_http::result::SdkError<crate::error::DeleteReplicationGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The identifier for the cluster to be deleted. This parameter is not case sensitive.</p>
        pub fn replication_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_id(input);
            self
        }
        pub fn set_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_id(input);
            self
        }
        /// <p>If set to <code>true</code>, all of the read replicas are deleted,
        /// but the primary node is retained.</p>
        pub fn retain_primary_cluster(mut self, input: bool) -> Self {
            self.inner = self.inner.retain_primary_cluster(input);
            self
        }
        pub fn set_retain_primary_cluster(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_retain_primary_cluster(input);
            self
        }
        /// <p>The name of a final node group (shard) snapshot.
        /// ElastiCache creates the snapshot from the primary node in the cluster,
        /// rather than one of the replicas; this is to ensure that it captures the freshest data.
        /// After the final snapshot is taken, the replication group is immediately deleted.</p>
        pub fn final_snapshot_identifier(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.final_snapshot_identifier(input);
            self
        }
        pub fn set_final_snapshot_identifier(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_final_snapshot_identifier(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteSnapshot<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_snapshot_input::Builder,
    }
    impl<C> DeleteSnapshot<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteSnapshotOutput,
            smithy_http::result::SdkError<crate::error::DeleteSnapshotError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the snapshot to be deleted.</p>
        pub fn snapshot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.snapshot_name(input);
            self
        }
        pub fn set_snapshot_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_snapshot_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteUser<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_user_input::Builder,
    }
    impl<C> DeleteUser<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteUserOutput,
            smithy_http::result::SdkError<crate::error::DeleteUserError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The ID of the user.</p>
        pub fn user_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.user_id(input);
            self
        }
        pub fn set_user_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_user_id(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteUserGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::delete_user_group_input::Builder,
    }
    impl<C> DeleteUserGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteUserGroupOutput,
            smithy_http::result::SdkError<crate::error::DeleteUserGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The ID of the user group.</p>
        pub fn user_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.user_group_id(input);
            self
        }
        pub fn set_user_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_user_group_id(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeCacheClusters<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::describe_cache_clusters_input::Builder,
    }
    impl<C> DescribeCacheClusters<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeCacheClustersOutput,
            smithy_http::result::SdkError<crate::error::DescribeCacheClustersError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The user-supplied cluster identifier. If this parameter is specified, only information
        /// about that specific cluster is returned. This parameter isn't case sensitive.</p>
        pub fn cache_cluster_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_cluster_id(input);
            self
        }
        pub fn set_cache_cluster_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_cluster_id(input);
            self
        }
        /// <p>The maximum number of records to include in the response. If more records exist than the
        /// specified <code>MaxRecords</code> value, a marker is included in the response so that
        /// the remaining results can be retrieved.</p>
        /// <p>Default: 100</p>
        /// <p>Constraints: minimum 20; maximum 100.</p>
        pub fn max_records(mut self, input: i32) -> Self {
            self.inner = self.inner.max_records(input);
            self
        }
        pub fn set_max_records(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_records(input);
            self
        }
        /// <p>An optional marker returned from a prior request.
        /// Use this marker for pagination of results from this operation. If this
        /// parameter is specified, the response includes only records beyond the marker, up to the
        /// value specified by <code>MaxRecords</code>.</p>
        pub fn marker(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.marker(input);
            self
        }
        pub fn set_marker(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_marker(input);
            self
        }
        /// <p>An optional flag that can be included in the <code>DescribeCacheCluster</code> request
        /// to retrieve information about the individual cache nodes.</p>
        pub fn show_cache_node_info(mut self, input: bool) -> Self {
            self.inner = self.inner.show_cache_node_info(input);
            self
        }
        pub fn set_show_cache_node_info(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_show_cache_node_info(input);
            self
        }
        /// <p>An optional flag that can be included in the <code>DescribeCacheCluster</code> request
        /// to show only nodes (API/CLI: clusters) that are not members of a replication group.
        /// In practice, this mean Memcached and single node Redis clusters.</p>
        pub fn show_cache_clusters_not_in_replication_groups(mut self, input: bool) -> Self {
            self.inner = self
                .inner
                .show_cache_clusters_not_in_replication_groups(input);
            self
        }
        pub fn set_show_cache_clusters_not_in_replication_groups(
            mut self,
            input: std::option::Option<bool>,
        ) -> Self {
            self.inner = self
                .inner
                .set_show_cache_clusters_not_in_replication_groups(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeCacheEngineVersions<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::describe_cache_engine_versions_input::Builder,
    }
    impl<C> DescribeCacheEngineVersions<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeCacheEngineVersionsOutput,
            smithy_http::result::SdkError<crate::error::DescribeCacheEngineVersionsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The cache engine to return. Valid values: <code>memcached</code> | <code>redis</code>
        /// </p>
        pub fn engine(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.engine(input);
            self
        }
        pub fn set_engine(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_engine(input);
            self
        }
        /// <p>The cache engine version to return.</p>
        /// <p>Example: <code>1.4.14</code>
        /// </p>
        pub fn engine_version(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.engine_version(input);
            self
        }
        pub fn set_engine_version(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_engine_version(input);
            self
        }
        /// <p>The name of a specific cache parameter group family to return details for.</p>
        /// <p>Valid values are:
        /// <code>memcached1.4</code> |
        /// <code>memcached1.5</code> |
        /// <code>memcached1.6</code> |
        /// <code>redis2.6</code> |
        /// <code>redis2.8</code> |
        /// <code>redis3.2</code> |
        /// <code>redis4.0</code> |
        /// <code>redis5.0</code> |
        /// <code>redis6.x</code> |
        /// </p>
        /// <p>Constraints:</p>
        /// <ul>
        /// <li>
        /// <p>Must be 1 to 255 alphanumeric characters</p>
        /// </li>
        /// <li>
        /// <p>First character must be a letter</p>
        /// </li>
        /// <li>
        /// <p>Cannot end with a hyphen or contain two consecutive hyphens</p>
        /// </li>
        /// </ul>
        pub fn cache_parameter_group_family(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.cache_parameter_group_family(input);
            self
        }
        pub fn set_cache_parameter_group_family(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_parameter_group_family(input);
            self
        }
        /// <p>The maximum number of records to include in the response. If more records exist than the
        /// specified <code>MaxRecords</code> value, a marker is included in the response so that
        /// the remaining results can be retrieved.</p>
        /// <p>Default: 100</p>
        /// <p>Constraints: minimum 20; maximum 100.</p>
        pub fn max_records(mut self, input: i32) -> Self {
            self.inner = self.inner.max_records(input);
            self
        }
        pub fn set_max_records(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_records(input);
            self
        }
        /// <p>An optional marker returned from a prior request. Use this marker for pagination of results from this operation.
        /// If this parameter is specified, the response includes only records beyond the marker, up to the
        /// value specified by <code>MaxRecords</code>.</p>
        pub fn marker(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.marker(input);
            self
        }
        pub fn set_marker(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_marker(input);
            self
        }
        /// <p>If <code>true</code>, specifies that only the default version of the specified engine or engine
        /// and major version combination is to be returned.</p>
        pub fn default_only(mut self, input: bool) -> Self {
            self.inner = self.inner.default_only(input);
            self
        }
        pub fn set_default_only(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_default_only(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeCacheParameterGroups<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::describe_cache_parameter_groups_input::Builder,
    }
    impl<C> DescribeCacheParameterGroups<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeCacheParameterGroupsOutput,
            smithy_http::result::SdkError<crate::error::DescribeCacheParameterGroupsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of a specific cache parameter group to return details for.</p>
        pub fn cache_parameter_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_parameter_group_name(input);
            self
        }
        pub fn set_cache_parameter_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_parameter_group_name(input);
            self
        }
        /// <p>The maximum number of records to include in the response. If more records exist than the
        /// specified <code>MaxRecords</code> value, a marker is included in the response so that
        /// the remaining results can be retrieved.</p>
        /// <p>Default: 100</p>
        /// <p>Constraints: minimum 20; maximum 100.</p>
        pub fn max_records(mut self, input: i32) -> Self {
            self.inner = self.inner.max_records(input);
            self
        }
        pub fn set_max_records(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_records(input);
            self
        }
        /// <p>An optional marker returned from a prior request. Use this marker for pagination of results from this operation.
        /// If this parameter is specified, the response includes only records beyond the marker, up to the
        /// value specified by <code>MaxRecords</code>.</p>
        pub fn marker(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.marker(input);
            self
        }
        pub fn set_marker(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_marker(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeCacheParameters<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::describe_cache_parameters_input::Builder,
    }
    impl<C> DescribeCacheParameters<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeCacheParametersOutput,
            smithy_http::result::SdkError<crate::error::DescribeCacheParametersError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of a specific cache parameter group to return details for.</p>
        pub fn cache_parameter_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_parameter_group_name(input);
            self
        }
        pub fn set_cache_parameter_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_parameter_group_name(input);
            self
        }
        /// <p>The parameter types to return.</p>
        /// <p>Valid values: <code>user</code> | <code>system</code> | <code>engine-default</code>
        /// </p>
        pub fn source(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.source(input);
            self
        }
        pub fn set_source(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_source(input);
            self
        }
        /// <p>The maximum number of records to include in the response. If more records exist than the
        /// specified <code>MaxRecords</code> value, a marker is included in the response so that
        /// the remaining results can be retrieved.</p>
        /// <p>Default: 100</p>
        /// <p>Constraints: minimum 20; maximum 100.</p>
        pub fn max_records(mut self, input: i32) -> Self {
            self.inner = self.inner.max_records(input);
            self
        }
        pub fn set_max_records(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_records(input);
            self
        }
        /// <p>An optional marker returned from a prior request.
        /// Use this marker for pagination of results from this operation.
        /// If this parameter is specified, the response includes only records beyond the marker, up to the
        /// value specified by <code>MaxRecords</code>.</p>
        pub fn marker(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.marker(input);
            self
        }
        pub fn set_marker(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_marker(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeCacheSecurityGroups<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::describe_cache_security_groups_input::Builder,
    }
    impl<C> DescribeCacheSecurityGroups<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeCacheSecurityGroupsOutput,
            smithy_http::result::SdkError<crate::error::DescribeCacheSecurityGroupsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the cache security group to return details for.</p>
        pub fn cache_security_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_security_group_name(input);
            self
        }
        pub fn set_cache_security_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_security_group_name(input);
            self
        }
        /// <p>The maximum number of records to include in the response. If more records exist than the
        /// specified <code>MaxRecords</code> value, a marker is included in the response so that
        /// the remaining results can be retrieved.</p>
        /// <p>Default: 100</p>
        /// <p>Constraints: minimum 20; maximum 100.</p>
        pub fn max_records(mut self, input: i32) -> Self {
            self.inner = self.inner.max_records(input);
            self
        }
        pub fn set_max_records(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_records(input);
            self
        }
        /// <p>An optional marker returned from a prior request. Use this marker for pagination of results from this operation. If this
        /// parameter is specified, the response includes only records beyond the marker, up to the
        /// value specified by <code>MaxRecords</code>.</p>
        pub fn marker(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.marker(input);
            self
        }
        pub fn set_marker(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_marker(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeCacheSubnetGroups<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::describe_cache_subnet_groups_input::Builder,
    }
    impl<C> DescribeCacheSubnetGroups<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeCacheSubnetGroupsOutput,
            smithy_http::result::SdkError<crate::error::DescribeCacheSubnetGroupsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the cache subnet group to return details for.</p>
        pub fn cache_subnet_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_subnet_group_name(input);
            self
        }
        pub fn set_cache_subnet_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_subnet_group_name(input);
            self
        }
        /// <p>The maximum number of records to include in the response. If more records exist than the
        /// specified <code>MaxRecords</code> value, a marker is included in the response so that
        /// the remaining results can be retrieved.</p>
        /// <p>Default: 100</p>
        /// <p>Constraints: minimum 20; maximum 100.</p>
        pub fn max_records(mut self, input: i32) -> Self {
            self.inner = self.inner.max_records(input);
            self
        }
        pub fn set_max_records(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_records(input);
            self
        }
        /// <p>An optional marker returned from a prior request.
        /// Use this marker for pagination of results from this operation.
        /// If this parameter is specified, the response includes only records beyond the marker, up to the
        /// value specified by <code>MaxRecords</code>.</p>
        pub fn marker(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.marker(input);
            self
        }
        pub fn set_marker(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_marker(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeEngineDefaultParameters<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::describe_engine_default_parameters_input::Builder,
    }
    impl<C> DescribeEngineDefaultParameters<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeEngineDefaultParametersOutput,
            smithy_http::result::SdkError<crate::error::DescribeEngineDefaultParametersError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the cache parameter group family.</p>
        /// <p>Valid values are:
        /// <code>memcached1.4</code> |
        /// <code>memcached1.5</code> |
        /// <code>memcached1.6</code> |
        /// <code>redis2.6</code> |
        /// <code>redis2.8</code> |
        /// <code>redis3.2</code> |
        /// <code>redis4.0</code> |
        /// <code>redis5.0</code> |
        /// <code>redis6.x</code> |
        /// </p>
        pub fn cache_parameter_group_family(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.cache_parameter_group_family(input);
            self
        }
        pub fn set_cache_parameter_group_family(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_parameter_group_family(input);
            self
        }
        /// <p>The maximum number of records to include in the response. If more records exist than the
        /// specified <code>MaxRecords</code> value, a marker is included in the response so that
        /// the remaining results can be retrieved.</p>
        /// <p>Default: 100</p>
        /// <p>Constraints: minimum 20; maximum 100.</p>
        pub fn max_records(mut self, input: i32) -> Self {
            self.inner = self.inner.max_records(input);
            self
        }
        pub fn set_max_records(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_records(input);
            self
        }
        /// <p>An optional marker returned from a prior request. Use this marker for pagination of results from this operation. If this
        /// parameter is specified, the response includes only records beyond the marker, up to the
        /// value specified by <code>MaxRecords</code>.</p>
        pub fn marker(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.marker(input);
            self
        }
        pub fn set_marker(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_marker(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeEvents<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::describe_events_input::Builder,
    }
    impl<C> DescribeEvents<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeEventsOutput,
            smithy_http::result::SdkError<crate::error::DescribeEventsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The identifier of the event source for which events are returned.
        /// If not specified, all sources are included in the response.</p>
        pub fn source_identifier(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.source_identifier(input);
            self
        }
        pub fn set_source_identifier(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_source_identifier(input);
            self
        }
        /// <p>The event source to retrieve events for.
        /// If no value is specified, all events are returned.</p>
        pub fn source_type(mut self, input: crate::model::SourceType) -> Self {
            self.inner = self.inner.source_type(input);
            self
        }
        pub fn set_source_type(
            mut self,
            input: std::option::Option<crate::model::SourceType>,
        ) -> Self {
            self.inner = self.inner.set_source_type(input);
            self
        }
        /// <p>The beginning of the time interval to retrieve events for, specified in ISO 8601 format.</p>
        /// <p>
        /// <b>Example:</b> 2017-03-30T07:03:49.555Z</p>
        pub fn start_time(mut self, input: smithy_types::Instant) -> Self {
            self.inner = self.inner.start_time(input);
            self
        }
        pub fn set_start_time(mut self, input: std::option::Option<smithy_types::Instant>) -> Self {
            self.inner = self.inner.set_start_time(input);
            self
        }
        /// <p>The end of the time interval for which to retrieve events, specified in ISO 8601 format.</p>
        /// <p>
        /// <b>Example:</b> 2017-03-30T07:03:49.555Z</p>
        pub fn end_time(mut self, input: smithy_types::Instant) -> Self {
            self.inner = self.inner.end_time(input);
            self
        }
        pub fn set_end_time(mut self, input: std::option::Option<smithy_types::Instant>) -> Self {
            self.inner = self.inner.set_end_time(input);
            self
        }
        /// <p>The number of minutes worth of events to retrieve.</p>
        pub fn duration(mut self, input: i32) -> Self {
            self.inner = self.inner.duration(input);
            self
        }
        pub fn set_duration(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_duration(input);
            self
        }
        /// <p>The maximum number of records to include in the response. If more records exist than the
        /// specified <code>MaxRecords</code> value, a marker is included in the response so that
        /// the remaining results can be retrieved.</p>
        /// <p>Default: 100</p>
        /// <p>Constraints: minimum 20; maximum 100.</p>
        pub fn max_records(mut self, input: i32) -> Self {
            self.inner = self.inner.max_records(input);
            self
        }
        pub fn set_max_records(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_records(input);
            self
        }
        /// <p>An optional marker returned from a prior request.
        /// Use this marker for pagination of results from this operation.
        /// If this parameter is specified, the response includes only records beyond the marker,
        /// up to the value specified by <code>MaxRecords</code>.</p>
        pub fn marker(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.marker(input);
            self
        }
        pub fn set_marker(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_marker(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeGlobalReplicationGroups<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::describe_global_replication_groups_input::Builder,
    }
    impl<C> DescribeGlobalReplicationGroups<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeGlobalReplicationGroupsOutput,
            smithy_http::result::SdkError<crate::error::DescribeGlobalReplicationGroupsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the Global datastore</p>
        pub fn global_replication_group_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.global_replication_group_id(input);
            self
        }
        pub fn set_global_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_global_replication_group_id(input);
            self
        }
        /// <p>The maximum number of records to include in the response. If more records exist than the specified MaxRecords value, a marker is included in the response so that the remaining results can be retrieved. </p>
        pub fn max_records(mut self, input: i32) -> Self {
            self.inner = self.inner.max_records(input);
            self
        }
        pub fn set_max_records(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_records(input);
            self
        }
        /// <p>An optional marker returned from a prior request. Use this marker for pagination of results from this operation. If this parameter is specified, the response includes only records beyond the marker, up to the value specified by <code>MaxRecords</code>. </p>
        pub fn marker(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.marker(input);
            self
        }
        pub fn set_marker(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_marker(input);
            self
        }
        /// <p>Returns the list of members that comprise the Global datastore.</p>
        pub fn show_member_info(mut self, input: bool) -> Self {
            self.inner = self.inner.show_member_info(input);
            self
        }
        pub fn set_show_member_info(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_show_member_info(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeReplicationGroups<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::describe_replication_groups_input::Builder,
    }
    impl<C> DescribeReplicationGroups<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeReplicationGroupsOutput,
            smithy_http::result::SdkError<crate::error::DescribeReplicationGroupsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The identifier for the replication group to be described. This parameter is not case sensitive.</p>
        /// <p>If you do not specify this parameter, information about all replication groups is returned.</p>
        pub fn replication_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_id(input);
            self
        }
        pub fn set_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_id(input);
            self
        }
        /// <p>The maximum number of records to include in the response. If more records exist than the
        /// specified <code>MaxRecords</code> value, a marker is included in the response so that
        /// the remaining results can be retrieved.</p>
        /// <p>Default: 100</p>
        /// <p>Constraints: minimum 20; maximum 100.</p>
        pub fn max_records(mut self, input: i32) -> Self {
            self.inner = self.inner.max_records(input);
            self
        }
        pub fn set_max_records(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_records(input);
            self
        }
        /// <p>An optional marker returned from a prior request. Use this marker for pagination of results from this operation. If this
        /// parameter is specified, the response includes only records beyond the marker, up to the
        /// value specified by <code>MaxRecords</code>.</p>
        pub fn marker(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.marker(input);
            self
        }
        pub fn set_marker(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_marker(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeReservedCacheNodes<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::describe_reserved_cache_nodes_input::Builder,
    }
    impl<C> DescribeReservedCacheNodes<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeReservedCacheNodesOutput,
            smithy_http::result::SdkError<crate::error::DescribeReservedCacheNodesError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The reserved cache node identifier filter value.
        /// Use this parameter to show only the reservation that matches the specified reservation ID.</p>
        pub fn reserved_cache_node_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.reserved_cache_node_id(input);
            self
        }
        pub fn set_reserved_cache_node_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_reserved_cache_node_id(input);
            self
        }
        /// <p>The offering identifier filter value.
        /// Use this parameter to show only purchased reservations matching the specified offering identifier.</p>
        pub fn reserved_cache_nodes_offering_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.reserved_cache_nodes_offering_id(input);
            self
        }
        pub fn set_reserved_cache_nodes_offering_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_reserved_cache_nodes_offering_id(input);
            self
        }
        /// <p>The cache node type filter value.
        /// Use this parameter to show only those reservations matching the specified cache node type.</p>
        /// <p>The following node types are supported by ElastiCache.
        /// Generally speaking, the current generation types provide more memory and computational power
        /// at lower cost when compared to their equivalent previous generation counterparts.</p>
        /// <ul>
        /// <li>
        /// <p>General purpose:</p>
        /// <ul>
        /// <li>
        /// <p>Current generation: </p>
        /// <p>
        /// <b>M6g node types</b> (available only for Redis engine version 5.0.6 onward and for Memcached engine version 1.5.16 onward).</p>
        /// <p>  
        /// <code>cache.m6g.large</code>,
        /// <code>cache.m6g.xlarge</code>,
        /// <code>cache.m6g.2xlarge</code>,
        /// <code>cache.m6g.4xlarge</code>,
        /// <code>cache.m6g.8xlarge</code>,
        /// <code>cache.m6g.12xlarge</code>,
        /// <code>cache.m6g.16xlarge</code>
        /// </p>  
        /// <note>
        /// <p>For region availability, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/CacheNodes.SupportedTypes.html#CacheNodes.SupportedTypesByRegion">Supported Node Types</a>
        /// </p>
        /// </note>
        /// <p>
        /// <b>M5 node types:</b>
        /// <code>cache.m5.large</code>,
        /// <code>cache.m5.xlarge</code>,
        /// <code>cache.m5.2xlarge</code>,
        /// <code>cache.m5.4xlarge</code>,
        /// <code>cache.m5.12xlarge</code>,
        /// <code>cache.m5.24xlarge</code>
        /// </p>  
        /// <p>
        /// <b>M4 node types:</b>
        /// <code>cache.m4.large</code>,
        /// <code>cache.m4.xlarge</code>,
        /// <code>cache.m4.2xlarge</code>,
        /// <code>cache.m4.4xlarge</code>,
        /// <code>cache.m4.10xlarge</code>
        /// </p>
        /// <p>
        /// <b>T3 node types:</b>
        /// <code>cache.t3.micro</code>,
        /// <code>cache.t3.small</code>,
        /// <code>cache.t3.medium</code>
        /// </p>
        /// <p>
        /// <b>T2 node types:</b>
        /// <code>cache.t2.micro</code>,
        /// <code>cache.t2.small</code>,
        /// <code>cache.t2.medium</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>Previous generation: (not recommended)</p>
        /// <p>
        /// <b>T1 node types:</b>
        /// <code>cache.t1.micro</code>
        /// </p>
        /// <p>
        /// <b>M1 node types:</b>
        /// <code>cache.m1.small</code>,
        /// <code>cache.m1.medium</code>,
        /// <code>cache.m1.large</code>,
        /// <code>cache.m1.xlarge</code>
        /// </p>
        /// <p>
        /// <b>M3 node types:</b>
        /// <code>cache.m3.medium</code>,
        /// <code>cache.m3.large</code>,
        /// <code>cache.m3.xlarge</code>,
        /// <code>cache.m3.2xlarge</code>
        /// </p>
        /// </li>
        /// </ul>
        /// </li>
        /// <li>
        /// <p>Compute optimized:</p>
        /// <ul>
        /// <li>
        /// <p>Previous generation: (not recommended)</p>
        /// <p>
        /// <b>C1 node types:</b>
        /// <code>cache.c1.xlarge</code>
        /// </p>
        /// </li>
        /// </ul>
        /// </li>
        /// <li>
        /// <p>Memory optimized:</p>
        /// <ul>
        /// <li>
        /// <p>Current generation: </p>
        /// <p>
        /// <b>R6g node types</b> (available only for Redis engine version 5.0.6 onward and for Memcached engine version 1.5.16 onward).</p>
        /// <p>  
        /// <code>cache.r6g.large</code>,
        /// <code>cache.r6g.xlarge</code>,
        /// <code>cache.r6g.2xlarge</code>,
        /// <code>cache.r6g.4xlarge</code>,
        /// <code>cache.r6g.8xlarge</code>,
        /// <code>cache.r6g.12xlarge</code>,
        /// <code>cache.r6g.16xlarge</code>
        /// </p>  
        /// <note>
        /// <p>For region availability, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/CacheNodes.SupportedTypes.html#CacheNodes.SupportedTypesByRegion">Supported Node Types</a>
        /// </p>
        /// </note>
        /// <p>
        /// <b>R5 node types:</b>
        /// <code>cache.r5.large</code>,
        /// <code>cache.r5.xlarge</code>,
        /// <code>cache.r5.2xlarge</code>,
        /// <code>cache.r5.4xlarge</code>,
        /// <code>cache.r5.12xlarge</code>,
        /// <code>cache.r5.24xlarge</code>
        /// </p>
        /// <p>
        /// <b>R4 node types:</b>
        /// <code>cache.r4.large</code>,
        /// <code>cache.r4.xlarge</code>,
        /// <code>cache.r4.2xlarge</code>,
        /// <code>cache.r4.4xlarge</code>,
        /// <code>cache.r4.8xlarge</code>,
        /// <code>cache.r4.16xlarge</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>Previous generation: (not recommended)</p>
        /// <p>
        /// <b>M2 node types:</b>            
        /// <code>cache.m2.xlarge</code>,
        /// <code>cache.m2.2xlarge</code>,
        /// <code>cache.m2.4xlarge</code>
        /// </p>
        /// <p>
        /// <b>R3 node types:</b>
        /// <code>cache.r3.large</code>,
        /// <code>cache.r3.xlarge</code>,
        /// <code>cache.r3.2xlarge</code>,  
        /// <code>cache.r3.4xlarge</code>,
        /// <code>cache.r3.8xlarge</code>
        /// </p>
        /// </li>
        /// </ul>
        /// </li>
        /// </ul>
        /// <p>
        /// <b>Additional node type info</b>
        /// </p>
        /// <ul>
        /// <li>
        /// <p>All current generation instance types are created in Amazon VPC by default.</p>
        /// </li>
        /// <li>
        /// <p>Redis append-only files (AOF) are not supported for T1 or T2 instances.</p>
        /// </li>
        /// <li>
        /// <p>Redis Multi-AZ with automatic failover is not supported on T1 instances.</p>
        /// </li>
        /// <li>
        /// <p>Redis configuration variables <code>appendonly</code> and
        /// <code>appendfsync</code> are not supported on Redis version 2.8.22 and later.</p>
        /// </li>
        /// </ul>
        pub fn cache_node_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_node_type(input);
            self
        }
        pub fn set_cache_node_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_node_type(input);
            self
        }
        /// <p>The duration filter value, specified in years or seconds.
        /// Use this parameter to show only reservations for this duration.</p>
        /// <p>Valid Values: <code>1 | 3 | 31536000 | 94608000</code>
        /// </p>
        pub fn duration(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.duration(input);
            self
        }
        pub fn set_duration(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_duration(input);
            self
        }
        /// <p>The product description filter value. Use this parameter to show only those reservations matching the specified product description.</p>
        pub fn product_description(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.product_description(input);
            self
        }
        pub fn set_product_description(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_product_description(input);
            self
        }
        /// <p>The offering type filter value.
        /// Use this parameter to show only the available offerings matching the specified offering type.</p>
        /// <p>Valid values: <code>"Light Utilization"|"Medium Utilization"|"Heavy Utilization"|"All Upfront"|"Partial Upfront"| "No Upfront"</code>
        /// </p>
        pub fn offering_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.offering_type(input);
            self
        }
        pub fn set_offering_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_offering_type(input);
            self
        }
        /// <p>The maximum number of records to include in the response. If more records exist than the
        /// specified <code>MaxRecords</code> value, a marker is included in the response so that
        /// the remaining results can be retrieved.</p>
        /// <p>Default: 100</p>
        /// <p>Constraints: minimum 20; maximum 100.</p>
        pub fn max_records(mut self, input: i32) -> Self {
            self.inner = self.inner.max_records(input);
            self
        }
        pub fn set_max_records(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_records(input);
            self
        }
        /// <p>An optional marker returned from a prior request.
        /// Use this marker for pagination of results from this operation.
        /// If this parameter is specified, the response includes only records beyond the marker,
        /// up to the value specified by <code>MaxRecords</code>.</p>
        pub fn marker(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.marker(input);
            self
        }
        pub fn set_marker(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_marker(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeReservedCacheNodesOfferings<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::describe_reserved_cache_nodes_offerings_input::Builder,
    }
    impl<C> DescribeReservedCacheNodesOfferings<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeReservedCacheNodesOfferingsOutput,
            smithy_http::result::SdkError<crate::error::DescribeReservedCacheNodesOfferingsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The offering identifier filter value.
        /// Use this parameter to show only the available offering that matches the specified reservation identifier.</p>
        /// <p>Example: <code>438012d3-4052-4cc7-b2e3-8d3372e0e706</code>
        /// </p>
        pub fn reserved_cache_nodes_offering_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.reserved_cache_nodes_offering_id(input);
            self
        }
        pub fn set_reserved_cache_nodes_offering_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_reserved_cache_nodes_offering_id(input);
            self
        }
        /// <p>The cache node type filter value.
        /// Use this parameter to show only the available offerings matching the specified cache node type.</p>
        /// <p>The following node types are supported by ElastiCache.
        /// Generally speaking, the current generation types provide more memory and computational power
        /// at lower cost when compared to their equivalent previous generation counterparts.</p>
        /// <ul>
        /// <li>
        /// <p>General purpose:</p>
        /// <ul>
        /// <li>
        /// <p>Current generation: </p>
        /// <p>
        /// <b>M6g node types</b> (available only for Redis engine version 5.0.6 onward and for Memcached engine version 1.5.16 onward).</p>
        /// <p>  
        /// <code>cache.m6g.large</code>,
        /// <code>cache.m6g.xlarge</code>,
        /// <code>cache.m6g.2xlarge</code>,
        /// <code>cache.m6g.4xlarge</code>,
        /// <code>cache.m6g.8xlarge</code>,
        /// <code>cache.m6g.12xlarge</code>,
        /// <code>cache.m6g.16xlarge</code>
        /// </p>  
        /// <note>
        /// <p>For region availability, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/CacheNodes.SupportedTypes.html#CacheNodes.SupportedTypesByRegion">Supported Node Types</a>
        /// </p>
        /// </note>
        /// <p>
        /// <b>M5 node types:</b>
        /// <code>cache.m5.large</code>,
        /// <code>cache.m5.xlarge</code>,
        /// <code>cache.m5.2xlarge</code>,
        /// <code>cache.m5.4xlarge</code>,
        /// <code>cache.m5.12xlarge</code>,
        /// <code>cache.m5.24xlarge</code>
        /// </p>  
        /// <p>
        /// <b>M4 node types:</b>
        /// <code>cache.m4.large</code>,
        /// <code>cache.m4.xlarge</code>,
        /// <code>cache.m4.2xlarge</code>,
        /// <code>cache.m4.4xlarge</code>,
        /// <code>cache.m4.10xlarge</code>
        /// </p>
        /// <p>
        /// <b>T3 node types:</b>
        /// <code>cache.t3.micro</code>,
        /// <code>cache.t3.small</code>,
        /// <code>cache.t3.medium</code>
        /// </p>
        /// <p>
        /// <b>T2 node types:</b>
        /// <code>cache.t2.micro</code>,
        /// <code>cache.t2.small</code>,
        /// <code>cache.t2.medium</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>Previous generation: (not recommended)</p>
        /// <p>
        /// <b>T1 node types:</b>
        /// <code>cache.t1.micro</code>
        /// </p>
        /// <p>
        /// <b>M1 node types:</b>
        /// <code>cache.m1.small</code>,
        /// <code>cache.m1.medium</code>,
        /// <code>cache.m1.large</code>,
        /// <code>cache.m1.xlarge</code>
        /// </p>
        /// <p>
        /// <b>M3 node types:</b>
        /// <code>cache.m3.medium</code>,
        /// <code>cache.m3.large</code>,
        /// <code>cache.m3.xlarge</code>,
        /// <code>cache.m3.2xlarge</code>
        /// </p>
        /// </li>
        /// </ul>
        /// </li>
        /// <li>
        /// <p>Compute optimized:</p>
        /// <ul>
        /// <li>
        /// <p>Previous generation: (not recommended)</p>
        /// <p>
        /// <b>C1 node types:</b>
        /// <code>cache.c1.xlarge</code>
        /// </p>
        /// </li>
        /// </ul>
        /// </li>
        /// <li>
        /// <p>Memory optimized:</p>
        /// <ul>
        /// <li>
        /// <p>Current generation: </p>
        /// <p>
        /// <b>R6g node types</b> (available only for Redis engine version 5.0.6 onward and for Memcached engine version 1.5.16 onward).</p>
        /// <p>  
        /// <code>cache.r6g.large</code>,
        /// <code>cache.r6g.xlarge</code>,
        /// <code>cache.r6g.2xlarge</code>,
        /// <code>cache.r6g.4xlarge</code>,
        /// <code>cache.r6g.8xlarge</code>,
        /// <code>cache.r6g.12xlarge</code>,
        /// <code>cache.r6g.16xlarge</code>
        /// </p>  
        /// <note>
        /// <p>For region availability, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/CacheNodes.SupportedTypes.html#CacheNodes.SupportedTypesByRegion">Supported Node Types</a>
        /// </p>
        /// </note>
        /// <p>
        /// <b>R5 node types:</b>
        /// <code>cache.r5.large</code>,
        /// <code>cache.r5.xlarge</code>,
        /// <code>cache.r5.2xlarge</code>,
        /// <code>cache.r5.4xlarge</code>,
        /// <code>cache.r5.12xlarge</code>,
        /// <code>cache.r5.24xlarge</code>
        /// </p>
        /// <p>
        /// <b>R4 node types:</b>
        /// <code>cache.r4.large</code>,
        /// <code>cache.r4.xlarge</code>,
        /// <code>cache.r4.2xlarge</code>,
        /// <code>cache.r4.4xlarge</code>,
        /// <code>cache.r4.8xlarge</code>,
        /// <code>cache.r4.16xlarge</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>Previous generation: (not recommended)</p>
        /// <p>
        /// <b>M2 node types:</b>            
        /// <code>cache.m2.xlarge</code>,
        /// <code>cache.m2.2xlarge</code>,
        /// <code>cache.m2.4xlarge</code>
        /// </p>
        /// <p>
        /// <b>R3 node types:</b>
        /// <code>cache.r3.large</code>,
        /// <code>cache.r3.xlarge</code>,
        /// <code>cache.r3.2xlarge</code>,  
        /// <code>cache.r3.4xlarge</code>,
        /// <code>cache.r3.8xlarge</code>
        /// </p>
        /// </li>
        /// </ul>
        /// </li>
        /// </ul>
        /// <p>
        /// <b>Additional node type info</b>
        /// </p>
        /// <ul>
        /// <li>
        /// <p>All current generation instance types are created in Amazon VPC by default.</p>
        /// </li>
        /// <li>
        /// <p>Redis append-only files (AOF) are not supported for T1 or T2 instances.</p>
        /// </li>
        /// <li>
        /// <p>Redis Multi-AZ with automatic failover is not supported on T1 instances.</p>
        /// </li>
        /// <li>
        /// <p>Redis configuration variables <code>appendonly</code> and
        /// <code>appendfsync</code> are not supported on Redis version 2.8.22 and later.</p>
        /// </li>
        /// </ul>
        pub fn cache_node_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_node_type(input);
            self
        }
        pub fn set_cache_node_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_node_type(input);
            self
        }
        /// <p>Duration filter value, specified in years or seconds.
        /// Use this parameter to show only reservations for a given duration.</p>
        /// <p>Valid Values: <code>1 | 3 | 31536000 | 94608000</code>
        /// </p>
        pub fn duration(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.duration(input);
            self
        }
        pub fn set_duration(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_duration(input);
            self
        }
        /// <p>The product description filter value.
        /// Use this parameter to show only the available offerings matching the specified product description.</p>
        pub fn product_description(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.product_description(input);
            self
        }
        pub fn set_product_description(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_product_description(input);
            self
        }
        /// <p>The offering type filter value.
        /// Use this parameter to show only the available offerings matching the specified offering type.</p>
        /// <p>Valid Values: <code>"Light Utilization"|"Medium Utilization"|"Heavy Utilization" |"All Upfront"|"Partial Upfront"| "No Upfront"</code>
        /// </p>
        pub fn offering_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.offering_type(input);
            self
        }
        pub fn set_offering_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_offering_type(input);
            self
        }
        /// <p>The maximum number of records to include in the response. If more records exist than the
        /// specified <code>MaxRecords</code> value, a marker is included in the response so that
        /// the remaining results can be retrieved.</p>
        /// <p>Default: 100</p>
        /// <p>Constraints: minimum 20; maximum 100.</p>
        pub fn max_records(mut self, input: i32) -> Self {
            self.inner = self.inner.max_records(input);
            self
        }
        pub fn set_max_records(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_records(input);
            self
        }
        /// <p>An optional marker returned from a prior request.
        /// Use this marker for pagination of results from this operation.
        /// If this parameter is specified, the response includes only records beyond the marker,
        /// up to the value specified by <code>MaxRecords</code>.</p>
        pub fn marker(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.marker(input);
            self
        }
        pub fn set_marker(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_marker(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeServiceUpdates<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::describe_service_updates_input::Builder,
    }
    impl<C> DescribeServiceUpdates<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeServiceUpdatesOutput,
            smithy_http::result::SdkError<crate::error::DescribeServiceUpdatesError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The unique ID of the service update</p>
        pub fn service_update_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.service_update_name(input);
            self
        }
        pub fn set_service_update_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_service_update_name(input);
            self
        }
        /// <p>The status of the service update</p>
        pub fn service_update_status(
            mut self,
            inp: impl Into<crate::model::ServiceUpdateStatus>,
        ) -> Self {
            self.inner = self.inner.service_update_status(inp);
            self
        }
        pub fn set_service_update_status(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ServiceUpdateStatus>>,
        ) -> Self {
            self.inner = self.inner.set_service_update_status(input);
            self
        }
        /// <p>The maximum number of records to include in the response</p>
        pub fn max_records(mut self, input: i32) -> Self {
            self.inner = self.inner.max_records(input);
            self
        }
        pub fn set_max_records(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_records(input);
            self
        }
        /// <p>An optional marker returned from a prior request.
        /// Use this marker for pagination of results from this operation. If this
        /// parameter is specified, the response includes only records beyond the marker, up to the
        /// value specified by <code>MaxRecords</code>.</p>
        pub fn marker(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.marker(input);
            self
        }
        pub fn set_marker(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_marker(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeSnapshots<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::describe_snapshots_input::Builder,
    }
    impl<C> DescribeSnapshots<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeSnapshotsOutput,
            smithy_http::result::SdkError<crate::error::DescribeSnapshotsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>A user-supplied replication group identifier.
        /// If this parameter is specified, only snapshots associated with that specific replication group are described.</p>
        pub fn replication_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_id(input);
            self
        }
        pub fn set_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_id(input);
            self
        }
        /// <p>A user-supplied cluster identifier.
        /// If this parameter is specified, only snapshots associated with that specific cluster are described.</p>
        pub fn cache_cluster_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_cluster_id(input);
            self
        }
        pub fn set_cache_cluster_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_cluster_id(input);
            self
        }
        /// <p>A user-supplied name of the snapshot.
        /// If this parameter is specified, only this snapshot are described.</p>
        pub fn snapshot_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.snapshot_name(input);
            self
        }
        pub fn set_snapshot_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_snapshot_name(input);
            self
        }
        /// <p>If set to <code>system</code>, the output shows snapshots that were automatically created by ElastiCache.
        /// If set to <code>user</code> the output shows snapshots that were manually created.
        /// If omitted, the output shows both automatically and manually created snapshots.</p>
        pub fn snapshot_source(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.snapshot_source(input);
            self
        }
        pub fn set_snapshot_source(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_snapshot_source(input);
            self
        }
        /// <p>An optional marker returned from a prior request.
        /// Use this marker for pagination of results from this operation.
        /// If this parameter is specified, the response includes only records beyond the marker,
        /// up to the value specified by <code>MaxRecords</code>.</p>
        pub fn marker(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.marker(input);
            self
        }
        pub fn set_marker(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_marker(input);
            self
        }
        /// <p>The maximum number of records to include in the response. If more records exist than the
        /// specified <code>MaxRecords</code> value, a marker is included in the response so that
        /// the remaining results can be retrieved.</p>
        /// <p>Default: 50</p>
        /// <p>Constraints: minimum 20; maximum 50.</p>
        pub fn max_records(mut self, input: i32) -> Self {
            self.inner = self.inner.max_records(input);
            self
        }
        pub fn set_max_records(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_records(input);
            self
        }
        /// <p>A Boolean value which if true, the node group (shard) configuration is included in the snapshot description.</p>
        pub fn show_node_group_config(mut self, input: bool) -> Self {
            self.inner = self.inner.show_node_group_config(input);
            self
        }
        pub fn set_show_node_group_config(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_show_node_group_config(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeUpdateActions<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::describe_update_actions_input::Builder,
    }
    impl<C> DescribeUpdateActions<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeUpdateActionsOutput,
            smithy_http::result::SdkError<crate::error::DescribeUpdateActionsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The unique ID of the service update</p>
        pub fn service_update_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.service_update_name(input);
            self
        }
        pub fn set_service_update_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_service_update_name(input);
            self
        }
        /// <p>The replication group IDs</p>
        pub fn replication_group_ids(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_ids(inp);
            self
        }
        pub fn set_replication_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_ids(input);
            self
        }
        /// <p>The cache cluster IDs</p>
        pub fn cache_cluster_ids(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_cluster_ids(inp);
            self
        }
        pub fn set_cache_cluster_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_cache_cluster_ids(input);
            self
        }
        /// <p>The Elasticache engine to which the update applies. Either Redis or Memcached </p>
        pub fn engine(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.engine(input);
            self
        }
        pub fn set_engine(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_engine(input);
            self
        }
        /// <p>The status of the service update</p>
        pub fn service_update_status(
            mut self,
            inp: impl Into<crate::model::ServiceUpdateStatus>,
        ) -> Self {
            self.inner = self.inner.service_update_status(inp);
            self
        }
        pub fn set_service_update_status(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ServiceUpdateStatus>>,
        ) -> Self {
            self.inner = self.inner.set_service_update_status(input);
            self
        }
        /// <p>The range of time specified to search for service updates that are in available status</p>
        pub fn service_update_time_range(mut self, input: crate::model::TimeRangeFilter) -> Self {
            self.inner = self.inner.service_update_time_range(input);
            self
        }
        pub fn set_service_update_time_range(
            mut self,
            input: std::option::Option<crate::model::TimeRangeFilter>,
        ) -> Self {
            self.inner = self.inner.set_service_update_time_range(input);
            self
        }
        /// <p>The status of the update action.</p>
        pub fn update_action_status(
            mut self,
            inp: impl Into<crate::model::UpdateActionStatus>,
        ) -> Self {
            self.inner = self.inner.update_action_status(inp);
            self
        }
        pub fn set_update_action_status(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::UpdateActionStatus>>,
        ) -> Self {
            self.inner = self.inner.set_update_action_status(input);
            self
        }
        /// <p>Dictates whether to include node level update status in the response </p>
        pub fn show_node_level_update_status(mut self, input: bool) -> Self {
            self.inner = self.inner.show_node_level_update_status(input);
            self
        }
        pub fn set_show_node_level_update_status(
            mut self,
            input: std::option::Option<bool>,
        ) -> Self {
            self.inner = self.inner.set_show_node_level_update_status(input);
            self
        }
        /// <p>The maximum number of records to include in the response</p>
        pub fn max_records(mut self, input: i32) -> Self {
            self.inner = self.inner.max_records(input);
            self
        }
        pub fn set_max_records(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_records(input);
            self
        }
        /// <p>An optional marker returned from a prior request.
        /// Use this marker for pagination of results from this operation. If this
        /// parameter is specified, the response includes only records beyond the marker, up to the
        /// value specified by <code>MaxRecords</code>.</p>
        pub fn marker(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.marker(input);
            self
        }
        pub fn set_marker(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_marker(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeUserGroups<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::describe_user_groups_input::Builder,
    }
    impl<C> DescribeUserGroups<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeUserGroupsOutput,
            smithy_http::result::SdkError<crate::error::DescribeUserGroupsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The ID of the user group.</p>
        pub fn user_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.user_group_id(input);
            self
        }
        pub fn set_user_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_user_group_id(input);
            self
        }
        /// <p>The maximum number of records to include in the response. If more records exist than the specified MaxRecords value, a marker is included in the response so that the remaining results can be retrieved. </p>
        pub fn max_records(mut self, input: i32) -> Self {
            self.inner = self.inner.max_records(input);
            self
        }
        pub fn set_max_records(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_records(input);
            self
        }
        /// <p>An optional marker returned from a prior request. Use this marker for pagination of results from this operation. If this parameter is specified, the response includes only records beyond the marker, up to the value specified by MaxRecords. ></p>
        pub fn marker(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.marker(input);
            self
        }
        pub fn set_marker(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_marker(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeUsers<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::describe_users_input::Builder,
    }
    impl<C> DescribeUsers<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeUsersOutput,
            smithy_http::result::SdkError<crate::error::DescribeUsersError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The Redis engine. </p>
        pub fn engine(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.engine(input);
            self
        }
        pub fn set_engine(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_engine(input);
            self
        }
        /// <p>The ID of the user.</p>
        pub fn user_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.user_id(input);
            self
        }
        pub fn set_user_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_user_id(input);
            self
        }
        /// <p>Filter to determine the list of User IDs to return.</p>
        pub fn filters(mut self, inp: impl Into<crate::model::Filter>) -> Self {
            self.inner = self.inner.filters(inp);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>The maximum number of records to include in the response. If more records exist than the specified MaxRecords value, a marker is included in the response so that the remaining results can be retrieved. </p>
        pub fn max_records(mut self, input: i32) -> Self {
            self.inner = self.inner.max_records(input);
            self
        }
        pub fn set_max_records(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_records(input);
            self
        }
        /// <p>An optional marker returned from a prior request. Use this marker for pagination of results from this operation. If this parameter is specified, the response includes only records beyond the marker, up to the value specified by MaxRecords. ></p>
        pub fn marker(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.marker(input);
            self
        }
        pub fn set_marker(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_marker(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DisassociateGlobalReplicationGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::disassociate_global_replication_group_input::Builder,
    }
    impl<C> DisassociateGlobalReplicationGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DisassociateGlobalReplicationGroupOutput,
            smithy_http::result::SdkError<crate::error::DisassociateGlobalReplicationGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the Global datastore</p>
        pub fn global_replication_group_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.global_replication_group_id(input);
            self
        }
        pub fn set_global_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_global_replication_group_id(input);
            self
        }
        /// <p>The name of the secondary cluster you wish to remove from the Global datastore</p>
        pub fn replication_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_id(input);
            self
        }
        pub fn set_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_id(input);
            self
        }
        /// <p>The AWS region of secondary cluster you wish to remove from the Global datastore</p>
        pub fn replication_group_region(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_region(input);
            self
        }
        pub fn set_replication_group_region(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_region(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct FailoverGlobalReplicationGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::failover_global_replication_group_input::Builder,
    }
    impl<C> FailoverGlobalReplicationGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::FailoverGlobalReplicationGroupOutput,
            smithy_http::result::SdkError<crate::error::FailoverGlobalReplicationGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the Global datastore</p>
        pub fn global_replication_group_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.global_replication_group_id(input);
            self
        }
        pub fn set_global_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_global_replication_group_id(input);
            self
        }
        /// <p>The AWS region of the primary cluster of the Global datastore</p>
        pub fn primary_region(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.primary_region(input);
            self
        }
        pub fn set_primary_region(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_primary_region(input);
            self
        }
        /// <p>The name of the primary replication group</p>
        pub fn primary_replication_group_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.primary_replication_group_id(input);
            self
        }
        pub fn set_primary_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_primary_replication_group_id(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct IncreaseNodeGroupsInGlobalReplicationGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::increase_node_groups_in_global_replication_group_input::Builder,
    }
    impl<C> IncreaseNodeGroupsInGlobalReplicationGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::IncreaseNodeGroupsInGlobalReplicationGroupOutput,
            smithy_http::result::SdkError<
                crate::error::IncreaseNodeGroupsInGlobalReplicationGroupError,
            >,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the Global datastore</p>
        pub fn global_replication_group_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.global_replication_group_id(input);
            self
        }
        pub fn set_global_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_global_replication_group_id(input);
            self
        }
        /// <p>The number of node groups you wish to add</p>
        pub fn node_group_count(mut self, input: i32) -> Self {
            self.inner = self.inner.node_group_count(input);
            self
        }
        pub fn set_node_group_count(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_node_group_count(input);
            self
        }
        /// <p>Describes the replication group IDs, the AWS regions where they are stored and the shard configuration for each that comprise the Global datastore</p>
        pub fn regional_configurations(
            mut self,
            inp: impl Into<crate::model::RegionalConfiguration>,
        ) -> Self {
            self.inner = self.inner.regional_configurations(inp);
            self
        }
        pub fn set_regional_configurations(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::RegionalConfiguration>>,
        ) -> Self {
            self.inner = self.inner.set_regional_configurations(input);
            self
        }
        /// <p>Indicates that the process begins immediately. At present, the only permitted value for this parameter is true.</p>
        pub fn apply_immediately(mut self, input: bool) -> Self {
            self.inner = self.inner.apply_immediately(input);
            self
        }
        pub fn set_apply_immediately(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_apply_immediately(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct IncreaseReplicaCount<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::increase_replica_count_input::Builder,
    }
    impl<C> IncreaseReplicaCount<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::IncreaseReplicaCountOutput,
            smithy_http::result::SdkError<crate::error::IncreaseReplicaCountError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The id of the replication group to which you want to add replica nodes.</p>
        pub fn replication_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_id(input);
            self
        }
        pub fn set_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_id(input);
            self
        }
        /// <p>The number of read replica nodes you want at the completion of this operation.
        /// For Redis (cluster mode disabled) replication groups, this is the number of replica nodes in the
        /// replication group. For Redis (cluster mode enabled) replication groups, this is the number of
        /// replica nodes in each of the replication group's node groups.</p>
        pub fn new_replica_count(mut self, input: i32) -> Self {
            self.inner = self.inner.new_replica_count(input);
            self
        }
        pub fn set_new_replica_count(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_new_replica_count(input);
            self
        }
        /// <p>A list of <code>ConfigureShard</code> objects that can be used to configure each shard
        /// in a Redis (cluster mode enabled) replication group. The <code>ConfigureShard</code> has three members:
        /// <code>NewReplicaCount</code>, <code>NodeGroupId</code>, and <code>PreferredAvailabilityZones</code>.</p>
        pub fn replica_configuration(
            mut self,
            inp: impl Into<crate::model::ConfigureShard>,
        ) -> Self {
            self.inner = self.inner.replica_configuration(inp);
            self
        }
        pub fn set_replica_configuration(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ConfigureShard>>,
        ) -> Self {
            self.inner = self.inner.set_replica_configuration(input);
            self
        }
        /// <p>If <code>True</code>, the number of replica nodes is increased immediately.
        /// <code>ApplyImmediately=False</code> is not currently supported.</p>
        pub fn apply_immediately(mut self, input: bool) -> Self {
            self.inner = self.inner.apply_immediately(input);
            self
        }
        pub fn set_apply_immediately(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_apply_immediately(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct ListAllowedNodeTypeModifications<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::list_allowed_node_type_modifications_input::Builder,
    }
    impl<C> ListAllowedNodeTypeModifications<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ListAllowedNodeTypeModificationsOutput,
            smithy_http::result::SdkError<crate::error::ListAllowedNodeTypeModificationsError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the cluster you want to scale up to a larger node instanced type.
        /// ElastiCache uses the cluster id to identify the current node type of this cluster and from that to create a list of node types you can scale up to.</p>
        /// <important>
        /// <p>You must provide a value for either the <code>CacheClusterId</code> or the
        /// <code>ReplicationGroupId</code>.</p>
        /// </important>
        pub fn cache_cluster_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_cluster_id(input);
            self
        }
        pub fn set_cache_cluster_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_cluster_id(input);
            self
        }
        /// <p>The name of the replication group want to scale up to a larger node type.
        /// ElastiCache uses the replication group id to identify the current node type being used by
        /// this replication group, and from that to create a list of node types you can scale up to.</p>
        /// <important>
        /// <p>You must provide a value for either the <code>CacheClusterId</code> or the
        /// <code>ReplicationGroupId</code>.</p>
        /// </important>
        pub fn replication_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_id(input);
            self
        }
        pub fn set_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_id(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct ListTagsForResource<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::list_tags_for_resource_input::Builder,
    }
    impl<C> ListTagsForResource<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ListTagsForResourceOutput,
            smithy_http::result::SdkError<crate::error::ListTagsForResourceError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The Amazon Resource Name (ARN) of the resource for which you want the list of tags,
        /// for example <code>arn:aws:elasticache:us-west-2:0123456789:cluster:myCluster</code>
        /// or <code>arn:aws:elasticache:us-west-2:0123456789:snapshot:mySnapshot</code>.</p>
        /// <p>For more information about ARNs, see <a href="https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html">Amazon Resource Names (ARNs) and AWS Service Namespaces</a>.</p>
        pub fn resource_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_name(input);
            self
        }
        pub fn set_resource_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_resource_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct ModifyCacheCluster<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::modify_cache_cluster_input::Builder,
    }
    impl<C> ModifyCacheCluster<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ModifyCacheClusterOutput,
            smithy_http::result::SdkError<crate::error::ModifyCacheClusterError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The cluster identifier. This value is stored as a lowercase string.</p>
        pub fn cache_cluster_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_cluster_id(input);
            self
        }
        pub fn set_cache_cluster_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_cluster_id(input);
            self
        }
        /// <p>The number of cache nodes that the cluster should have.
        /// If the value for <code>NumCacheNodes</code> is greater than the sum of the number of current cache nodes and
        /// the number of cache nodes pending creation (which may be zero), more nodes are added.
        /// If the value is less than the number of existing cache nodes,  nodes are removed.
        /// If the value is equal to the number of current cache nodes,
        /// any pending add or remove requests are canceled.</p>
        /// <p>If you are removing cache nodes, you must
        /// use the <code>CacheNodeIdsToRemove</code> parameter to provide the IDs of the specific cache nodes to remove.</p>
        /// <p>For clusters running Redis, this value must be 1.
        /// For clusters running Memcached, this value must be between 1 and 40.</p>
        /// <note>
        /// <p>Adding or removing Memcached cache nodes can be applied immediately or as a pending operation (see <code>ApplyImmediately</code>).</p>
        /// <p>A pending operation to modify the number of cache nodes in a cluster during its maintenance window,
        /// whether by adding or removing nodes in accordance with the scale out architecture, is not queued.
        /// The customer's latest request to add or remove nodes to the cluster overrides any previous pending operations to modify the
        /// number of cache nodes in the cluster.
        /// For example, a request to remove 2 nodes would override a previous pending operation to remove 3 nodes.
        /// Similarly, a request to add 2 nodes would override a previous pending operation to remove 3 nodes and vice versa.
        /// As Memcached cache nodes may now be provisioned in different Availability Zones with flexible cache node placement,
        /// a request to add nodes does not automatically override a previous pending operation to add nodes.
        /// The customer can modify the previous pending operation to add more nodes or explicitly cancel the pending request and
        /// retry the new request.
        /// To cancel pending operations to modify the number of cache nodes in a cluster,
        /// use the <code>ModifyCacheCluster</code> request and
        /// set <code>NumCacheNodes</code> equal to the number of cache nodes currently in the cluster.</p>
        /// </note>
        pub fn num_cache_nodes(mut self, input: i32) -> Self {
            self.inner = self.inner.num_cache_nodes(input);
            self
        }
        pub fn set_num_cache_nodes(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_num_cache_nodes(input);
            self
        }
        /// <p>A list of cache node IDs to be removed. A node ID is a numeric identifier (0001, 0002,
        /// etc.). This parameter is only valid when <code>NumCacheNodes</code> is less than the existing number
        /// of cache nodes. The number of cache node IDs supplied in this parameter must match the
        /// difference between the existing number of cache nodes in the cluster or pending cache nodes, whichever is
        /// greater, and the value of <code>NumCacheNodes</code> in the request.</p>
        /// <p>For example: If you have 3 active cache nodes, 7 pending cache nodes, and the number of cache nodes in this
        /// <code>ModifyCacheCluster</code> call is 5, you must list 2 (7 - 5) cache node IDs to remove.</p>
        pub fn cache_node_ids_to_remove(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_node_ids_to_remove(inp);
            self
        }
        pub fn set_cache_node_ids_to_remove(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_cache_node_ids_to_remove(input);
            self
        }
        /// <p>Specifies whether the new nodes in this Memcached cluster are all created in a
        /// single Availability Zone or created across multiple Availability Zones.</p>
        /// <p>Valid values: <code>single-az</code> | <code>cross-az</code>.</p>
        /// <p>This option is only supported for Memcached clusters.</p>
        /// <note>
        /// <p>You cannot specify <code>single-az</code> if the Memcached cluster already has cache nodes in different Availability Zones.            
        /// If <code>cross-az</code> is specified, existing Memcached nodes remain in their current Availability Zone.</p>
        /// <p>Only newly created nodes are located in different Availability Zones.
        /// </p>
        /// </note>
        pub fn az_mode(mut self, input: crate::model::AzMode) -> Self {
            self.inner = self.inner.az_mode(input);
            self
        }
        pub fn set_az_mode(mut self, input: std::option::Option<crate::model::AzMode>) -> Self {
            self.inner = self.inner.set_az_mode(input);
            self
        }
        /// <note>
        /// <p>This option is only supported on Memcached clusters.</p>
        /// </note>
        /// <p>The list of Availability Zones where the new Memcached cache nodes are created.</p>  
        /// <p>This parameter is only valid when <code>NumCacheNodes</code> in the request is greater
        /// than the sum of the number of active cache nodes and the number of cache nodes pending creation (which may be zero).
        /// The number of Availability Zones supplied in this list must match the cache nodes being added in this request.</p>
        /// <p>Scenarios:</p>
        /// <ul>
        /// <li>
        /// <p>
        /// <b>Scenario 1:</b> You have 3 active nodes and wish to add 2 nodes.
        /// Specify <code>NumCacheNodes=5</code> (3 + 2) and optionally specify two Availability Zones
        /// for the two new nodes.</p>
        /// </li>
        /// <li>
        /// <p>
        /// <b>Scenario 2:</b> You have 3 active nodes and 2 nodes pending creation
        /// (from the scenario 1 call) and want to add 1 more node.
        /// Specify <code>NumCacheNodes=6</code> ((3 + 2) + 1) and
        /// optionally specify an Availability Zone for the new node.</p>
        /// </li>
        /// <li>
        /// <p>
        /// <b>Scenario 3:</b> You want to cancel all pending operations.
        /// Specify <code>NumCacheNodes=3</code> to cancel all pending operations.</p>
        /// </li>
        /// </ul>
        /// <p>The Availability Zone placement of nodes pending creation cannot be modified. If you wish to cancel any nodes pending creation,
        /// add 0 nodes by setting <code>NumCacheNodes</code> to the number of current nodes.</p>
        /// <p>If <code>cross-az</code> is specified, existing Memcached nodes remain in their current Availability Zone.
        /// Only newly created nodes can be located in different Availability Zones.
        /// For guidance on how to move existing Memcached nodes to different Availability Zones, see the
        /// <b>Availability Zone Considerations</b> section of <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/mem-ug/CacheNodes.SupportedTypes.html">Cache Node Considerations for Memcached</a>.</p>
        /// <p>
        /// <b>Impact of new add/remove requests upon pending requests</b>
        /// </p>
        /// <ul>
        /// <li>
        /// <p>Scenario-1</p>
        /// <ul>
        /// <li>
        /// <p>Pending Action: Delete</p>
        /// </li>
        /// <li>
        /// <p>New Request: Delete</p>
        /// </li>
        /// <li>
        /// <p>Result: The new delete, pending or immediate, replaces the pending delete.</p>
        /// </li>
        /// </ul>
        /// </li>
        /// <li>
        /// <p>Scenario-2</p>
        /// <ul>
        /// <li>
        /// <p>Pending Action: Delete</p>
        /// </li>
        /// <li>
        /// <p>New Request: Create</p>
        /// </li>
        /// <li>
        /// <p>Result: The new create, pending or immediate, replaces the pending delete.</p>
        /// </li>
        /// </ul>
        /// </li>
        /// <li>
        /// <p>Scenario-3</p>
        /// <ul>
        /// <li>
        /// <p>Pending Action: Create</p>
        /// </li>
        /// <li>
        /// <p>New Request: Delete</p>
        /// </li>
        /// <li>
        /// <p>Result: The new delete, pending or immediate, replaces the pending create.</p>
        /// </li>
        /// </ul>
        /// </li>
        /// <li>
        /// <p>Scenario-4</p>
        /// <ul>
        /// <li>
        /// <p>Pending Action: Create</p>
        /// </li>
        /// <li>
        /// <p>New Request: Create</p>
        /// </li>
        /// <li>
        /// <p>Result: The new create is added to the pending create.</p>
        /// <important>
        /// <p>
        /// <b>Important:</b>
        /// If the new create request is <b>Apply Immediately - Yes</b>,
        /// all creates are performed immediately.
        /// If the new create request is <b>Apply Immediately - No</b>,
        /// all creates are pending.</p>
        /// </important>
        /// </li>
        /// </ul>
        /// </li>
        /// </ul>
        pub fn new_availability_zones(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.new_availability_zones(inp);
            self
        }
        pub fn set_new_availability_zones(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_new_availability_zones(input);
            self
        }
        /// <p>A list of cache security group names to authorize on this cluster.
        /// This change is asynchronously applied as soon as possible.</p>
        /// <p>You can use this parameter only with clusters that are created outside of an Amazon Virtual Private Cloud (Amazon VPC).</p>
        /// <p>Constraints: Must contain no more than 255 alphanumeric characters. Must not be "Default".</p>
        pub fn cache_security_group_names(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_security_group_names(inp);
            self
        }
        pub fn set_cache_security_group_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_cache_security_group_names(input);
            self
        }
        /// <p>Specifies the VPC Security Groups associated with the cluster.</p>
        /// <p>This parameter can be used only with clusters that are created in an Amazon Virtual Private Cloud (Amazon VPC).</p>
        pub fn security_group_ids(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.security_group_ids(inp);
            self
        }
        pub fn set_security_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_security_group_ids(input);
            self
        }
        /// <p>Specifies the weekly time range during which maintenance
        /// on the cluster is performed. It is specified as a range in
        /// the format ddd:hh24:mi-ddd:hh24:mi (24H Clock UTC). The minimum
        /// maintenance window is a 60 minute period.</p>
        /// <p>Valid values for <code>ddd</code> are:</p>
        /// <ul>
        /// <li>
        /// <p>
        /// <code>sun</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>mon</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>tue</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>wed</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>thu</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>fri</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>sat</code>
        /// </p>
        /// </li>
        /// </ul>
        /// <p>Example: <code>sun:23:00-mon:01:30</code>
        /// </p>
        pub fn preferred_maintenance_window(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.preferred_maintenance_window(input);
            self
        }
        pub fn set_preferred_maintenance_window(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_preferred_maintenance_window(input);
            self
        }
        /// <p>The Amazon Resource Name (ARN) of the Amazon SNS topic to which notifications are sent.</p>
        /// <note>
        /// <p>The Amazon SNS topic owner must be same as the cluster owner.</p>
        /// </note>
        pub fn notification_topic_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.notification_topic_arn(input);
            self
        }
        pub fn set_notification_topic_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_notification_topic_arn(input);
            self
        }
        /// <p>The name of the cache parameter group to apply to this cluster. This change is
        /// asynchronously applied as soon as possible for parameters when the
        /// <code>ApplyImmediately</code> parameter is specified as <code>true</code> for this request.</p>
        pub fn cache_parameter_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_parameter_group_name(input);
            self
        }
        pub fn set_cache_parameter_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_parameter_group_name(input);
            self
        }
        /// <p>The status of the Amazon SNS notification topic. Notifications are sent only if the
        /// status is <code>active</code>.</p>
        /// <p>Valid values: <code>active</code> | <code>inactive</code>
        /// </p>
        pub fn notification_topic_status(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.notification_topic_status(input);
            self
        }
        pub fn set_notification_topic_status(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_notification_topic_status(input);
            self
        }
        /// <p>If <code>true</code>, this parameter causes the modifications in this request and any
        /// pending modifications to be applied, asynchronously and as soon as possible, regardless
        /// of the <code>PreferredMaintenanceWindow</code> setting for the cluster.</p>
        /// <p>If <code>false</code>, changes to the cluster are applied on the next
        /// maintenance reboot, or the next failure reboot, whichever occurs first.</p>
        /// <important>
        /// <p>If you perform a <code>ModifyCacheCluster</code> before a pending modification is applied,
        /// the pending modification is replaced by the newer modification.</p>
        /// </important>
        /// <p>Valid values: <code>true</code> | <code>false</code>
        /// </p>
        /// <p>Default: <code>false</code>
        /// </p>
        pub fn apply_immediately(mut self, input: bool) -> Self {
            self.inner = self.inner.apply_immediately(input);
            self
        }
        pub fn set_apply_immediately(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_apply_immediately(input);
            self
        }
        /// <p>The upgraded version of the cache engine to be run on the cache nodes.</p>
        /// <p>
        /// <b>Important:</b> You can upgrade to a newer engine version
        /// (see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/SelectEngine.html#VersionManagement">Selecting a Cache Engine and Version</a>), but you cannot downgrade to an earlier engine version.
        /// If you want to use an earlier engine version,
        /// you must delete the existing cluster and create it anew with the earlier engine version. </p>
        pub fn engine_version(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.engine_version(input);
            self
        }
        pub fn set_engine_version(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_engine_version(input);
            self
        }
        /// <p>This parameter is currently disabled.</p>
        pub fn auto_minor_version_upgrade(mut self, input: bool) -> Self {
            self.inner = self.inner.auto_minor_version_upgrade(input);
            self
        }
        pub fn set_auto_minor_version_upgrade(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_auto_minor_version_upgrade(input);
            self
        }
        /// <p>The number of days for which ElastiCache retains automatic cluster snapshots before
        /// deleting them. For example, if you set <code>SnapshotRetentionLimit</code> to 5,  a
        /// snapshot that was taken today is retained for 5 days before being deleted.</p>
        /// <note>
        /// <p>If the value of <code>SnapshotRetentionLimit</code> is set to zero (0), backups are turned off.</p>
        /// </note>
        pub fn snapshot_retention_limit(mut self, input: i32) -> Self {
            self.inner = self.inner.snapshot_retention_limit(input);
            self
        }
        pub fn set_snapshot_retention_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_snapshot_retention_limit(input);
            self
        }
        /// <p>The daily time range (in UTC) during which ElastiCache  begins taking a daily snapshot of
        /// your cluster. </p>
        pub fn snapshot_window(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.snapshot_window(input);
            self
        }
        pub fn set_snapshot_window(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_snapshot_window(input);
            self
        }
        /// <p>A valid cache node type that you want to scale this cluster up to.</p>
        pub fn cache_node_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_node_type(input);
            self
        }
        pub fn set_cache_node_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_node_type(input);
            self
        }
        /// <p>Reserved parameter. The password used to access a password protected server. This parameter must be specified with the <code>auth-token-update</code> parameter.
        /// Password constraints:</p>
        /// <ul>
        /// <li>
        /// <p>Must be only printable ASCII characters</p>
        /// </li>
        /// <li>
        /// <p>Must be at least 16 characters and no more than 128 characters in length</p>
        /// </li>
        /// <li>
        /// <p>Cannot contain any of the following characters: '/', '"', or '@', '%'</p>
        /// </li>
        /// </ul>
        /// <p>     
        /// For more information, see AUTH password at <a href="http://redis.io/commands/AUTH">AUTH</a>.</p>
        pub fn auth_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.auth_token(input);
            self
        }
        pub fn set_auth_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_auth_token(input);
            self
        }
        /// <p>Specifies the strategy to use to update the AUTH token. This parameter must be specified with the <code>auth-token</code> parameter.
        /// Possible values:</p>
        /// <ul>
        /// <li>
        /// <p>Rotate</p>
        /// </li>
        /// <li>
        /// <p>Set</p>
        /// </li>
        /// </ul>
        /// <p>
        /// For more information, see <a href="http://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/auth.html">Authenticating Users with Redis AUTH</a>
        /// </p>
        pub fn auth_token_update_strategy(
            mut self,
            input: crate::model::AuthTokenUpdateStrategyType,
        ) -> Self {
            self.inner = self.inner.auth_token_update_strategy(input);
            self
        }
        pub fn set_auth_token_update_strategy(
            mut self,
            input: std::option::Option<crate::model::AuthTokenUpdateStrategyType>,
        ) -> Self {
            self.inner = self.inner.set_auth_token_update_strategy(input);
            self
        }
        /// <p>Specifies the destination, format and type of the logs.</p>
        pub fn log_delivery_configurations(
            mut self,
            inp: impl Into<crate::model::LogDeliveryConfigurationRequest>,
        ) -> Self {
            self.inner = self.inner.log_delivery_configurations(inp);
            self
        }
        pub fn set_log_delivery_configurations(
            mut self,
            input: std::option::Option<
                std::vec::Vec<crate::model::LogDeliveryConfigurationRequest>,
            >,
        ) -> Self {
            self.inner = self.inner.set_log_delivery_configurations(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct ModifyCacheParameterGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::modify_cache_parameter_group_input::Builder,
    }
    impl<C> ModifyCacheParameterGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ModifyCacheParameterGroupOutput,
            smithy_http::result::SdkError<crate::error::ModifyCacheParameterGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the cache parameter group to modify.</p>
        pub fn cache_parameter_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_parameter_group_name(input);
            self
        }
        pub fn set_cache_parameter_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_parameter_group_name(input);
            self
        }
        /// <p>An array of parameter names and values for the parameter update. You must supply at least one parameter name and value; subsequent arguments are optional. A maximum of 20 parameters may be modified per request.</p>
        pub fn parameter_name_values(
            mut self,
            inp: impl Into<crate::model::ParameterNameValue>,
        ) -> Self {
            self.inner = self.inner.parameter_name_values(inp);
            self
        }
        pub fn set_parameter_name_values(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ParameterNameValue>>,
        ) -> Self {
            self.inner = self.inner.set_parameter_name_values(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct ModifyCacheSubnetGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::modify_cache_subnet_group_input::Builder,
    }
    impl<C> ModifyCacheSubnetGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ModifyCacheSubnetGroupOutput,
            smithy_http::result::SdkError<crate::error::ModifyCacheSubnetGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name for the cache subnet group. This value is stored as a lowercase string.</p>
        /// <p>Constraints: Must contain no more than 255 alphanumeric characters or hyphens.</p>
        /// <p>Example: <code>mysubnetgroup</code>
        /// </p>
        pub fn cache_subnet_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_subnet_group_name(input);
            self
        }
        pub fn set_cache_subnet_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_subnet_group_name(input);
            self
        }
        /// <p>A description of the cache subnet group.</p>
        pub fn cache_subnet_group_description(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.cache_subnet_group_description(input);
            self
        }
        pub fn set_cache_subnet_group_description(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_subnet_group_description(input);
            self
        }
        /// <p>The EC2 subnet IDs for the cache subnet group.</p>
        pub fn subnet_ids(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.subnet_ids(inp);
            self
        }
        pub fn set_subnet_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_subnet_ids(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct ModifyGlobalReplicationGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::modify_global_replication_group_input::Builder,
    }
    impl<C> ModifyGlobalReplicationGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ModifyGlobalReplicationGroupOutput,
            smithy_http::result::SdkError<crate::error::ModifyGlobalReplicationGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the Global datastore</p>
        pub fn global_replication_group_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.global_replication_group_id(input);
            self
        }
        pub fn set_global_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_global_replication_group_id(input);
            self
        }
        /// <p>This parameter causes the modifications in this request and any pending modifications to be applied, asynchronously and as soon as possible. Modifications to Global
        /// Replication Groups cannot be requested to be applied in PreferredMaintenceWindow.
        /// </p>
        pub fn apply_immediately(mut self, input: bool) -> Self {
            self.inner = self.inner.apply_immediately(input);
            self
        }
        pub fn set_apply_immediately(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_apply_immediately(input);
            self
        }
        /// <p>A valid cache node type that you want to scale this Global datastore to.</p>
        pub fn cache_node_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_node_type(input);
            self
        }
        pub fn set_cache_node_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_node_type(input);
            self
        }
        /// <p>The upgraded version of the cache engine to be run on the clusters in the Global datastore. </p>
        pub fn engine_version(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.engine_version(input);
            self
        }
        pub fn set_engine_version(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_engine_version(input);
            self
        }
        /// <p>The name of the cache parameter group to use with the Global datastore. It must be compatible with the major engine version used by the Global datastore.</p>
        pub fn cache_parameter_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_parameter_group_name(input);
            self
        }
        pub fn set_cache_parameter_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_parameter_group_name(input);
            self
        }
        /// <p>A description of the Global datastore</p>
        pub fn global_replication_group_description(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.global_replication_group_description(input);
            self
        }
        pub fn set_global_replication_group_description(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_global_replication_group_description(input);
            self
        }
        /// <p>Determines whether a read replica is automatically promoted to read/write primary if the existing primary encounters a failure. </p>
        pub fn automatic_failover_enabled(mut self, input: bool) -> Self {
            self.inner = self.inner.automatic_failover_enabled(input);
            self
        }
        pub fn set_automatic_failover_enabled(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_automatic_failover_enabled(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct ModifyReplicationGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::modify_replication_group_input::Builder,
    }
    impl<C> ModifyReplicationGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ModifyReplicationGroupOutput,
            smithy_http::result::SdkError<crate::error::ModifyReplicationGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The identifier of the replication group to modify.</p>
        pub fn replication_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_id(input);
            self
        }
        pub fn set_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_id(input);
            self
        }
        /// <p>A description for the replication group. Maximum length is 255 characters.</p>
        pub fn replication_group_description(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.replication_group_description(input);
            self
        }
        pub fn set_replication_group_description(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_description(input);
            self
        }
        /// <p>For replication groups with a single primary,
        /// if this parameter is specified, ElastiCache promotes the specified cluster in the specified replication group to the primary role.
        /// The nodes of all other clusters in the replication group are read replicas.</p>
        pub fn primary_cluster_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.primary_cluster_id(input);
            self
        }
        pub fn set_primary_cluster_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_primary_cluster_id(input);
            self
        }
        /// <p>The cluster ID that is used as the daily snapshot source for the replication group.
        /// This parameter cannot be set for Redis (cluster mode enabled) replication groups.</p>
        pub fn snapshotting_cluster_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.snapshotting_cluster_id(input);
            self
        }
        pub fn set_snapshotting_cluster_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_snapshotting_cluster_id(input);
            self
        }
        /// <p>Determines whether a read replica is automatically promoted to read/write primary if the existing primary encounters a failure.</p>
        /// <p>Valid values: <code>true</code> | <code>false</code>
        /// </p>
        pub fn automatic_failover_enabled(mut self, input: bool) -> Self {
            self.inner = self.inner.automatic_failover_enabled(input);
            self
        }
        pub fn set_automatic_failover_enabled(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_automatic_failover_enabled(input);
            self
        }
        /// <p>A list of tags to be added to this resource. A tag is a key-value pair. A tag key must be accompanied by a tag value, although null is accepted.</p>
        pub fn multi_az_enabled(mut self, input: bool) -> Self {
            self.inner = self.inner.multi_az_enabled(input);
            self
        }
        pub fn set_multi_az_enabled(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_multi_az_enabled(input);
            self
        }
        /// <p>Deprecated. This parameter is not used.</p>
        pub fn node_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.node_group_id(input);
            self
        }
        pub fn set_node_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_node_group_id(input);
            self
        }
        /// <p>A list of cache security group names to authorize for the clusters in this replication group. This change is asynchronously applied as soon as possible.</p>
        /// <p>This parameter can be used only with replication group containing clusters running outside of an Amazon Virtual Private Cloud (Amazon VPC).</p>
        /// <p>Constraints: Must contain no more than 255 alphanumeric characters. Must not be <code>Default</code>.</p>
        pub fn cache_security_group_names(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_security_group_names(inp);
            self
        }
        pub fn set_cache_security_group_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_cache_security_group_names(input);
            self
        }
        /// <p>Specifies the VPC Security Groups associated with the clusters in the replication group.</p>
        /// <p>This parameter can be used only with replication group containing clusters running in
        /// an Amazon Virtual Private Cloud (Amazon VPC).</p>
        pub fn security_group_ids(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.security_group_ids(inp);
            self
        }
        pub fn set_security_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_security_group_ids(input);
            self
        }
        /// <p>Specifies the weekly time range during which maintenance
        /// on the cluster is performed. It is specified as a range in
        /// the format ddd:hh24:mi-ddd:hh24:mi (24H Clock UTC). The minimum
        /// maintenance window is a 60 minute period.</p>
        /// <p>Valid values for <code>ddd</code> are:</p>
        /// <ul>
        /// <li>
        /// <p>
        /// <code>sun</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>mon</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>tue</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>wed</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>thu</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>fri</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>sat</code>
        /// </p>
        /// </li>
        /// </ul>
        /// <p>Example: <code>sun:23:00-mon:01:30</code>
        /// </p>
        pub fn preferred_maintenance_window(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.preferred_maintenance_window(input);
            self
        }
        pub fn set_preferred_maintenance_window(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_preferred_maintenance_window(input);
            self
        }
        /// <p>The Amazon Resource Name (ARN) of the Amazon SNS topic to which notifications are sent.</p>
        /// <note>
        /// <p>The Amazon SNS topic owner must be same as the replication group owner. </p>
        /// </note>
        pub fn notification_topic_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.notification_topic_arn(input);
            self
        }
        pub fn set_notification_topic_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_notification_topic_arn(input);
            self
        }
        /// <p>The name of the cache parameter group to apply to all of the clusters in this replication group.
        /// This change is asynchronously applied as soon as possible for parameters when the
        /// <code>ApplyImmediately</code> parameter is specified as <code>true</code> for this request.</p>
        pub fn cache_parameter_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_parameter_group_name(input);
            self
        }
        pub fn set_cache_parameter_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_parameter_group_name(input);
            self
        }
        /// <p>The status of the Amazon SNS notification topic for the replication group.
        /// Notifications are sent only if the status is <code>active</code>.</p>
        /// <p>Valid values: <code>active</code> | <code>inactive</code>
        /// </p>
        pub fn notification_topic_status(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.notification_topic_status(input);
            self
        }
        pub fn set_notification_topic_status(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_notification_topic_status(input);
            self
        }
        /// <p>If <code>true</code>, this parameter causes the modifications in this request and any
        /// pending modifications to be applied, asynchronously and as soon as possible, regardless
        /// of the <code>PreferredMaintenanceWindow</code> setting for the replication group.</p>
        /// <p>If <code>false</code>, changes to the nodes in the replication group are applied on
        /// the next maintenance reboot, or the next failure reboot, whichever occurs first.</p>
        /// <p>Valid values: <code>true</code> | <code>false</code>
        /// </p>
        /// <p>Default: <code>false</code>
        /// </p>
        pub fn apply_immediately(mut self, input: bool) -> Self {
            self.inner = self.inner.apply_immediately(input);
            self
        }
        pub fn set_apply_immediately(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_apply_immediately(input);
            self
        }
        /// <p>The upgraded version of the cache engine to be run on the clusters in the replication group.</p>
        /// <p>
        /// <b>Important:</b> You can upgrade to a newer engine version (see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/SelectEngine.html#VersionManagement">Selecting a Cache Engine and Version</a>), but you cannot downgrade to an earlier engine version.
        /// If you want to use an earlier engine version,
        /// you must delete the existing replication group and create it anew with the earlier engine version. </p>
        pub fn engine_version(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.engine_version(input);
            self
        }
        pub fn set_engine_version(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_engine_version(input);
            self
        }
        /// <p>This parameter is currently disabled.</p>
        pub fn auto_minor_version_upgrade(mut self, input: bool) -> Self {
            self.inner = self.inner.auto_minor_version_upgrade(input);
            self
        }
        pub fn set_auto_minor_version_upgrade(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_auto_minor_version_upgrade(input);
            self
        }
        /// <p>The number of days for which ElastiCache retains automatic node group (shard) snapshots before
        /// deleting them. For example, if you set <code>SnapshotRetentionLimit</code> to 5, a
        /// snapshot that was taken today is retained for 5 days before being deleted.</p>
        /// <p>
        /// <b>Important</b> If the value of SnapshotRetentionLimit is set to zero (0),
        /// backups are turned off.</p>
        pub fn snapshot_retention_limit(mut self, input: i32) -> Self {
            self.inner = self.inner.snapshot_retention_limit(input);
            self
        }
        pub fn set_snapshot_retention_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_snapshot_retention_limit(input);
            self
        }
        /// <p>The daily time range (in UTC) during which ElastiCache  begins taking a daily snapshot of
        /// the node group (shard) specified by <code>SnapshottingClusterId</code>.</p>
        /// <p>Example: <code>05:00-09:00</code>
        /// </p>
        /// <p>If you do not specify this parameter, ElastiCache  automatically chooses an appropriate time range.</p>
        pub fn snapshot_window(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.snapshot_window(input);
            self
        }
        pub fn set_snapshot_window(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_snapshot_window(input);
            self
        }
        /// <p>A valid cache node type that you want to scale this replication group to.</p>
        pub fn cache_node_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_node_type(input);
            self
        }
        pub fn set_cache_node_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_node_type(input);
            self
        }
        /// <p>Reserved parameter. The password used to access a password protected server. This parameter must be specified with the <code>auth-token-update-strategy </code>
        /// parameter.
        /// Password constraints:</p>
        /// <ul>
        /// <li>
        /// <p>Must be only printable ASCII characters</p>
        /// </li>
        /// <li>
        /// <p>Must be at least 16 characters and no more than 128 characters in length</p>
        /// </li>
        /// <li>
        /// <p>Cannot contain any of the following characters: '/', '"', or '@', '%'</p>
        /// </li>
        /// </ul>
        /// <p>     
        /// For more information, see AUTH password at <a href="http://redis.io/commands/AUTH">AUTH</a>.</p>
        pub fn auth_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.auth_token(input);
            self
        }
        pub fn set_auth_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_auth_token(input);
            self
        }
        /// <p>Specifies the strategy to use to update the AUTH token. This parameter must be specified with the <code>auth-token</code> parameter.
        /// Possible values:</p>
        /// <ul>
        /// <li>
        /// <p>Rotate</p>
        /// </li>
        /// <li>
        /// <p>Set</p>
        /// </li>
        /// </ul>
        /// <p>
        /// For more information, see <a href="http://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/auth.html">Authenticating Users with Redis AUTH</a>
        /// </p>
        pub fn auth_token_update_strategy(
            mut self,
            input: crate::model::AuthTokenUpdateStrategyType,
        ) -> Self {
            self.inner = self.inner.auth_token_update_strategy(input);
            self
        }
        pub fn set_auth_token_update_strategy(
            mut self,
            input: std::option::Option<crate::model::AuthTokenUpdateStrategyType>,
        ) -> Self {
            self.inner = self.inner.set_auth_token_update_strategy(input);
            self
        }
        /// <p>The user group you are associating with the replication group.</p>
        pub fn user_group_ids_to_add(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.user_group_ids_to_add(inp);
            self
        }
        pub fn set_user_group_ids_to_add(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_user_group_ids_to_add(input);
            self
        }
        /// <p>The user group to remove, meaning the users in the group no longer can access the replication group.</p>
        pub fn user_group_ids_to_remove(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.user_group_ids_to_remove(inp);
            self
        }
        pub fn set_user_group_ids_to_remove(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_user_group_ids_to_remove(input);
            self
        }
        /// <p>Removes the user groups that can access this replication group.</p>
        pub fn remove_user_groups(mut self, input: bool) -> Self {
            self.inner = self.inner.remove_user_groups(input);
            self
        }
        pub fn set_remove_user_groups(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_remove_user_groups(input);
            self
        }
        /// <p>Specifies the destination, format and type of the logs.</p>
        pub fn log_delivery_configurations(
            mut self,
            inp: impl Into<crate::model::LogDeliveryConfigurationRequest>,
        ) -> Self {
            self.inner = self.inner.log_delivery_configurations(inp);
            self
        }
        pub fn set_log_delivery_configurations(
            mut self,
            input: std::option::Option<
                std::vec::Vec<crate::model::LogDeliveryConfigurationRequest>,
            >,
        ) -> Self {
            self.inner = self.inner.set_log_delivery_configurations(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct ModifyReplicationGroupShardConfiguration<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::modify_replication_group_shard_configuration_input::Builder,
    }
    impl<C> ModifyReplicationGroupShardConfiguration<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ModifyReplicationGroupShardConfigurationOutput,
            smithy_http::result::SdkError<
                crate::error::ModifyReplicationGroupShardConfigurationError,
            >,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the Redis (cluster mode enabled) cluster (replication group)
        /// on which the shards are to be configured.</p>
        pub fn replication_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_id(input);
            self
        }
        pub fn set_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_id(input);
            self
        }
        /// <p>The number of node groups (shards) that results from the modification of the
        /// shard configuration.</p>
        pub fn node_group_count(mut self, input: i32) -> Self {
            self.inner = self.inner.node_group_count(input);
            self
        }
        pub fn set_node_group_count(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_node_group_count(input);
            self
        }
        /// <p>Indicates that the shard reconfiguration process begins immediately.
        /// At present, the only permitted value for this parameter is <code>true</code>.</p>
        /// <p>Value: true</p>
        pub fn apply_immediately(mut self, input: bool) -> Self {
            self.inner = self.inner.apply_immediately(input);
            self
        }
        pub fn set_apply_immediately(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_apply_immediately(input);
            self
        }
        /// <p>Specifies the preferred availability zones for each node group in the cluster.
        /// If the value of <code>NodeGroupCount</code> is greater than the current number
        /// of node groups (shards), you can use this parameter to specify the preferred
        /// availability zones of the cluster's shards.
        /// If you omit this parameter ElastiCache selects availability zones for you.</p>
        /// <p>You can specify this parameter only if the value of <code>NodeGroupCount</code>
        /// is greater than the current number of node groups (shards).</p>
        pub fn resharding_configuration(
            mut self,
            inp: impl Into<crate::model::ReshardingConfiguration>,
        ) -> Self {
            self.inner = self.inner.resharding_configuration(inp);
            self
        }
        pub fn set_resharding_configuration(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ReshardingConfiguration>>,
        ) -> Self {
            self.inner = self.inner.set_resharding_configuration(input);
            self
        }
        /// <p>If the value of <code>NodeGroupCount</code> is less than the
        /// current number of node groups (shards), then either <code>NodeGroupsToRemove</code> or
        /// <code>NodeGroupsToRetain</code> is required.
        /// <code>NodeGroupsToRemove</code> is a list of <code>NodeGroupId</code>s to remove
        /// from the cluster.</p>
        /// <p>ElastiCache for Redis will attempt to remove all node groups listed by <code>NodeGroupsToRemove</code>
        /// from the cluster.</p>
        pub fn node_groups_to_remove(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.node_groups_to_remove(inp);
            self
        }
        pub fn set_node_groups_to_remove(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_node_groups_to_remove(input);
            self
        }
        /// <p>If the value of <code>NodeGroupCount</code> is less than the
        /// current number of node groups (shards), then either <code>NodeGroupsToRemove</code> or
        /// <code>NodeGroupsToRetain</code> is required.
        /// <code>NodeGroupsToRetain</code> is a list of <code>NodeGroupId</code>s to retain
        /// in the cluster.</p>
        /// <p>ElastiCache for Redis will attempt to remove all node groups except those listed by <code>NodeGroupsToRetain</code>
        /// from the cluster.</p>
        pub fn node_groups_to_retain(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.node_groups_to_retain(inp);
            self
        }
        pub fn set_node_groups_to_retain(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_node_groups_to_retain(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct ModifyUser<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::modify_user_input::Builder,
    }
    impl<C> ModifyUser<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ModifyUserOutput,
            smithy_http::result::SdkError<crate::error::ModifyUserError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The ID of the user.</p>
        pub fn user_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.user_id(input);
            self
        }
        pub fn set_user_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_user_id(input);
            self
        }
        /// <p>Access permissions string used for this user.</p>
        pub fn access_string(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.access_string(input);
            self
        }
        pub fn set_access_string(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_access_string(input);
            self
        }
        /// <p>Adds additional user permissions to the access string.</p>
        pub fn append_access_string(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.append_access_string(input);
            self
        }
        pub fn set_append_access_string(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_append_access_string(input);
            self
        }
        /// <p>The passwords belonging to the user. You are allowed up to two.</p>
        pub fn passwords(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.passwords(inp);
            self
        }
        pub fn set_passwords(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_passwords(input);
            self
        }
        /// <p>Indicates no password is required for the user.</p>
        pub fn no_password_required(mut self, input: bool) -> Self {
            self.inner = self.inner.no_password_required(input);
            self
        }
        pub fn set_no_password_required(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_no_password_required(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct ModifyUserGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::modify_user_group_input::Builder,
    }
    impl<C> ModifyUserGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ModifyUserGroupOutput,
            smithy_http::result::SdkError<crate::error::ModifyUserGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The ID of the user group.</p>
        pub fn user_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.user_group_id(input);
            self
        }
        pub fn set_user_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_user_group_id(input);
            self
        }
        /// <p>The list of user IDs to add to the user group.</p>
        pub fn user_ids_to_add(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.user_ids_to_add(inp);
            self
        }
        pub fn set_user_ids_to_add(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_user_ids_to_add(input);
            self
        }
        /// <p>The list of user IDs to remove from the user group.</p>
        pub fn user_ids_to_remove(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.user_ids_to_remove(inp);
            self
        }
        pub fn set_user_ids_to_remove(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_user_ids_to_remove(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PurchaseReservedCacheNodesOffering<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::purchase_reserved_cache_nodes_offering_input::Builder,
    }
    impl<C> PurchaseReservedCacheNodesOffering<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PurchaseReservedCacheNodesOfferingOutput,
            smithy_http::result::SdkError<crate::error::PurchaseReservedCacheNodesOfferingError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The ID of the reserved cache node offering to purchase.</p>
        /// <p>Example: <code>438012d3-4052-4cc7-b2e3-8d3372e0e706</code>
        /// </p>
        pub fn reserved_cache_nodes_offering_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.reserved_cache_nodes_offering_id(input);
            self
        }
        pub fn set_reserved_cache_nodes_offering_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_reserved_cache_nodes_offering_id(input);
            self
        }
        /// <p>A customer-specified identifier to track this reservation.</p>
        /// <note>
        /// <p>The Reserved Cache Node ID is an unique customer-specified identifier to track this reservation.
        /// If this parameter is not specified,
        /// ElastiCache automatically generates an identifier for the reservation.</p>
        /// </note>
        /// <p>Example: myreservationID</p>
        pub fn reserved_cache_node_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.reserved_cache_node_id(input);
            self
        }
        pub fn set_reserved_cache_node_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_reserved_cache_node_id(input);
            self
        }
        /// <p>The number of cache node instances to reserve.</p>
        /// <p>Default: <code>1</code>
        /// </p>
        pub fn cache_node_count(mut self, input: i32) -> Self {
            self.inner = self.inner.cache_node_count(input);
            self
        }
        pub fn set_cache_node_count(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_cache_node_count(input);
            self
        }
        /// <p>A list of tags to be added to this resource. A tag is a key-value pair. A tag key must be accompanied by a tag value, although null is accepted.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct RebalanceSlotsInGlobalReplicationGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::rebalance_slots_in_global_replication_group_input::Builder,
    }
    impl<C> RebalanceSlotsInGlobalReplicationGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::RebalanceSlotsInGlobalReplicationGroupOutput,
            smithy_http::result::SdkError<
                crate::error::RebalanceSlotsInGlobalReplicationGroupError,
            >,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the Global datastore</p>
        pub fn global_replication_group_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.global_replication_group_id(input);
            self
        }
        pub fn set_global_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_global_replication_group_id(input);
            self
        }
        /// <p>If <code>True</code>, redistribution is applied immediately.</p>
        pub fn apply_immediately(mut self, input: bool) -> Self {
            self.inner = self.inner.apply_immediately(input);
            self
        }
        pub fn set_apply_immediately(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_apply_immediately(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct RebootCacheCluster<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::reboot_cache_cluster_input::Builder,
    }
    impl<C> RebootCacheCluster<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::RebootCacheClusterOutput,
            smithy_http::result::SdkError<crate::error::RebootCacheClusterError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The cluster identifier. This parameter is stored as a lowercase string.</p>
        pub fn cache_cluster_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_cluster_id(input);
            self
        }
        pub fn set_cache_cluster_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_cluster_id(input);
            self
        }
        /// <p>A list of cache node IDs to reboot. A node ID is a numeric identifier (0001, 0002, etc.). To reboot an entire cluster, specify all of the cache node IDs.</p>
        pub fn cache_node_ids_to_reboot(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_node_ids_to_reboot(inp);
            self
        }
        pub fn set_cache_node_ids_to_reboot(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_cache_node_ids_to_reboot(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct RemoveTagsFromResource<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::remove_tags_from_resource_input::Builder,
    }
    impl<C> RemoveTagsFromResource<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::RemoveTagsFromResourceOutput,
            smithy_http::result::SdkError<crate::error::RemoveTagsFromResourceError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The Amazon Resource Name (ARN) of the resource from which you want the tags removed,
        /// for example <code>arn:aws:elasticache:us-west-2:0123456789:cluster:myCluster</code>
        /// or <code>arn:aws:elasticache:us-west-2:0123456789:snapshot:mySnapshot</code>.</p>
        /// <p>For more information about ARNs, see <a href="https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html">Amazon Resource Names (ARNs) and AWS Service Namespaces</a>.</p>
        pub fn resource_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_name(input);
            self
        }
        pub fn set_resource_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_resource_name(input);
            self
        }
        /// <p>A list of <code>TagKeys</code> identifying the tags you want removed from the named resource.</p>
        pub fn tag_keys(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.tag_keys(inp);
            self
        }
        pub fn set_tag_keys(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_tag_keys(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct ResetCacheParameterGroup<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::reset_cache_parameter_group_input::Builder,
    }
    impl<C> ResetCacheParameterGroup<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ResetCacheParameterGroupOutput,
            smithy_http::result::SdkError<crate::error::ResetCacheParameterGroupError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the cache parameter group to reset.</p>
        pub fn cache_parameter_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_parameter_group_name(input);
            self
        }
        pub fn set_cache_parameter_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_parameter_group_name(input);
            self
        }
        /// <p>If <code>true</code>,
        /// all parameters in the cache parameter group are reset to their default values.
        /// If <code>false</code>, only the parameters listed by <code>ParameterNameValues</code>
        /// are reset to their default values.</p>
        /// <p>Valid values: <code>true</code> | <code>false</code>
        /// </p>
        pub fn reset_all_parameters(mut self, input: bool) -> Self {
            self.inner = self.inner.reset_all_parameters(input);
            self
        }
        pub fn set_reset_all_parameters(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_reset_all_parameters(input);
            self
        }
        /// <p>An array of parameter names to reset to their default values.
        /// If <code>ResetAllParameters</code> is <code>true</code>,
        /// do not use <code>ParameterNameValues</code>.
        /// If <code>ResetAllParameters</code> is <code>false</code>,
        /// you must specify the name of at least one parameter to reset.</p>
        pub fn parameter_name_values(
            mut self,
            inp: impl Into<crate::model::ParameterNameValue>,
        ) -> Self {
            self.inner = self.inner.parameter_name_values(inp);
            self
        }
        pub fn set_parameter_name_values(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ParameterNameValue>>,
        ) -> Self {
            self.inner = self.inner.set_parameter_name_values(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct RevokeCacheSecurityGroupIngress<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::revoke_cache_security_group_ingress_input::Builder,
    }
    impl<C> RevokeCacheSecurityGroupIngress<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::RevokeCacheSecurityGroupIngressOutput,
            smithy_http::result::SdkError<crate::error::RevokeCacheSecurityGroupIngressError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the cache security group to revoke ingress from.</p>
        pub fn cache_security_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.cache_security_group_name(input);
            self
        }
        pub fn set_cache_security_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_cache_security_group_name(input);
            self
        }
        /// <p>The name of the Amazon EC2 security group to revoke access from.</p>
        pub fn ec2_security_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.ec2_security_group_name(input);
            self
        }
        pub fn set_ec2_security_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_ec2_security_group_name(input);
            self
        }
        /// <p>The AWS account number of the Amazon EC2 security group owner.
        /// Note that this is not the same thing as an AWS access key ID - you must provide
        /// a valid AWS account number for this parameter.</p>
        pub fn ec2_security_group_owner_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.ec2_security_group_owner_id(input);
            self
        }
        pub fn set_ec2_security_group_owner_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_ec2_security_group_owner_id(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct StartMigration<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::start_migration_input::Builder,
    }
    impl<C> StartMigration<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::StartMigrationOutput,
            smithy_http::result::SdkError<crate::error::StartMigrationError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The ID of the replication group to which data should be migrated.</p>
        pub fn replication_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_id(input);
            self
        }
        pub fn set_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_id(input);
            self
        }
        /// <p>List of endpoints from which data should be migrated. For Redis (cluster mode disabled), list should have only one element.</p>
        pub fn customer_node_endpoint_list(
            mut self,
            inp: impl Into<crate::model::CustomerNodeEndpoint>,
        ) -> Self {
            self.inner = self.inner.customer_node_endpoint_list(inp);
            self
        }
        pub fn set_customer_node_endpoint_list(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::CustomerNodeEndpoint>>,
        ) -> Self {
            self.inner = self.inner.set_customer_node_endpoint_list(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct TestFailover<C = aws_hyper::DynConnector> {
        handle: std::sync::Arc<super::Handle<C>>,
        inner: crate::input::test_failover_input::Builder,
    }
    impl<C> TestFailover<C> {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::TestFailoverOutput,
            smithy_http::result::SdkError<crate::error::TestFailoverError>,
        >
        where
            C: aws_hyper::SmithyConnector,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the replication group (console: cluster) whose automatic failover is being
        /// tested by this operation.</p>
        pub fn replication_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.replication_group_id(input);
            self
        }
        pub fn set_replication_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_replication_group_id(input);
            self
        }
        /// <p>The name of the node group (called shard in the console) in this replication group on
        /// which automatic failover is to be tested.
        /// You may test automatic failover on up to 5 node groups in any rolling 24-hour period.</p>
        pub fn node_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.node_group_id(input);
            self
        }
        pub fn set_node_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_node_group_id(input);
            self
        }
    }
}
